#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9 + 10;
vector<vector<pii>> g;
vector<pii> e;
vi answ, num;
vector<bool> curr;

void Solve(vi &l) {
    if (l.size() <= 1)
        return;
    vi dist(l.size(), INF);
    vector<vi> nl(l.size());
    queue<int> q;
    dist[0] = 0;
    q.push(0);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        nl[dist[u]].push_back(l[u]);
        for (auto to: g[l[u]]) {
            if (curr[to.first]) {
                if (dist[u] + 1 <= dist[num[to.first]]) {
                    if (e[to.second].first == l[u])
                        answ[to.second] = 0;
                    else
                        answ[to.second] = 1;
                    if (dist[u] + 1 < dist[num[to.first]]) {
                        dist[num[to.first]] = dist[u] + 1;
                        q.push(num[to.first]);
                    }
                }
            }
        }
    }
    for (auto u: l)
        curr[u] = false;
    sfor(i, 1, (int)l.size() - 1) {
        int j = 0;
        for (auto u: nl[i]) {
            curr[u] = true;
            num[u] = j;
            ++j;
        }
        Solve(nl[i]);
    }
}

string find_reverse(int n, int m, int connections[][2]) {
    g.resize(n);
    e.resize(m);
    answ.assign(m, -1);
    curr.assign(n, true);
    sfor(i, 0, m - 1) {
        e[i].first = connections[i][0];
        e[i].second = connections[i][1];
        --e[i].first;
        --e[i].second;
        g[e[i].first].emplace_back(e[i].second, i);
        g[e[i].second].emplace_back(e[i].first, i);
    }
    vi l(n);
    num.resize(n);
    sfor(i, 0, n - 1) l[i] = num[i] = i;
    Solve(l);
    string s;
    sfor(i, 0, m - 1) s.push_back('0' + answ[i]);
    return s;
}
