#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define pii pair<ll,ll>
using namespace std;
static const int MAXM = 1.5e6;
string find_reverse(int n, int m, int connections[MAXM][2]) {
	/*
	vector<int>vis(m, false);
	vector<pair<int,pii>>adj(m);
	vector<vector<int>>vec(n);
	for (int i = 0; i < m; i++) {
		adj[i].second.first = connections[i][0];
		adj[i].second.second = connections[i][1];
		adj[i].first = i;
	}
	for (int i = 0; i < m; i++) {
		vec[]
	}*/
	string ans(m,'0');
	for (int i = 0; i < m; i++) {
		if (connections[i][0] > connections[i][1])
			ans[i] = '1';
	}
	return ans;
}
/*
static int connections[MAXM][2];
int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> connections[i][0] >> connections[i][1];
	}
	string ans = find_reverse(n, m, connections);
	cout << ans;
	cout << endl;
}*/
/* tried nlogn
int main() {
	int n, m;
	cin >> n;
	vector<pii>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].first;
		a[i].second = i;
	}
	cin >> m;
	vector<pii>b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i].second;
	}
	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	int l1 = 1, l2 = 1, r1 = 1, r2 = 1;
	bool flag = false;
	ll sum1 = a[0].first, sum2 = b[0].first;
	while (!flag) {
		if (sum1 == sum2) {
			flag = true;
		}
		else if (sum1 < sum2 and r1!=(n-1)) {
			r1++;
			sum1 += a[r1].first;
		}
		else if(sum2 < sum1 and r2 != (m - 1)) {
			r2++;
			sum2 += b[r2].first;
		}
		else if (sum1 < sum2) {
			l2++;

		}
	}
}*/
/*n^2
int main() {
	int n, m;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cin >> m;
	vector<int>b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
	}
	vector<pii>a1(n), b1(m);
	for (int i = 0; i < n; i++) {
		a1[i].first = a[i]; a1[i].second = i;
	}
	for (int i = 0; i < m; i++) {
		b1[i].first = b[i]; b1[i].second = i;
	}
	sort(a1.begin(), a1.end());
	sort(b1.begin(), b1.end());
	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	vector<ll>pref1(n), pref2(m);
	pref1[0] = a[0];
	pref2[0] = b[0];
	for (int i = 1; i < n; i++) {
		pref1[i] = pref1[i - 1] + a[i];
	}
	for (int i = 1; i < m; i++) {
		pref2[i] = pref2[i - 1] + b[i];
	}
	vector<pair<ll, pii>>sums1, sums2;
	for (int i = 0; i < n; i++) {
		sums1.push_back({ pref1[i],{0,i} });
	}
	for (int i = 0; i < m; i++) {
		sums2.push_back({ pref2[i],{0,i} });
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			sums1.push_back({ pref1[j] - pref1[i],{i + 1,j} });
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = i + 1; j < m; j++) {
			sums2.push_back({ pref2[j] - pref2[i],{i + 1,j} });
		}
	}
	vector<int>hisn(n*m+1, 0);
	vector<int>hism(n*m+1, 0);
	for (int i = 0; i < sums1.size(); i++) {
		hisn[sums1[i].first]++;
	}
	for (int i = 0; i < sums2.size(); i++) {
		hism[sums2[i].first]++;
	}
	int flags = -1;
	for (int i = 0; i <= n*m; i++) {
		if (hisn[i] != 0 and hism[i] != 0) {
			flags = i;
			break;
		}
	}
	if (flags != -1) {
		int ans1, ans2;
		for (int i = 0; i < sums1.size(); i++) {
			if (sums1[i].first == flags) {
				ans1 = i;
				break;
			}
		}
		for (int i = 0; i < sums1.size(); i++) {
			if (sums2[i].first == flags) {
				ans2 = i;
				break;
			}
		}
		cout << sums1[ans1].second.second - sums1[ans1].second.first + 1 << endl;
		for (int h = sums1[ans1].second.first; h <= sums1[ans1].second.second; h++) {
			cout << a1[h].second << " ";
		}
		cout << endl;
		cout << sums2[ans2].second.second - sums2[ans2].second.first + 1 << endl;
		for (int h = sums2[ans2].second.first; h <= sums2[ans2].second.second; h++) {
			cout << b1[h].second << " ";
		}
		cout << endl;
	}
}*/
/* n^4
int main() {
	int n,m;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cin >> m;
	vector<int>b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
	}
	vector<int>his1(m + 1, 0);
	vector<int>his2(n + 1, 0);
	for (int i = 0; i < n; i++) {
		his1[a[i]]++;
	}
	for (int i = 0; i < m; i++) {
		his2[b[i]]++;
	}
	int flag = -1;
	for (int i = 0; i <= min(n,m); i++) {
		if (his1[i] != 0 and his2[i] != 0) {
			flag = i;
			break;
		}
	}
	if (flag != -1) {
		int ans1, ans2;
		for (int i = 0; i < n; i++) {
			if (a[i] == flag) {
				ans1 = i;
			}
		}
		for (int i = 0; i < m; i++) {
			if (b[i] == flag) {
				ans2 = i;
			}
		}
		cout << 1 << endl << ans1 << endl << 1 << endl << ans2;
	}
	else {
		vector<pii>a1(n), b1(m);
		for (int i = 0; i < n; i++) {
			a1[i].first = a[i]; a1[i].second = i;
		}
		for (int i = 0; i < m; i++) {
			b1[i].first = b[i]; b1[i].second = i;
		}
		sort(a1.begin(), a1.end());
		sort(b1.begin(), b1.end());
		sort(a.begin(), a.end());
		sort(b.begin(), b.end());
		vector<ll>pref1(n), pref2(m);
		pref1[0] = a[0];
		pref2[0] = b[0];
		for (int i = 1; i < n; i++) {
			pref1[i] = pref1[i - 1] + a[i];
		}
		for (int i = 1; i < m; i++) {
			pref2[i] = pref2[i - 1] + b[i];
		}
		vector<pair<ll,pii>>sums1, sums2;
		for (int i =0; i < n; i++) {
			sums1.push_back({ pref1[i],{0,i} });
		}
		for (int i = 0; i < m; i++) {
			sums2.push_back({ pref2[i],{0,i} });
		}
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				sums1.push_back({ pref1[j] - pref1[i],{i+1,j} });
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				sums2.push_back({ pref2[j] - pref2[i],{i+1,j} });
			}
		}
		bool flag1 = false;
		for (int i = 0; i < sums1.size(); i++) {
			for (int j = 0; j < sums2.size(); j++) {
				if (sums1[i].first == sums2[j].first) {
					cout << sums1[i].second.second - sums1[i].second.first + 1 << endl;
					for (int h = sums1[i].second.first; h <= sums1[i].second.second; h++) {
						cout << a1[h].second << " ";
					}
					cout << endl;
					cout << sums2[j].second.second - sums2[j].second.first + 1 << endl;
					for (int h = sums2[j].second.first; h <= sums2[j].second.second; h++) {
						cout << b1[h].second << " ";
					}
					cout << endl;
					flag1 = true;
					break;
				}
			}
			if (flag1)
				break;
		}
	}
}*/