#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define pii pair<ll,ll>
using namespace std;
int main() {
	int n,m;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cin >> m;
	vector<int>b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
	}
	vector<int>his1(m + 1, 0);
	vector<int>his2(n + 1, 0);
	for (int i = 0; i < n; i++) {
		his1[a[i]]++;
	}
	for (int i = 0; i < m; i++) {
		his2[b[i]]++;
	}
	int flag = -1;
	for (int i = 0; i <= min(n,m); i++) {
		if (his1[i] != 0 and his2[i] != 0) {
			flag = i;
			break;
		}
	}
	if (flag != -1) {
		int ans1, ans2;
		for (int i = 0; i < n; i++) {
			if (a[i] == flag) {
				ans1 = i;
			}
		}
		for (int i = 0; i < m; i++) {
			if (b[i] == flag) {
				ans2 = i;
			}
		}
		cout << 1 << endl << ans1 << endl << 1 << endl << ans2;
	}
	else {
		vector<pii>a1(n), b1(m);
		for (int i = 0; i < n; i++) {
			a1[i].first = a[i]; a1[i].second = i;
		}
		for (int i = 0; i < m; i++) {
			b1[i].first = b[i]; b1[i].second = i;
		}
		sort(a1.begin(), a1.end());
		sort(b1.begin(), b1.end());
		sort(a.begin(), a.end());
		sort(b.begin(), b.end());
		vector<ll>pref1(n), pref2(m);
		pref1[0] = a[0];
		pref2[0] = b[0];
		for (int i = 1; i < n; i++) {
			pref1[i] = pref1[i - 1] + a[i];
		}
		for (int i = 1; i < m; i++) {
			pref2[i] = pref2[i - 1] + b[i];
		}
		vector<pair<ll,pii>>sums1, sums2;
		for (int i =0; i < n; i++) {
			sums1.push_back({ pref1[i],{0,i} });
		}
		for (int i = 0; i < m; i++) {
			sums2.push_back({ pref2[i],{0,i} });
		}
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				sums1.push_back({ pref1[j] - pref1[i],{i+1,j} });
			}
		}
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				sums2.push_back({ pref2[j] - pref2[i],{i+1,j} });
			}
		}
		bool flag1 = false;
		for (int i = 0; i < sums1.size(); i++) {
			for (int j = 0; j < sums2.size(); j++) {
				if (sums1[i].first == sums2[j].first) {
					cout << sums1[i].second.second - sums1[i].second.first + 1 << endl;
					for (int h = sums1[i].second.first; h <= sums1[i].second.second; h++) {
						cout << a1[h].second << " ";
					}
					cout << endl;
					cout << sums2[j].second.second - sums2[j].second.first + 1 << endl;
					for (int h = sums2[j].second.first; h <= sums2[j].second.second; h++) {
						cout << b1[h].second << " ";
					}
					cout << endl;
					flag1 = true;
					break;
				}
			}
			if (flag1)
				break;
		}
	}
}