#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define mp make_pair
#define pb push_back

#pragma GCC optimize "Ofast"
#pragma GCC optimize "unroll-loops"

const int N = (int)5e5 + 111;
const int M = (int)15e5 + 111;

struct edge{
    int id,to;
    bool rev = false;
    edge(){}
};

bool operator == (const edge& a,const edge& b){
    return a.id == b.id;
}

bool operator <(const edge& a, const edge& b){
    return a.id < b.id;
}

set<edge> g[N];
bool usedV[N];
bool usedE[M];
bool reversed[M];
int cnt[N];

void bfs(int v){
    set<int> q;
    q.insert(v);
    while(!q.empty()){
        int v = *q.begin();
        q.erase(q.begin());
        usedV[v] = 1;
//        cerr << v << "\n";
        while(!g[v].empty()){
            edge x = *g[v].begin();
            g[v].erase(g[v].begin());
            int id = x.id;
            int to = x.to;
            int rev = x.rev;
            usedE[id] = true;
            reversed[id] = x.rev;
            g[id].erase(x);
            if(!usedV[to])
                q.insert(to);
        }
    }
    return;
}

string find_reverse(int n,int m,int connections[][2]){

    for(int i = 0; i < m; i++){
        int a,b;
        a = connections[i][0], b = connections[i][1];
        edge e;
        e.id = i;
        e.to = b;
        e.rev = false;
        g[a].insert(e);
        e.to = a;
        e.rev = true;
        g[b].insert(e);
        cnt[a]++;
        cnt[b]++;
    }

    set<int> q;
    for(int i = 1; i <= n; i++){
        if(!usedV[i]){
            bfs(i);
        }
    }

    string ans = "";

    for(int i = 0; i < m; i++){
        ans += (char)(reversed[i] + '0');
    }

    return ans;
}
