#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define mp make_pair
#define pb push_back
const int N = (int)5e5 + 111;
const int M = (int)15e5 + 111;
struct edge{
    int id,to;
    bool rev = false;
    edge(){}
};
bool operator == (const edge& a,const edge& b){
    return a.id == b.id;
}
bool operator <(const edge& a, const edge& b){
    return a.id < b.id;
}

set<edge> g[N];
bool usedV[N];
bool usedE[M];
bool reversed[M];
int cnt[N];
void dfs(int v){
    if(usedV[v])
        return;
    usedV[v] = true;
    for(auto& x : g[v]){
        int id = x.id;
        if(!usedE[id]){
            usedE[id] = true;
            edge e;
            e.to = v;
            e.id = id;
            e.rev = x.rev ^ 1;
            g[x.to].erase(e);
            reversed[id] = x.rev;
        }
    }
    for(auto& x : g[v]){
        if(!usedV[x.to])
            dfs(x.to);
    }
    return;
}
string find_reverse(int n,int m,int connections[][2]){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    for(int i = 0; i < m; i++){
        int a,b;
        a = connections[i][0], b = connections[i][1];
        edge e;
        e.id = i;
        e.to = b;
        e.rev = false;
        g[a].insert(e);
        e.to = a;
        e.rev = true;
        g[b].insert(e);
        cnt[a]++;
        cnt[b]++;
    }
    for(int i = 1; i <= n; i++){
        if(!usedV[i]){
            dfs(i);
        }
    }
    string ans = "";
    for(int i = 0; i < m; i++){
        ans += (char)(reversed[i] + '0');
    }
    return ans;
}
