#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define mp make_pair
#define pb push_back
const int N = (int)5e5 + 111;
const int M = (int)15e5 + 111;
struct edge{
    int id,to;
    bool rev = false;
    edge(){}
};

vector<int> g[N];
int A[M],B[M];
bitset<N> usedV;
bitset<M> usedE;
string reversed;
int cnt[N];
void dfs(int v){
    if(usedV[v])
        return;
//    cerr << v << "\n";
    usedV[v] = true;
    for(auto& x : g[v]){
        int id = x >> 1;
        bool rev = x & 1;
        if(!usedE[id]){
            usedE[id] = true;
            reversed[id] = (rev + '0');
        }
    }
    for(auto& x : g[v]){
        int to = ((x & 1) ? A[x>>1] : B[x>>1]);
//        cerr << v << " " << to << "\n";
        if(!usedV[to])
            dfs(to);
    }
    return;
}
string find_reverse(int n,int m,int connections[][2]){
    for(int i = 0; i < m; i++){
        int a,b;
        a = connections[i][0], b = connections[i][1];
        A[i] = a, B[i] = b;
        g[a].pb(i<<1);
        g[b].pb(i<<1|1);
        cnt[a]++;
        cnt[b]++;
        reversed.pb('0');
    }
    for(int i = 1; i <= n; i++){
        if(!usedV[i]){
            dfs(i);
        }
    }
    return reversed;
}
