#include <bits/stdc++.h>

using namespace std;

#define int long long
#define mp make_pair
#define pb push_back

vector<int> dp[2];
const int N = (int)1e4 + 11;

mt19937 rnd(time(nullptr));

int rnnnnd(int l,int r){
    return rnd() % (r - l + 1) + l;
}

void solve(){
    int n,m;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    cin >> m;
    int b[m];
    for(int i = 0; i < m; i++){
        cin >> b[i];
    }

    if(n * m <= (int)1e6){
        dp[0].resize(n*m+1);
        dp[1].resize(n*m+1);
        dp[0].assign(n*m+1,-2);
        dp[1].assign(n*m+1,-2);
        dp[0][0] = -1;
        dp[1][0] = -1;
        int mxSum = 0;
        for(int i = 0; i < n; i++){
            for(int j = min(mxSum+a[i],n*m); j - a[i] >= 0; j--){
                if(dp[0][j] != -2)
                    continue;
                if(dp[0][j-a[i]] != -2)
                    dp[0][j] = i, mxSum = max(mxSum,j);
            }
        }
        mxSum = 0;
        for(int i = 0; i < m; i++){
            for(int j = min(mxSum+b[i],n*m); j - b[i] >= 0; j--){
                if(dp[1][j] != -2)
                    continue;
                if(dp[1][j-b[i]] != -2){
                    dp[1][j] = i, mxSum = max(mxSum,j);
                    if(dp[0][j] != -2){
                        int y = j;
    //                    cerr << "sum = " << y << "\n";
                        vector<int> id;
                        while(y > 0){
                            id.pb(dp[0][y]);
                            y = y - a[dp[0][y]];
                        }
                        cout << id.size() << "\n";
                        for(auto& x : id)
                            cout << x << " ";
                        cout << "\n";
                        y = j;
                        id.clear();
                        while(y > 0){
                            id.pb(dp[1][y]);
                            y = y - b[dp[1][y]];
                        }
                        cout << id.size() << "\n";
                        for(auto& x : id)
                            cout << x << " ";
                        cout << "\n";
                        return;
                    }
                }
            }
        }
        return;
    }

    vector<pair<int,int>> v[2];
    v[0].pb(mp(0,-1));
    v[1].pb(mp(0,-1));
    for(int i = 0; i < n; i++){
        v[0].pb(mp(a[i],i));
    }

    for(int i = 0; i < m; i++){
        v[1].pb(mp(b[i],i));
    }

    sort(v[0].begin(),v[0].end());
    sort(v[1].begin(),v[1].end());

    int pref[2][max(n,m)+1];

    pref[0][0] = pref[1][0] = 0;

    for(int i = 1; i <= n; i++){
        pref[0][i] = pref[0][i-1] + v[0][i].first;
    }
    for(int i = 1; i <= m; i++){
        pref[1][i] = pref[1][i-1] + v[1][i].first;
    }

    int tries = (int)2e6;
    while(tries--){
        int l[2],r[2];
        l[0] = rnnnnd(1,n);
        r[0] = rnnnnd(l[0],n);

        l[1] = rnnnnd(1,m);
        r[1] = rnnnnd(l[1],m);

        if(pref[0][r[0]] - pref[0][l[0]-1] != pref[1][r[1]] - pref[1][l[1]-1])
            continue;
        cout << r[0] - l[0] + 1 << "\n";
        for(int i = l[0]; i <= r[0]; i++){
            cout << v[0][i].second << " ";
        }
        cout << "\n";
        cout << r[1] - l[1] + 1 << "\n";
        for(int i = l[1]; i <= r[1]; i++){
            cout << v[0][i].second << " ";
        }
        cout << "\n";
        return;
    }

//    vector<pair<int,int>> v[2];
//
//    for(int i = 0; i < n; i++){
//        cin >> v[0][i].first;
//        v[0][i].second = i;
//    }
//
//    for(int i = 0; i < m; i++){
//        cin >> v[1][i].first;
//        v[1][i].second = i;
//    }

//    sort(v[0].begin(),v[0].end());
//    sort(v[1].begin(),v[1].end());
//
//    int sum[2] = {0,0};
//    int l[2],r[2];
//
//    l = {0,0};
//    r = {-1,-1};
//
//    set<int> ids[2];
//
//    while(l[0] < n && l[1] < m){
//        if(sum[0] == sum[1] && sum[0] != 0){
//            cout << ids[0].size() << "\n";
//            for(auto& x : ids[0])
//                cout << x << " ";
//            cout << "\n";
//            cout << ids[1].size() << "\n";
//            for(auto& x : ids[1])
//                cout << x << " ";
//            cout << "\n";
//            return;
//        }
//        if(sum[1] > sum[0])
//    }

    return;
}

signed main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

    int tests = 1;
//    cin >> tests;

    for(int _ = 1; _ <= tests; _++){
        solve();
    }

    return 0;
}
