#include <iostream>
#include <vector>
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

using namespace std;

const int NMAX = 5e5 + 2;
const int MMAX = 1500000;
bool viz[NMAX + 2];
vector <int> v[NMAX + 2];
int depth[NMAX + 2];
int connections[MMAX + 2][2];
int sizes[NMAX + 2];
int h[NMAX + 2];

void dfs( int node ){
  viz[node] = 1;
  int i;
  for( i = 0; i < sizes[node]; ++i ) {
    if( !viz[v[node][i]] ) {
      depth[v[node][i]] = depth[node] + 1;
      dfs(v[node][i]);
    }
  }
}

string find_reverse (int n, int m, int connections[][2]) {
  int i;
  string s;


  depth[1] = 1;

  for( i = 0; i < m; ++i ) {
    ++sizes[connections[i][0]];
    ++sizes[connections[i][1]];
  }

  for( i = 1; i <= n; ++i )
    v[i].resize(sizes[i]);

  for( i = 0; i < m; ++i ) {
    v[connections[i][0]][h[connections[i][0]]++] = connections[i][1];
    v[connections[i][1]][h[connections[i][1]]++] = connections[i][0];
  }

  dfs(1);

  s = "";
  for( i = 0; i < m; ++i )
    if( depth[connections[i][0]] < depth[connections[i][1]] )
      s += '0';
    else
      s += '1';
  return s;
}