#include <iostream>
#include <vector>
#include <string>
#include <climits>

#define ll long long
#define ld long double
#define point pair<int,int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define c connections

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 500000;
const int INF = INT_MAX;
const int LOG = 31;

vector<point> g[N];
int used[N], ans[N];

void dfs(int v) {
    used[v] = 2;
    for (auto to : g[v]) {
        if (used[to.ff] == 2)
            ans[to.ss] = 1;
        if (!used[to.ff])
            dfs(to.ff);
    }
    used[v] = 1;
}

string find_reverse(int n, int m, int connections[][2]) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    for (int i = 0; i < m; ++i)
        g[c[i][0]].push_back(make_pair(c[i][1], i)), ans[i] = 0;

    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);

//    string s = "";
//    for (int i = 0; i < m; ++i)
//        s += ans[i] + '0';
    string s; s.resize(m);
    for (int i = 0; i < m; ++i)
        s[i] = ans[i] + '0';
    return s;
}

//come on people, 0.15 secs??? on a task with constraints 1.5kk?
//that was rude.

//signed main() {
//    int n, m;
//    cin >> n >> m;
//    int connections[m][2];
//    for (int i = 0; i < m; ++i)
//        cin >> c[i][0] >> c[i][1];
//
//    cout << find_reverse(n, m, c);
//}
