#include <iostream>
#include <queue>
#include <stack>
#include <vector>
#include <algorithm>
#include <list>
#include <map>
using namespace std;
string find_reverse(int n,int m, int [][2])
{
    class Graph
    {
        map<int, vector <int> > adjlist;
        map <int,bool> vis;
        list <int> order;
    public:
        Graph(){}
        void addedge(int u,int v)
        {
            adjlist[u].push_back(v);
        }
        void dfshelper(int u)
        {
            vis[u]=true;
            for(auto i:adjlist[u])
            {
                if(!vis[i])
                    dfshelper(i);
            }
            order.push_front(u);
        }
        list <int> topological()
        {
            for(auto i:adjlist)
            {
                int node =i.first;
                if(!vis[node])
                {
                    dfshelper(node);
                }
            }
            return order;
        }
    };
    Graph g;
    int t1,t2;
    pair<int,int> edges[m];
    for(int i=0;i<m;i++)
    {
        cin>>t1>>t2;
        edges[i]={t1-1,t2-1};
        g.addedge(t1-1,t2-1);
    }
    list <int> l =g.topological();
    pair<int,int> edge;
    int first,second;
    string s="";
    for(int i=0;i<m;i++)
    {
        first=0;
        second=0;
        edge=edges[i];
        for(auto ele: l)
        {
            if(ele==edge.first)
            {
                first=1;
                break;
            }
            if(ele==edge.second)
            {
                second=1;
                break;
            }
        }
        if(first==1)
            s+="1";
        else
            s+="0";
    }
    return s;
}