#include <cstring>
#include <iostream>

using namespace std;

const int mxN = 2e4+5;

int a[mxN][mxN];
bool viz[mxN];
string ans;

void dfs(int x, int n, int m) {
	viz[x] = 1;
	for (int i = 1; i <= n; i++)
		if (a[x][i]) {
			if (viz[i]) {
				ans[a[x][i] - 1] = '1';
				a[x][i] = 0;
				a[i][x] = -1;
				break;
			}
			else
				dfs(i, n, m);
		}
	for (int i = 1; i <= n; i++)
		if (a[x][i])
			viz[i] = 0;
}

string find_reverse(int n, int m, int connections[][2]) {
	ans.resize(m);
	for (int i = 0; i < m; i++)
		a[connections[i][0]][connections[i][1]] = i+1;

	dfs(1, n, m);
	for (int i = 0; i < ans.size(); i++)
		if (ans[i] != '1')
			ans[i] = '0';

	return ans;
}
