#include <cstring>
#include <iostream>

using namespace std;

const int mxN = 1e3+5;

int a[mxN][mxN];
bool viz[mxN];
string ans;
bool ok;

void dfs(int x, int n, int m, int k0, int k1) {
	if (x == k0 && a[k1][k0] > 0) {
		ans[a[k1][k0]-1] = '1';
		a[k0][k1] = -1;
		a[k1][k0] = 0;
		ok = 0;
	}
	if (!ok || viz[x])
		return;
	viz[x] = 1;
	for (int i = 1; i <= n; i++)
		if (a[i][x])
			dfs(i, n, m, k0 != 0 ? k0 : x, k1 != 0 ? k1 : i);
}

string find_reverse(int n, int m, int connections[][2]) {
	ans.resize(m);
	for (int i = 0; i < m; i++)
		a[connections[i][0]][connections[i][1]] = i+1;

	for (int i = 0; i < ans.size(); i++)
		ans[i] = '0';
	for (int i = 1; i <= n; i++) {
		ok = 1;
		dfs(i, n, m, 0, 0);
		for (int j = 1; j <= n; j++)
			viz[j] = 0;
	}

	return ans;
}

