#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <fstream>
#include <iomanip>
#include <functional>


using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;
using vvll = vector<vll>;
using vld = vector<ld>;
using vvld = vector<vld>;
using vstr = vector<string>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

void print(ll n, ll m, vvll& arr)
{
	for (ll i = 0; i < n; i++)
	{
		for (ll j = 0; j < m; j++)
		{
			cout << arr[i][j] << " ";
		}
		cout << endl;
	}
}

int main()
{
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	vvll arr(n, vll(m, 0));
	ll q;
	cin >> q;
	for (ll iq = 0; iq < q; iq++)
	{
		ll x;
		cin >> x;
		ll y; 
		cin >> y;
		ll iy = y;
		for (ll ix = x - 1; (ix >= 0) && (iy < m) && (arr[ix][iy] != 1) && (arr[ix][iy] != 3); ix--)
		{
			if (arr[ix][iy] == 2)
			{
				arr[ix][iy] = 3;
				break;
			}
			arr[ix][iy] = 1;
			iy++;
		}
		iy = y;
		for (ll ix = x; (ix < n) && (iy < m) && (arr[ix][iy] != 2) && (arr[ix][iy] != 3); ix++)
		{
			if (arr[ix][iy] == 1)
			{
				arr[ix][iy] = 3;
				break;
			}
			arr[ix][iy] = 2;
			iy++;
		}
		double ans = 0;
		//print(n, m, arr);
		for (ll i = 0; i < n; i++)
		{
			for (ll j = 0; j < m; j++)
			{
				if ((arr[i][j] == 1) || (arr[i][j] == 2))
				{
					ans += 0.5;
					break;
				}
				else if (arr[i][j] == 3)
				{
					ans += 0.25;
					break;
				}
				else
				{
					ans += 1;
				}
			}
		}
		cout << fixed << setprecision(2) << ans << endl;
	}
}
