#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <fstream>
#include <iomanip>
#include <functional>


using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;
using vvll = vector<vll>;
using vld = vector<ld>;
using vvld = vector<vld>;
using vstr = vector<string>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

void print(ll n, ll m, vvll& arr)
{
	for (ll i = 0; i < n; i++)
	{
		for (ll j = 0; j < m; j++)
		{
			cout << arr[i][j] << " ";
		}
		cout << endl;
	}
}

void print2(ll n, ll m, vll& arr1, vll& arr2, vll& arr3)
{
	for (ll i = 0; i < n; i++)
	{
		cout << arr1[i] << "    " << arr2[i] << "      " << arr3[i] << endl;
	}
}

int main()
{
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	//vvll arr(n, vll(m, 0));
	vll arr1(n, m);
	vll arr2(n, m);
	vll arr3(n, m);
	ll q;
	cin >> q;
	for (ll iq = 0; iq < q; iq++)
	{
		ll x;
		cin >> x;
		ll y;
		cin >> y;
		ll iy = y;
		for (ll ix = x - 1; (ix >= 0) && (iy < m); ix--)
		{
			if ((arr1[ix] <= iy) || (arr2[ix] < iy) || (arr3[ix] <= iy))
				break;
			if (arr1[ix] > iy) {
				arr1[ix] = iy;
			}
			if (arr2[ix] == iy) {
				arr3[ix] = iy;
			}
			iy++;
		}
		iy = y;
		for (ll ix = x; (ix < n) && (iy < m); ix++)
		{
			if ((arr1[ix] < iy) || (arr2[ix] <= iy) || (arr3[ix] <= iy))
				break;
			if (arr2[ix] > iy) {
				arr2[ix] = iy;
			}
			if (arr1[ix] == iy) {
				arr3[ix] = iy;
			}
			iy++;
		}
		double ans = 0;
		//print2(n, m, arr1, arr2, arr3);
		for (ll i = 0; i < n; i++)
		{
			if ((arr1[i] == m) && (arr2[i] == m) && (arr3[i] == m))
			{
				ans += m;
			}
			else if ((arr3[i] <= arr1[i]) && (arr3[i] <= arr2[i]))
			{
				ans += 0.25 + arr3[i];
			}
			else if (arr1[i] < arr2[i])
			{
				ans += 0.5 + arr1[i];
			}
			else
			{
				ans += 0.5 + arr2[i];
			}
		}
		cout << fixed << setprecision(2) << ans << endl;
	}
}
