#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <fstream>
#include <iomanip>
#include <functional>


using namespace std;

using ll = long long;
using ld = long double;
using vll = vector<ll>;
using vvll = vector<vll>;
using vld = vector<ld>;
using vvld = vector<vld>;
using vstr = vector<string>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;



int main()
{
	ll n;
	cin >> n;
	vll arrn(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> arrn[i];
	}
	ll m;
	cin >> m;
	vll arrm(m);
	for (ll i = 0; i < m; i++)
	{
		cin >> arrm[i];
	}
	vll sums(n * m, 0);
	for (ll i = 1; i < ((ll)1) << n; i++)
	{
		ll sum = 0;
		for (ll j = 0; j < n; j++)
		{
			if (((i >> j) & 1) == 1)
			{
				sum += arrn[j];
			}
		}
		sums[sum] = 1;
	}
/*	for (ll i = 0; i < n * m; i++)
	{
		cout << "i:   " << i << " sums: " << sums[i] << endl;
	}*/
	for (ll i = 1; i < ((ll)1) << m; i++)
	{
		ll sum = 0;
		ll num = 0;
		for (ll j = 0; j < m; j++)
		{
			if (((i >> j) & 1) == 1)
			{
				sum += arrm[j];
				num++;
			}
		}
		if (sums[sum] == 1)
		{
			for (ll i2 = 1; i2 < ((ll)1) << n; i2++)
			{
				ll sum2 = 0;
				ll num2 = 0;
				for (ll j2 = 0; j2 < n; j2++)
				{
					if (((i2 >> j2) & 1) == 1)
					{
						sum2 += arrn[j2];
						num2++;
					}
				}
				if (sum2 == sum) {
					cout << num2 << endl;
					for (ll j2 = 0; j2 < n; j2++)
					{
						if (((i2 >> j2) & 1) == 1)
						{
							cout << j2 << " ";
						}
					}
					cout << endl;
					break;
				}
			}

			cout << num << endl;
			for (ll j = 0; j < m; j++)
			{
				if (((i >> j) & 1) == 1)
				{
					cout << j << " ";
				}
			}
			cout << endl;
			return 0;
		}
	}
}