#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

const int N = 20 * 1e5;
vector<int> g[N];
int color[N];
int num = 1;

string find_reverse(int n, int m, int connections[][2]) {
	for (int i = 0; i < m; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		g[x].push_back(y);
		g[y].push_back(x);
	}
	map<int, bool> mp;
	for (int i = 1; i <= n; i++) {
		if (!color[i]) {
			mp[i] = true;
			color[i] = num;
			for (auto j : g[i]) {
				color[j] = num;
			}
			num++;
		}
	}
	string s = "";
	for (int i = 0; i < m; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		if (mp[x]) {
			s += '1';
		}
		else {
			s += '0';
		}
	}
	return s;
}
