#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

const int N = 20 * 1e5;
vector<int> g[N];
bool color[N];
int num = 1;
map<pair<int, int>, bool> mp1;

void dfs(int u) {
	for (int i = 0; i < g[u].size(); i++) {
		int v = g[u][i];
		if (!color[v]) {
			mp1[{u, v}] = true;
			color[v] = true;
			dfs(v);
		}
	}
}

string find_reverse(int n, int m, int connections[][2]) {
	for (int i = 0; i < m; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		g[x].push_back(y);
		g[y].push_back(x);
	}
	color[1] = true;
	dfs(1);
	string s = "";
	for (int i = 0; i < m; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		if (mp1[{x, y}]) {
			s += '0';
		}
		else {
			s += '1';
		}
	}
	return s;
}