#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define ll long long
#define pb push_back

const int N = 10000005;
bool dp1[N], dp2[N];
ll from1[N], from2[N];
ll pref1[N], pref2[N];
int a[N], b[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	ll sum1 = 0, sum2 = 0;
	map<ll, int> mp;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum1 += a[i];
		mp[sum1] = i + 1;
		pref1[i] = sum1;
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		sum2 += b[i];
		pref2[i] = sum2;
	}
	for (int i = 0; i < m; i++) {
		if (mp[pref2[i]]) {
			int ind1 = mp[pref1[i]];
			cout << ind1 << endl;
			for (int j = 0; j < ind1; j++) {
				cout << j << ' ';
			}
			cout << endl;
			cout << i + 1 << endl;
			for (int j = 0; j <= i; j++) {
				cout << j << ' ';
			}
			cout << endl;
			return 0;
		}
	}
	for (int i = 0; i < n; i++) {
		for (ll j = sum1 - a[i]; j > 0; j--) {
			if (dp1[j] && !dp1[j + a[i]]) {
				dp1[j + a[i]] = true;
				from1[j + a[i]] = i;
			}
		}
		if (!dp1[a[i]]) {
			dp1[a[i]] = true;
			from1[a[i]] = i;
		}
	}
	for (int i = 0; i < m; i++) {
		for (ll j = sum2 - b[i]; j > 0; j--) {
			if (dp2[j] && !dp2[j + b[i]]) {
				dp2[j + b[i]] = true;
				from2[j + b[i]] = i;
			}
		}
		if (!dp2[b[i]]) {
			dp2[b[i]] = true;
			from2[b[i]] = i;
		}
	}
	ll sum = -1;
	for (int i = 1; i <= max(sum1, sum2); i++) {
		if (dp1[i] && dp2[i]) {
			sum = i;
			break;
		}
	}
	vector<int> ans1;
	vector<int> ans2;
	ll sum0 = sum;
	while (sum != 0) {
		int ind = from1[sum];
		ans1.push_back(ind);
		sum -= a[ind];
	}
	sum = sum0;
	while (sum != 0) {
		int ind = from2[sum];
		ans2.push_back(ind);
		sum -= b[ind];
	}
	reverse(ans1.begin(), ans1.end());
	reverse(ans2.begin(), ans2.end());
	cout << ans1.size() << endl;
	for(auto i : ans1){
		cout << i << ' ';
	}
	cout << endl;
	cout << ans2.size() << endl;
	for (auto i : ans2) {
		cout << i << ' ';
	}
	cout << endl;
	return 0;
}