#include <iostream>
#include <vector>

using namespace std;

int main() {
    long long n, m, sum1 = 0, sum2 = 0;
    cin >> n;
    long long arr[n];
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        sum1 += arr[i];
    }
    cin >> m;
    long long arr1[m];
    for (int i = 0; i < m; ++i) {
        cin >> arr1[i];
        sum2 += arr1[i];
    }
    sum1++;
    sum2++;
    long long dp1[n][sum1];
    long long dp2[m][sum2];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < sum1; ++j) {
            dp1[i][j] = 0;
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < sum2; ++j) {
            dp2[i][j] = 0;
        }
    }
    for (int i = 0; i < sum1; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j == 0) {
                if (i >= arr[j]) {
                    dp1[j][i] = arr[j];
                }
            } else {
                if (i >= arr[j]) {
                    dp1[j][i] = max(arr[j] + dp1[j - 1][i - arr[j]], dp1[j - 1][i]);
                } else {
                    dp1[j][i] = dp1[j - 1][i];
                }
            }
        }
    }
    for (int i = 0; i < sum2; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j == 0) {
                if (i >= arr1[j]) {
                    dp2[j][i] = arr1[j];
                }
            } else {
                if (i >= arr1[j]) {
                    dp2[j][i] = max(arr1[j] + dp2[j - 1][i - arr1[j]], dp2[j - 1][i]);
                } else {
                    dp2[j][i] = dp2[j - 1][i];
                }
            }
        }
    }
    vector <long long> ans1;
    vector <long long> ans2;
    for (int i = 1; i < min(sum1, sum2); ++i) {
        if (dp1[n - 1][i] == dp2[m - 1][i] && dp1[n - 1][i] != 0) {
            int j = i;
            int k = n - 1;
            while (j > 0) {
                if (k > 0) {
                    if (dp1[k][j] == dp1[k - 1][j]) {
                        k--;
                    } else {
                        ans1.push_back(k);
                        j -= arr[k];
                        k--;
                    }
                } else {
                    ans1.push_back(k);
                    j = 0;
                }
            }
            j = i;
            k = m - 1;
            while (j > 0) {
                if (k > 0) {
                    if (dp2[k][j] == dp2[k - 1][j]) {
                        k--;
                    } else {
                        ans2.push_back(k);
                        j -= arr1[k];
                    }
                } else {
                    ans2.push_back(k);
                    j = 0;
                }
            }
            break;
        }
    }
    cout << ans1.size() << endl;
    for (int i = ans1.size() - 1; i > -1; --i) {
        cout << ans1[i] << " ";
    }
    cout << endl;
    cout << ans2.size() << endl;
    for (int i = ans2.size() - 1; i > -1; --i) {
        cout << ans2[i] << " ";
    }
    cout << endl;
}