#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>
using namespace std;
const int MAXN=int(1e6)+7;

vector <double> d(MAXN*4,0);
void fix(int x,int l,int r,int qi,double qe) {
    if (qi<l || qi>=r) {
        return;
    }
    if (r-l==1) {
        d[x]=qe;
        return;
    }
    int m=l+(r-l)/2;
    fix(2*x+1,l,m,qi,qe);
    fix(2*x+2,m,r,qi,qe);
    d[x]=d[2*x+1]+d[2*x+2];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(2);
    long long n,m,q;
    cin >> n >> m >> q;
    long long ans=n*m;
    vector <long long> r1(n+1,0);
    if (n<=10000) {
        for (int i=0;i<q;i++) {
            long long x,y;
            cin >> x >> y;
            y=m-y;
            for (int j=x;j<=n && j<=x+y;j++) {
                r1[j]=max(y-(j-x),r1[j]);
            }
            for (int j=x-1;j>=0 && j>=x-y;j--) {
                r1[j]=max(y-(x-j),r1[j]);
            }
            double ans1=0;
            for (int j=1;j<=n;j++) {
                if (r1[j]==r1[j-1]) {
                    ans1+=max(0.75+(r1[j]-1),double(0));
                } else {
                    ans1+=max(min(r1[j],r1[j-1])+0.5,double(0));
                }
            }
            cout << ans-ans1 << "\n";
        }
    } else {
        for (int i=0;i<q;i++) {
            long long x,y;
            cin >> x >> y;
            y=m-y;
            for (int j=x;j<=n && j<=x+y;j++) {
                r1[j]=max(y-(j-x),r1[j]);
            }
            for (int j=x-1;j>=0 && j>=x-y;j--) {
                r1[j]=max(y-(x-j),r1[j]);
            }
            for (int j=max(x-y,1ll);j<=n && j<=x+y+1;j++) {
                if (r1[j]==r1[j-1]) {
                    fix(0,0,n+1,j,max(0.75+(r1[j]-1),double(0)));
                } else {
                    fix(0,0,n+1,j,max(min(r1[j],r1[j-1])+0.5,double(0)));
                }
            }
            cout << ans-d[0] << "\n";
        }
    }
}
