#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;

ve<ll> arr[500005];
ll link[500005],sz[500005];

void init(ll n)
{
    iota(link,link+n,0);
    fill(sz,sz+n,1);
}

ll fset(ll x)
{
    if(x==link[x]) return x;
    return link[x]=fset(link[x]);
}

void unite(ll a, ll b)
{
    a=fset(a);
    b=fset(b);
    if(sz[a]<sz[b]) swap(a,b);
    link[b]=a;
    sz[a]+=sz[b];
}

ll tin[500005];
ll timer=1;

void dfs(ll s)
{
    if(tin[s]!=0) return;
    tin[s]=timer++;

    for(ll i:arr[s])
        dfs(i);
}

string find_reverse(int n, int m, int con[][2])
{
    init(n);

    for(ll i=0;i<m;i++)
    {
        ll a=con[i][0]-1,b=con[i][1]-1;

        if(fset(a)!=fset(b))
        {
            unite(a,b);
            arr[a].PB(b);
            arr[b].PB(a);
        }
    }

    dfs(0);
    string ans(m,'0');

    for(ll i=0;i<m;i++)
    {
        if(tin[con[i][0]-1]>tin[con[i][1]-1])
            ans[i]='1';
    }

    return ans;
}

/*void solve()
{

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}*/
