#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define rll register ll

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;

ve<ll> arr[500005];
ll link[500005],sz[500005];

void init(ll n)
{
    iota(link,link+n,0);
    fill(sz,sz+n,1);
}

ll fset(ll x)
{
    if(x==link[x]) return x;
    return link[x]=fset(link[x]);
}

void unite(ll a, ll b)
{
    ll sa=fset(a);
    ll sb=fset(b);
    if(sa==sb) return;
    arr[a].PB(b);
    arr[b].PB(a);
    if(sz[sa]<sz[sb]) swap(sa,sb);
    link[sb]=sa;
    sz[sa]+=sz[sb];
}

ll tin[500005];
ll timer=1;

void dfs(ll s, ll p)
{
    tin[s]=timer++;

    for(rll i:arr[s])
    {
        if(i!=p)
            dfs(i,s);
    }
}

string find_reverse(int n, int m, int con[][2])
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init(n);

    #pragma GCC ivdep
    for(rll i=0;i<m;i++)
        unite(con[i][0]-1,con[i][1]-1);

    dfs(0,0);
    string ans(m,'0');

    #pragma GCC ivdep
    for(rll i=0;i<m;i++)
    {
        if(tin[con[i][0]-1]>tin[con[i][1]-1])
            ans[i]='1';
    }

    return ans;
}

/*void solve()
{

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}*/
