#include <vector>
#pragma optimize "Ofast"
using std::vector;
using std::string;
using std::swap;
using std::max;
using std::pair;

using ll = long long;


const int nmax=500005;

const int mmax=1500005;

//vector<int> graph[nmax];
vector<int> ind[nmax];
int actedge[mmax+1];
int other[mmax];
//unordered_map<int,unordered_map<int,int,dinaiabunadetot>, dinaiabunadetot> actedge;
int level[nmax];

class QUEUE {
  public:
    #define SIZE (1048576*2)
    int x[SIZE];
    int y[SIZE];
    int z[SIZE];
    int l=0,r=0;
    
    pair<int,pair<int,int> > front() {
      return {x[l],{y[l],z[l]}};
    }
    void pop() {
      l=(l+1)&(SIZE-1);
    }
    void push(pair<int,pair<int,int> > a) {
      x[r]=a.first;
      y[r]=a.second.first;
      z[r++]=a.second.second;
      r&=SIZE-1;
    }
    bool empty() {
      return l==r;
    }
} que;

//queue< > que;

static void bfs() {
  while(!que.empty()) {
    int node=que.front().first,f=que.front().second.first,index=que.front().second.second;
    //std::cerr << "+\n";
    que.pop();
    if(level[node]!=-1) {
      if(level[node]<level[f]) {
        actedge[index]=node;
        //std::cerr << node+1 << ' ' <<  f+1 <<' '<<index << '\n';
      }
      else if(level[node]==level[f]) {
        if(node>f)
          swap(node,f);
        actedge[index]=node;
        //std::cerr << node+1 << ' ' <<  f+1 <<' '<<index << '\n';
      }
      else {
        actedge[index]=f;
        //std::cerr << f+1 << ' ' << node+1<<' '<<index << '\n';
      }
      bfs();
      return;
    }
    level[node]=level[f]+1;
    actedge[index]=f;
    //std::cerr << f+1 << ' ' << node+1 <<' '<<index << '\n';
    for(int i=0; i<ind[node].size(); i++) {
      int x=other[ind[node][i]]^node;
      if(x!=f && actedge[ind[node][i]]==-1) {
        que.push({x,{node,ind[node][i]}});
      }
      //else
        //std::cerr << "-\n";
    }
  }
  return;
}

std::string find_reverse(int n, int m, int edge[][2]) {
  for(int i=0; i<m; i++) {
    --edge[i][0],--edge[i][1];
    ind[edge[i][0]].push_back(i);
    ind[edge[i][1]].push_back(i);
    other[i]=edge[i][0]^edge[i][1];
    actedge[i]=-1;
  }
  for(int i=0; i<n; i++) {
    level[i]=-1;
  }
  que.push({0,{0,500000}}),bfs();
  
  std::string s;
  s.resize(m);
  for(int i=0,val; i<m; i++) {
    s[i]='1'-(actedge[i]==edge[i][0]);
  }
  return s;
}
