#include <iostream>
#include <iomanip>
#include <set>

using namespace std;
#define x first
#define y second
namespace convert {
  int n,m;
  int lc,rc,lr,rr;
  void init(int cn, int cm) {
    n=cn,m=cm;
    lc=n-1;
    rc=n-m+n-1;
  }
  pair<int,int> getcoord(int x, int y) {
    pair<int,int> rez;
    rez.y=x+y;
    rez.x=(y-x+m);
    //cout << x << ' '<< y << '\n';
    //cout << rez.x << ' '<< rez.y << '\n';
    //cout << '\n';
    return rez;
  }
  double get(double x, double y) {
    double coef,cy=x+y-m,cx=y-x+m;
    cx/=2;
    cy/=2;
    if(cx>n || cx<0 || cy<0 || cy>m)
      return 0;
    x=cx;
    y=cy;
    coef=(n-cx);
    double area=0;
    area+=(n-cx)*(n-cx)*2;
    if(y-coef<0) {
      area-=(coef-y)*(coef-y);
    }
    if(y+coef>m) {
      area-=(m-(y+coef))*(m-(y+coef));
    }
    area/=2;
    //cout  << x << ' '<< y << ' '<<area << '\n';
    return area;
  }
  double get(pair<int,int> p) {
    return get(p.x,p.y);
  }
};

struct pct {
  int x,y;
  double area;
  bool operator <(const pct& a) const {
    return y<a.y;
  } 
}; 

multiset< pct > s;

double getareabet(pct c,multiset<pct>::iterator b, multiset<pct>::iterator it) {
  
  double rez;
  if(it==s.end() && b==s.begin()) {
    //cout << "2\n";
    rez=convert::get(c.x,c.y);
  }
  else if(b==s.begin()) {
    //cout << "1\n";
    rez=convert::get(c.x,c.y)-convert::get(c.x,it->y);
  }
  else if(it==s.end()) {
    b--;
    //cout << "3\n";
    rez=convert::get(c.x,c.y)-convert::get(b->x,c.y);
  }
  else {
    b--;
    //cout << "4\n";
    rez=convert::get(c.x,c.y)
          -convert::get(b->x,c.y)
          -convert::get(c.x,it->y)
          +convert::get(b->x,it->y);
  }
  return rez;
}

int main() {
  int n,m,q;
  double sum;
  cin >> n >> m;
  swap(n,m);
  convert::init(n,m);
  sum=n*m;
  cin >> q;
  pct c;
  for(int i=0,x,y; i<q; i++) {
    cin >> x >> y;
    swap(x,y);
    auto cc=convert::getcoord(x,y);
    c.x=cc.x;
    c.y=cc.y;
    if(s.empty()) {
      c.area=convert::get(c.x,c.y);
      s.insert(c);
      sum-=c.area;
    }
    else {
      auto it=s.lower_bound(c),b=it;
      //for (auto xs: s)
        //cout << "==" << xs.x << ' '<< xs.y <<'\n';
      //if(i==4)
        //cout << "osaosa\n",it++;
      //if(it!=s.end())
        //cout << it->x << ' ' << it->y << ' '<< it->area << "|\n";
        
      while(it!=s.end() && (*it).x<=c.x) {
        auto temp=it;
        //cout << sum <<' '<<it->x << ' ' << it->y << ' '<< it->area << "--\n";
        it++;
        sum+=getareabet(*temp,temp,it);
      }
      if(it==s.end() && b==s.begin()) {
        //cout << "2\n";
        c.area=convert::get(c.x,c.y);
      }
      else if(b==s.begin()) {
        //cout << "1\n";
        c.area=convert::get(c.x,c.y)-convert::get(c.x,it->y);
      }
      else if(it==s.end()) {
        b--;
        //cout << "3\n";
        c.area=convert::get(c.x,c.y)-convert::get(b->x,c.y);
        b++;
      }
      else {
        b--;
        //cout << "4\n";
        c.area=convert::get(c.x,c.y)
              -convert::get(b->x,c.y)
              -convert::get(c.x,it->y)
              +convert::get(b->x,it->y);
        b++;
      }
      if(b!=s.end())
        s.erase(b,it);
      s.insert(c);
      sum-=c.area;
    }
      //cout << c.area << '\n';
    cout << setprecision(2) << fixed << sum << '\n';
  }
}
