#include <iostream>
#include <vector>

using namespace std;

vector< vector<int> > mkdp(vector<int> v,int lim) {
  int n=v.size();
  vector< vector<int> > can(n,vector<int>(n*lim+2,0));
  int cnt=0;
  for(auto x:v) {
    cnt++;
    can[cnt-1][0]=0;
    can[cnt-1][x]=cnt;
    if(cnt==1)
      continue;
    for(int g=n*lim; g>=x; g--) {
      can[cnt-1][g]=can[cnt-2][g];
      if(can[cnt-2][g-x]!=0)
        can[cnt-1][g]=cnt;
    }
    for(int g=x-1; g>=0; g--)
      can[cnt-1][g]=can[cnt-2][g];
  }
  return can;
}

void recon( vector<int> init, vector<vector<int> > dp, int c) {
  vector<int> rez;
  int lin=dp.size()-1;
  while(c>0 && lin>=0 && dp[lin][c]!=0) {
    rez.push_back(dp[lin][c]);
    int poz=dp[lin][c];
    c-=init[poz-1];
    lin=poz-2;    
  }
  //cout << lin << ' '<<c << '\n';
  cout << rez.size() <<'\n';
  for(auto x:rez)
    cout << x-1 << ' ';
  cout <<'\n';
  return;
}

int main() {
  int n,m;
  vector<int> a,b;
  cin >> n;
  a.resize(n);
  for(auto &x: a)
    cin >> x;
  cin >> m;
  b.resize(m);
  for(auto &x: b)
    cin >> x;
  auto l=mkdp(a,m);
  auto r=mkdp(b,n);
  for(int i=0; i<min(l[0].size(),r[0].size()); i++) {
    //cout << l[l.size()-1][i] <<' '<<r[r.size()-1][i] <<'\n';
    if(l[l.size()-1][i]!=0 && 0!=r[r.size()-1][i]) {
      recon(a,l,i);
      recon(b,r,i);
      //cout << "Cox\n";
      exit(0);
    }
  }
}
