#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int NMAX = 5e5 + 5;

vector <int> edges[NMAX + 1];

int depth[NMAX + 1];

int d;
int node;
void dfs() {
    depth[node] = d;
    for ( auto it : edges[node] ) {
        if ( !depth[it] ) {
            int copie = node;
            node = it;
            d ++;
            dfs();
            node = copie;
            d --;
        }
    }
}
string find_reverse (int N, int M, int connections[][2]) {
    int i;
    string ans = "";
    for ( i = 0; i < M; i ++ ) {
        edges[connections[i][0]].push_back( connections[i][1] );
    }
    d = 1;
    for ( i = N; i >= 1; i -- ) {
        if ( !depth[i] ) {
            node = i;
            dfs();

        }
    }
    for ( i = 0; i < M; i ++ ) {
        if ( depth[connections[i][0]] < depth[connections[i][1]] )
            ans += '1';
        else
            ans += '0';
    }
    return ans;
}
