#include <iostream>
#include <iomanip>
using namespace std;
const int NMAX = 1e7 + 5;
long double v[NMAX + 1];
long long n, m;
long double sum;
void update( int x, long double height, int add ) {
    while ( x <= n && x >= 1 && height >= v[x] ) {
        sum -= v[x];
        if ( height == 0 )
            return;
        if ( height == v[x] && height - 1 != v[x + add] ) {
            v[x] = height + 0.25;
            sum += v[x];
            return;
        } else {
            v[x] = height;
            sum += v[x];
        }
        height --;
        x += add;
    }
}
int main() {
    int q, x, y, i;
    long double area;
    cin >> n >> m >> q;
    area = n * m;
    for ( i = 0; i < q; i ++ ) {
        cin >> x >> y;
        update( x + 1, m - y - 0.5, 1 );
        update( x, m - y - 0.5, -1 );
        cout << fixed << setprecision( 2 ) << area - sum << '\n';
    }
    return 0;
}
