#include <bits/stdc++.h>

using namespace std;

int n, m, conn[1005][1005];
int x[10000], y[10000];
vector<pair<int, int>> e[1005];
bool was[1005];

vector<int> g[5005], par[100005];
int deg[100005];

set<vector<int>> cycles, seen;

bitset<100000> my[100005];

int tsz;

void Dfs(vector<int> edges, vector<int> nodes, int lst) {
	for (auto edg : e[lst]) {
		int v = edg.first;
		int id = edg.second;
		if (was[v]) {
			vector<int> use = nodes;
			sort(use.begin(), use.end());
			if (seen.find(use) != seen.end()) {
				continue;
			}
			seen.insert(use);
			vector<int> srt = edges;
			sort(srt.begin(), srt.end());
			cycles.insert(srt);
		} else {
			was[v] = true;
			vector<int> new_edges = edges;
			vector<int> new_nodes = nodes;
			new_nodes.push_back(v);
			new_edges.push_back(id);
			Dfs(new_edges, new_nodes, v);
			was[v] = false;
		}
	}
}

string find_reverse(int n, int m, int connections[][2]) {
	for (int i = 0; i < m; i++) {
		x[i] = connections[i][0];
		y[i] = connections[i][1];
		--x[i]; --y[i];
		conn[x[i]][y[i]] = 1;
		e[x[i]].push_back({y[i], i});
	}
	for (int i = 0; i < n; i++) {
		was[i] = true;
		Dfs({}, {i}, i);
		was[i] = false;
	}
	for (auto cyc : cycles) {
		/*for (auto sta : cyc) {
			cout << sta << " ";
		}
		cout << '\n';*/
		tsz++;
		for (int q : cyc) {
			g[q].push_back(tsz);
			my[q].set(tsz, 1);
			par[tsz].push_back(q);
			deg[tsz]++;
		}
	}
	/*cout << "broj        "  << tsz << '\n';
	for (int i = 0; i < m; i++) {
		cout << my[i] << '\n';
	}*/
	string ans(m, '1');
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < m; j++) {
			if (i == j) continue;
			if ((my[i] | my[j]) == my[j]) {
				ans[i] = '0';
			}
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	int connections[m][2];
	for (int i = 0; i < m; i++) {
		cin >> connections[i][0] >> connections[i][1];
	}
	cout << find_reverse(n, m, connections);
	return 0;
}