#include <bits/stdc++.h>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int N;
	cin >> N;
	vector<int> A(N + 1);
	for (int i = 1; i <= N; i++) {
		cin >> A[i];
	}
	int M;
	cin >> M;
	vector<int> B(M + 1);
	for (int i = 1; i <= M; i++) {
		cin >> B[i];
	}
	function<void(vector<vector<tuple<bool, int, bool>>>&, vector<int>)> Solve = [&](vector<vector<tuple<bool, int, bool>>>& dp, vector<int> a) {
		int n = a.size() - 1;
		int s = accumulate(a.begin(), a.end(), 0);
		dp[0][0] = {true, 0, true};
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j <= N * M; j++) {
				dp[i][j] = dp[i - 1][j];
				get<2>(dp[i][j]) = false;
				if (j >= a[i] && get<0>(dp[i - 1][j - a[i]])) {
					get<0>(dp[i][j]) = true;
					get<1>(dp[i][j]) = i - 1;
					get<2>(dp[i][j]) = true;
				}
			}
		}
	};
	function<void(vector<vector<tuple<bool, int, bool>>>, int, int, vector<int> a)> Rec = [&](vector<vector<tuple<bool, int, bool>>> dp, int x, int k, vector<int> a) {
		vector<int> ans;
		int pos = k;
		while (pos > 0) {
			if (get<2>(dp[pos][x])) {
				ans.push_back(pos);
				x -= a[pos];
			}
			pos--;
		}
		reverse(ans.begin(), ans.end());
		cout << ans.size() << '\n';
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] - 1 << " ";
		}
		cout << '\n';
	};
	vector<vector<tuple<bool, int, bool>>> dp_a(N + 1, vector<tuple<bool, int, bool>>(N * M + 1));
	vector<vector<tuple<bool, int, bool>>> dp_b(M + 1, vector<tuple<bool, int, bool>>(N * M + 1));
	Solve(dp_a, A);
	Solve(dp_b, B);
	/*for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n * m; j++) {
			cout << get<0>(dp_a[i][j]) << " ";
		}
		cout << '\n';
	}*/
	for (int x = 1; x <= N * M; x++) {
		if (get<0>(dp_a[N][x]) && get<0>(dp_b[M][x])) {
			cout << x << '\n';
			Rec(dp_a, x, N, A);
			Rec(dp_b, x, M, B);
			return 0;
		}
	}
	cout << "bruh";
	return 0;
}