#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define SPEED ios_base::sync_with_stdio(false); cin.tie(0), cout.tie(0)
#define all(v) (v).begin(), (v).end()
#define pb push_back
using namespace std;

ll Q, n, m, w[1000005], cur[1000005];

// w[i] indicates the number of vertically wholy covered squares on square i on x axis

// cur[i] == -1
// it means the i'th square on x axis is covered 50% starting from left
// cur[i] == 1
// it means the i'th square on x axis is covered 50% starting from right
// cur[i] == 2
// it means the i'th square on x axis is covered 75%

int main()
{
	SPEED;
	// implementing idea 2.0 (naive brute O(n*Q))
	cin>>n>>m>>Q;
	while(Q--)
	{
		ll x, y;
		cin>>x>>y;		
		ll h=m-y;
		ll l=x-h, r=x+h-1;
		ll wl=max(0ll, -l), wr=max(r-n+1, 0ll);
		//   +1 / \ -1
		int k=1;
		//cout<<"h = "<<h<<"\nl, r = "<<l<<' '<<r<<"\nwl = "<<wl<<'\n';
		for(int i=max(0ll, l); i<=min(n-1, r); i++)
		{
			if(wl==h) wl--, k=-1;
			if(wl<0) break;
			if(w[i]<wl or cur[i]==0)
			{
				w[i]=wl;
				cur[i]=k;
			}
			else if(w[i]==wl and k!=cur[i])
				cur[i]=2;

			wl+=k;

			//cout<<"w["<<i<<"] = "<<w[i]<<"\ncur["<<i<<"] = "<<cur[i]<<'\n';
		}
		ll o50=0, o75=0, ans=0;
		for(int i=0; i<n; i++)
		{
			ans+=(m-w[i]-1);
			if(cur[i]==0) ans++;
			else if(cur[i]==2) o75++;
			else o50++;
		}
		//cout<<ans<<' '<<o50<<' '<<o75<<'\n';
		cout<<fixed<<setprecision(2)<<1.0*ans+0.50*o50+0.25*o75<<'\n';
	}
	return 0;
}
/*
	for each query (x, y):

	h -> height of the triangle

	h = m - y;

	range that the triangle will cover on x axis is :

	[ max(x - h, 0) ; min(h + x, n) ]

	so for each query will have to subtract the area of the formed triangle
	from the previous answer
	and add the areas that were already subtracted from the answer
	and to do that we'll have to find triangle that lie on each other
	and add that area were these two triangle coincide

	final solition :
	inclusion - eclusion :
	for each square we have have to find the number of triangles that lie on it
	if this number is even, we have to add that area to the answer
	otherwise, subtract it from the answer
	
	final solution (idea 2.0) :
	for every square on the x axis just calculate the number of squared that are vertially covered
	O(Q*n) the naive solution (bruteforce)

	P.S. it might be easier to calculate the answer if we veiw the squares diagonally
	P.S.S or maybe not

	optimal way to do it :
	i think , the optimal way to do it is somehow related to 2D segtree
	this means i'm not able to fully solve this problem but i can come up
	with some solutions for the subtasks;

*/