#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000

using namespace std;

int dist[MAX_N + 1], viz[MAX_N + 1], rev[MAX_N + 1], q[MAX_N + 1];
vector <int> edge[MAX_N + 1][2];

void bfs( int n, int m, int nod, int c[][2] ) {
    int e, i, f, l;

    dist[nod] = 1;
    f = l = 0;
    q[f] = nod;
    while ( f <= l ) {
        nod = q[f];
        f++;

        viz[nod] = 1;

        for ( i = 0; i < edge[nod][0].size(); i++ ) {
            e = edge[nod][0][i];
            if ( viz[c[e][1]] == 0 )
                rev[e] = 1;
        }

        for ( i = 0; i < edge[nod][1].size(); i++ ) {
            e = edge[nod][1][i];
            if ( rev[e] == 0 ) {
                if ( dist[c[e][0]] == 0 ) {
                    dist[c[e][0]] = dist[nod] + 1;
                    l++;
                    q[l] = c[e][0];
                }
            }
        }
        for ( i = 0; i < edge[nod][0].size(); i++ ) {
            e = edge[nod][0][i];
            if ( rev[e] == 1 ) {
                if ( dist[c[e][1]] == 0 ) {
                    dist[c[e][1]] = dist[nod] + 1;
                    l++;
                    q[l] = c[e][1];
                }
            }
        }
    }
}

std::string find_reverse( int n, int m, int connections[][2] ) {
    int i;
    string ans;

    for ( i = 0; i < m; i++ ) {
        edge[connections[i][0]][0].push_back( i );
        edge[connections[i][1]][1].push_back( i );
    }

    bfs( n / 2, m, n, connections );

    ans = "";
    for ( i = 0; i < m; i++ )
        ans += char( rev[i] + '0' );

    return ans;
}