#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000
#define NIL -1

using namespace std;

int vizq[MAX_N], viz[MAX_N], rev[MAX_M];
int edge[MAX_N], nxt[2 * MAX_M], q[MAX_N];
string ans;

string find_reverse( int n, int m, int c[][2] ) {
    int f, l, e, nod, i;

    for ( i = 0; i < n; i++ )
        edge[i] = NIL;
    for ( i = 0; i < m; i++ ) {
        c[i][0]--;
        c[i][1]--;

        nxt[i] = edge[c[i][0]];
        edge[c[i][0]] = i;

        nxt[i + m] = edge[c[i][1]];
        edge[c[i][1]] = i + m;
    }

    nod = 1;

    vizq[nod] = 1;
    f = l = 0;
    q[f] = nod;
    while ( f <= l ) {
        nod = q[f];
        f++;

        viz[nod] = 1;

        e = edge[nod];
        while ( e != NIL ) {
            if ( e < m ) {
                if ( viz[c[e][1]] == 0 ) {
                    rev[e] = 1;
                    if ( vizq[c[e][1]] == 0 ) {
                        vizq[c[e][1]] = 1;
                        l++;
                        q[l] = c[e][1];
                    }
                }
            } else {
                e -= m;
                if ( rev[e] == 0 ) {
                    if ( vizq[c[e][0]] == 0 ) {
                        vizq[c[e][0]] = 1;
                        l++;
                        q[l] = c[e][0];
                    }
                }
                e += m;
            }
            e = nxt[e];
        }
    }

    for ( i = 0; i < m; i++ )
        ans += char( rev[i] + '0' );

    return ans;
}
