#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
struct seq {
    int sum;
    vector<int> inds;
    /*bool operator<(const seq& s) {
        return sum < s.sum;
    }
    bool operator==(const seq& s) {
        return sum == s.sum;
    }*/
};
bool operator<(const seq& s1, const seq& s2) {
    return s1.sum < s2.sum;
}
bool operator==(const seq& s1, const seq& s2) {
    return s1.sum == s2.sum;
}
int n, m;
vector<int> A;
vector<int> B;
set<seq> getSeqA(int i) {
    if (i == n) {
        return {};
    }
    if (i == n - 1) {
        return { {A[i],{i}},{0,{}} };
    }
    set<seq> v = getSeqA(i + 1);
    set<seq> v1(v);
    for (auto j = v1.begin(); j!= v1.end(); j++) {
        seq s = *j;
        s.sum += A[i];
        s.inds.push_back(i);
        v.insert(s);
    }
    return v;
}
set<seq> getSeqB(int i) {
    if (i == m) {
        return {};
    }
    if (i == m - 1) {
        return { {B[i],{i}},{0,{}} };
    }
    set<seq> v = getSeqB(i + 1);
    set<seq> v1(v);
    for (auto j = v1.begin(); j != v1.end(); j++) {
        seq s = *j;
        s.sum += B[i];
        s.inds.push_back(i);
        v.insert(s);
    }
    return v;
}
/*struct range {
    int start, end;
    int size() {
        return end - start + 1;
    }
    int middle() {
        return (end + start) / 2;
    }
};
int find(int k, vector<int>& v, range r) {
    if (r.size() == 1) {
        return (r.start + 1) * (k == v[r.start]) - 1;
    }
    int x = v[r.middle()];
    if (x == k)
        return r.middle();
    if (x < k) {
        return find(k, v, { r.middle() + 1,r.end });
    }
    else
        return find(k, v, { r.start,r.middle()});
}
vector<vector<pair<seq,seq>>> dp;*/
/*pair<seq, seq> f(int i, int dif) {
    if (dp[i][dif].first.sum!=0||dp[i][dif+dp.size()-1])
        return dp[i][dif]
    if (i == dp.size() - 1) {
        if (dif == A[i] - B[i]) {
            
        }
    }
}*/
int main()
{
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    cin >> m;
    B.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> B[i];
    }
    /*int max = n > m ? n : m;
    if (n < m) {
        for (int i = n; i < m; i++) {
            A.push_back(0);
        }
    }
    else {
        for (int i = m; i < n;i++) {
            B.push_back(0);
        }
    }
    dp.resize(max);
    for (int i = 0; i < max; i++) {
        dp[i].resize(max);
    }*/

    /*vector<int> b(B);
    sort(b.begin(), b.end());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (A[i] <= b[j])
                continue;
            int x = find(A[i] - b[j], b, { 0,m - 1 });
            if (x != -1) {
                for (int k = 0; k < m; k++) {
                    if (B[k] == b[j]) {
                        for (int l = 0; l < m; l++) {
                            if (l != k && B[l] == A[i] - b[j]) {
                                cout << 1 << endl << i << endl << 2 << k << " " << l;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    vector<int> a(A);
    sort(a.begin(), a.end());
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (B[i] <= a[j])
                continue;
            int x = find(B[i] - a[j], a, { 0,n - 1 });
            if (x != -1) {
                for (int k = 0; k < n; k++) {
                    if (A[k] == a[j]) {
                        for (int l = 0; l < n; l++) {
                            if (l != k && A[l] == B[i] - a[j]) {
                                cout << 2 << endl << k << " " << l << endl << 1 << endl << i;
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }*/
    set<seq> sa = getSeqA(0);
    set<seq> sb = getSeqB(0);
    vector<seq> va, vb;
    for (auto j = sa.begin(); j != sa.end(); j++) {
        va.push_back(*j);
    }
    for (auto j = sb.begin(); j != sb.end(); j++) {
        vb.push_back(*j);
    }
    int i = 0;
    int j = 0;
    while (1) {
        if (va[i] == vb[j] && va[i].sum != 0) {
            cout << va[i].inds.size() << endl;
            for (int k = 0;k < va[i].inds.size();k++) {
                cout << va[i].inds[k] << " ";
            }
            cout << endl;
            cout << vb[j].inds.size() << endl;
            for (int k = 0;k < vb[j].inds.size();k++) {
                cout << vb[j].inds[k] << " ";
            }
            cout << endl;
            break;
        }
        if (va[i] < vb[j]) {
            i++;
        }
        else
            j++;
    }
}