#include <iostream>
#include <string>
#include <vector>

using namespace std;

static const int MAXN = 500000;
struct nod{
    bool vizitat;
    int start_time;
    int end_time;
    vector<int> succesori;
};

nod graph[MAXN + 1];

int t;
void dfs(int crt){
    nod&crt_nod = graph[crt];
    crt_nod.vizitat = true;
    crt_nod.start_time = t;
    t++;
    for(unsigned i = 0; i < crt_nod.succesori.size(); i++){
        int succ_idx = crt_nod.succesori[i];
        if(!graph[succ_idx].vizitat)
            dfs(succ_idx);
    }
    crt_nod.end_time = t;
    t++;
}

std::string find_reverse (int n, int m, int connections[][2]){
    for(int i = 0; i < m; i++){
        int x = connections[i][0];
        int y = connections[i][1];

        graph[x].succesori.push_back(y);
    }
    dfs(1);

    string rez;
    for(int i = 0; i < m; i++){
        int x = connections[i][0];
        int y = connections[i][1];
        if(graph[x].start_time > graph[y].start_time && graph[x].end_time < graph[y].end_time){
            rez.append("1");
        }else{
            rez.append("0");
        }
    }

    return rez;
}
