#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>
using namespace std;

#define state second
#define id first

const int MAX_N = 1e5 + 128;

vector <char> used;
vector < vector<int> > g;
vector < vector<int> > inv;
string ans;
unordered_map < int , unordered_map<int, pair<int, char>> > edges;
// maybe if true the edge open, otherwise - close?

void make(int v, int u) {
    if (edges[v].find(u) == edges[v].end()) return;
//    cout << "we make swap : " << v << " and " << u << '\n';
    int val = edges[v][u].id;

    ans[val] = (ans[val] == '0' ? '1' : '0');

    edges[v][u].state = !edges[v][u].state;
    edges[u][v].state = !edges[u][v].state;
}

void dfs(int v) {
    used[v] = true;
    unordered_set <int> to;

    for (auto u : g[v]) {
        if (edges[v][u].state == false)
            continue;
        if (used[u])
            continue;
        dfs(u);
    }

    for (auto u : inv[v]) {
        if (edges[v][u].state == false)
            continue;
        if (used[u])
            continue;
        dfs(u);
    }

    for (auto u : g[v])
        if (edges[v][u].state && used[u])
            to.insert(u);
    for (auto u : inv[v])
        if (edges[v][u].state && used[u])
            to.insert(u);

    for (auto c : to)
        make(v, c);


}

extern std::string find_reverse (int N, int M, int connections[][2]) {
    boost;
    for (int i = 0; i < M; i++) ans += "0";
    g.resize(N); inv.resize(N); used.resize(N);
    for (int i = 0; i < M; i++) {
        int u = connections[i][0] - 1;
        int v = connections[i][1] - 1;
        g[u].push_back(v);
        inv[v].push_back(u);
        edges[u][v] = {i, true};
        edges[v][u] = {i, false};
    }
    for (int i = 0; i < N; i++)
        if (!used[i])
            dfs(i);
    return ans;
}
