#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>

using namespace std;

void test_case() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto &x : a)
        cin >> x;
    int m;
    cin >> m;
    vector <int> b(m);
    for (auto &x : b)
        cin >> x;

    if (max(n, m) <= 23) {
        unordered_map <int, vector<int>> subsA, subsB;
        for (int mask = 0; mask < (1ll << n); mask++) {
            vector <int> arr; ll sum = 0;
            for (int bit = 0; bit < n; bit++)
                if ((mask >> bit) & 1)
                    arr.push_back(bit), sum += a[bit];
            subsA[sum] = arr;
        }
        for (int mask = 0; mask < (1ll << m); mask++) {
            vector <int> arr; ll sum = 0;
            for (int bit = 0; bit < m; bit++)
                if ((mask >> bit) & 1)
                    arr.push_back(bit), sum += b[bit];
            subsB[sum] = arr;
        }

        for (auto [l, r] : subsA)
            if (subsB.find(l) != subsB.end()) {
                cout << (int) r.size() << '\n';
                for (auto c : r)
                    cout << c << ' ';
                cout << '\n';
                cout << (int) subsB[l].size() << '\n';
                for (auto c : subsB[l])
                    cout << c << ' ';
                cout << '\n';
                return;
            }
        while (true) continue;
    }

    vector < vector<int> > cntA(m+1), cntB(n+1);
    for (int i = 0; i < n; i++)
        cntA[a[i]].push_back(i);
    for (int i = 0; i < m; i++)
        cntB[b[i]].push_back(i);
    for (int i = 0; i <= min(n, m); i++)
        if (!cntA[i].empty() && !cntB[i].empty()) {
            cout << 1 << '\n';
            cout << cntA[i].front() << '\n';
            cout << 1 << '\n';
            cout << cntB[i].front() << '\n';
            return;
        }
}

main () {
    boost;
    test_case();
    return 0;
}
