#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <tuple>
using namespace std;

void Next(vector<vector<pair<int, int>>>& graph, vector<bool>& painted_now, vector<bool>& painted, stack<int>& route, string& res) {
	int current = route.top();
	painted[current] = true;
	painted_now[current] = true;
	for (int i = 0; i < graph[current].size(); i++)
	{
		int node = graph[current][i].first;
		int connection = graph[current][i].second;

		if (painted_now[node]) {
			res[connection] = '1';
		}
		if (!painted[node]) {
			route.push(node);
			Next(graph, painted_now, painted, route, res);
		}

	}
	route.pop();
}

string find_reverse(int N, int M, int connections[][2]) {

	vector<vector<pair<int, int>>> graph(N);
	for (int i = 0; i < M; i++)
	{

		graph[connections[i][0]-1].push_back(make_pair(connections[i][1]-1, i));
	}
	string res(M, '0');
	vector<bool> painted(N);
	vector<bool> painted_now;
	stack<int> route;
	for (int i = 0; i < N; i++)
	{
		painted_now = vector<bool>(N);
		if (!painted[i]) {
			painted[i] = true;
			route.push(i);
			Next(graph, painted_now, painted, route, res);
		}
	}
	return res;
}


