﻿#pragma GCC optimize("O3")

#include <iostream>
#include <string>
#include <vector>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<vector<int>>> a(n, vector<vector<int>>(m, vector<int>(4, 1)));
    int q;
    cin >> q;
    long long ans = n * m * 4;
    while (q--) {
        int x, y;
        cin >> x >> y;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i - j == x - y && j >= y) {
                    ans -= (a[i][j][0] + a[i][j][3]);
                    a[i][j][0] = a[i][j][3] = 0;
                } else if (i + j == x + y - 1 && i <= x && j >= y) {
                    ans -= (a[i][j][0] + a[i][j][1]);
                    a[i][j][0] = a[i][j][1] = 0;
                } else if (i - j < x - y && i + j >= x + y && j >= y) {
                    ans -= (a[i][j][0] + a[i][j][1] + a[i][j][2] + a[i][j][3]);
                    a[i][j][0] = a[i][j][1] = a[i][j][2] = a[i][j][3] = 0;
                }
            }
        }
        cout << ans / 4 << ".";
        if (ans % 4 == 0) {
            cout << "00";
        } else {
            cout << ans % 4 * 25;
        }
        cout << '\n';
    }
    return 0;
}