﻿#pragma GCC optimize("O3")

#include <iostream>
#include <string>
#include <vector>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, m;
    cin >> n >> m;
    vector<vector<long long>> a(n, vector<long long>(4, m));
    long long ans = n * m * 4;
    int q;
    cin >> q;
    while (q--) {
        long long x, y;
        cin >> x >> y;
        for (long long i = x - 1; i >= 0; --i) {
            long long j = (x + y - 1) - i;
            if (j == m) {
                break;
            }
            ans -= (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
            if (0 <= j && j <= m) {
                a[i][2] = min(a[i][2], j);
                a[i][3] = min(a[i][3], j);
                if (j + 1 <= m) {
                    a[i][0] = min(a[i][0], j + 1);
                    a[i][1] = min(a[i][1], j + 1);
                }
            }
            ans += (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
        }
        for (long long i = x; i < n; ++i) {
            long long j = i - (x - y);
            if (j == m) {
                break;
            }
            ans -= (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
            if (0 <= j && j <= m) {
                a[i][1] = min(a[i][1], j);
                a[i][2] = min(a[i][2], j);
                if (j + 1 <= m) {
                    a[i][0] = min(a[i][0], j + 1);
                    a[i][3] = min(a[i][3], j + 1);
                }
            }
            ans += (a[i][0] + a[i][1] + a[i][2] + a[i][3]);
        }
        cout << ans / 4 << ".";
        if (ans % 4 == 0) {
            cout << "00";
        } else {
            cout << ans % 4 * 25;
        }
        cout << '\n';
    }
    return 0;
}