﻿#pragma GCC optimize("O3")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
        sum += a[i].first;
    }
    int m;
    cin >> m;
    long long sum2 = 0;
    vector<pair<int, int>> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].first;
        b[i].second = i;
        sum2 += b[i].first;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i].first == b[j].first) {
                cout << 1 << '\n' << a[i].second << '\n' << 1 << '\n' << b[j].second;
                return 0;
            }
        }
    }
    unordered_set<long long> s;
    long long sm = 0;
    for (int j = 0; j < n; ++j) {
        sm += a[j].first;
        s.insert(sm);
        if (j + 1 != n) {
            s.insert(sum - sm);
        }
    }
    sm = 0;
    for (int j = 0; j < m; ++j) {
        sm += b[j].first;
        if (s.count(sm)) {
            long long sm1 = 0;
            for (int j1 = 0; j1 < n; ++j1) {
                sm1 += a[j1].first;
                if (sm1 == sm) {
                    cout << j1 + 1 << '\n';
                    for (int k = 0; k <= j1; ++k) {
                        cout << a[k].second << ' ';
                    }
                    cout << '\n';
                    cout << j + 1 << '\n';
                    for (int k = 0; k <= j; ++k) {
                        cout << b[k].second << ' ';
                    }
                    return 0;
                }
                if (sum - sm1 == sm) {
                    cout << n - j1 - 1 << '\n';
                    for (int k = j1 + 1; k < n; ++k) {
                        cout << a[k].second << ' ';
                    }
                    cout << '\n';
                    cout << j + 1 << '\n';
                    for (int k = 0; k <= j; ++k) {
                        cout << b[k].second << ' ';
                    }
                    return 0;
                }
            }
            return 0;
        }
        if (j + 1 != m && s.count(sum2 - sm)) {
            long long sm1 = 0;
            for (int j1 = 0; j1 < n; ++j1) {
                sm1 += a[j1].first;
                if (sm1 == sum2 - sm) {
                    cout << j1 + 1 << '\n';
                    for (int k = 0; k <= j1; ++k) {
                        cout << a[k].second << ' ';
                    }
                    cout << '\n';
                    cout << m - j - 1 << '\n';
                    for (int k = j + 1; k < m; ++k) {
                        cout << b[k].second << ' ';
                    }
                    return 0;
                }
                if (sum - sm1 == sum2 - sm) {
                    cout << n - j1 - 1 << '\n';
                    for (int k = j1 + 1; k < n; ++k) {
                        cout << a[k].second << ' ';
                    }
                    cout << '\n';
                    cout << m - j - 1 << '\n';
                    for (int k = j + 1; k < m; ++k) {
                        cout << b[k].second << ' ';
                    }
                    return 0;
                }
            }
            return 0;
        }
    }
    return 1;
}