#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>

#define int long long

using namespace std;


main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    long double S = n * m;
    cout << fixed << setprecision(2);
    vector<vector<vector<bool> > > a;
    a.resize(m + 5);
    for(int i = 0; i < m + 5; i ++){
        a[i].resize(n + 5);
        for(int j = 0; j < n + 5; j ++)
            a[i][j].resize(4);
    }
    while(q --){
        long double p, q;
        cin >> p >> q;
        q = m - q;
        long double s = 0;
        for(int i = 0; i < q; i ++){
            int j = p - q + i;
            if (j < 0 || j >= n)
                continue;
            if (a[i][j][0] || a[i][j][1] || a[i][j][2])
                continue;
            if (a[i][j][3]){
                a[i][j][1] = a[i][j][2] = true;
                s += 0.25;
            } else {
                a[i][j][2] = true;
                s += 0.5;
            }
        }

//        cout << "s1 = " << s << '\n';

        for(int i = q - 1; i >= 0; i --){
            int j = p + q - i - 1;
            if (j < 0 || j >= n)
                continue;
            if (a[i][j][0] || a[i][j][1] || a[i][j][3])
                continue;
            if (a[i][j][2]){
                a[i][j][1] = a[i][j][3] = true;
                s += 0.25;
            } else {
                a[i][j][3] = true;
                s += 0.5;
            }
        }

//        cout << "s2 = " << s << '\n';

        for(int i = 0; i < q - 1; i ++){
            for(int j = p - q + 1 + i; j <= p + q - 2 - i; j ++){
                if (j < 0 || j >= n)
                    continue;
                if (a[i][j][0])
                    continue;
                if (a[i][j][1]){
                    a[i][j][0] = true;
                    s += 0.25;
                } else if (a[i][j][2] || a[i][j][3]){
                    a[i][j][0] = true;
                    s += 0.5;
                } else {
                    a[i][j][0] = true;
                    s += 1;
                }
            }
//            cout << "s3." << i << " = " << s << '\n';
        }

        S -= s;
//        cout << "s = " << s << '\n';
        cout << S << '\n';
    }
}
