#include<iostream>
#include<string>
#include <vector>
#define pb push_back
using namespace std;

extern std::string find_reverse (int, int, int[][2]);

static const int MAXM=1.5e6;
static int connections[MAXM][2];

const int N = 100005;
bool cycle = 0,q;
int f[N];
vector <int> v[N];

void dfs(int x){
    f[x] = 1;
    for (int to: v[x]){
        if (f[to] == 1) cycle = 1;
        else if (f[to] == 0) dfs(to);
    }
    f[x] = 2;
}
string find_reverse(int n,int m,int edge[m][2]){
    string S ="";
    for (int i=0;i<(1LL<<(m)); i++){
        string str="";
        for (int j=0;j<m;j++){
            if (((1LL<<j)&i) > 0) str+='1';
            else str+='0';
        }

        for (int j=0;j<m;j++)
            if (str[j] == '1') v[edge[j][1]].pb(edge[j][0]);
            else v[edge[j][0]].pb(edge[j][1]);

        cycle=0;
        for(int j=1;j<=n;j++){
            if (f[j] == 0) dfs(j);
            if (cycle) break;
        }
        if (!cycle) {S = str; break;}
    
        for(int j=1;j<=n;j++)
            v[j].clear(),f[j] = 0;
    }
    return S;
}

int main () {
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        cin >> connections[i][0] >> connections[i][1] ;
    }
    string ans = find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
}
