#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <set>
using namespace std;

vector<int> g[500005];

bool visit[500005];

queue<int> q, qq;

set<int> st[500005];

void bfs()
{
	int i, j;
	int u, v;
	visit[1] = true;
	q.push(1);
	while (!q.empty()) {
		u = q.front();
		q.pop();
		for (i = 0; i < g[u].size(); i++) {
			v = g[u][i];
			if (st[u].find(v) == st[u].end() && st[v].find(u) == st[v].end()) {
				st[u].insert(v);
			}
			if (visit[v]) {
				continue;
			}
			q.push(v);
			visit[v] = true;
		}
	}
	return;
}

string find_reverse(int N, int M, int connections[][2])
{
	int i, j;
	for (i = 0; i < M; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		g[x].push_back(y);
		g[y].push_back(x);
	}
	bfs();
	string s = "";
	for (i = 0; i < M; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		if (st[x].find(y) == st[x].end()) {
			s += '1';
		}
		else {
			s += '0';
		}
	}
	return s;
}