#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second

int n, m;
vector<int> a;
vector<vector<int>> g;
map<int, vector<int>> dist1, dist2;
vector<bool> used;

void dfs(int v, int sum) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) {
            continue;
        }
        dist1[sum + a[u]] = dist1[sum];
        dist1[sum + a[u]].push_back(u);
        dfs(u, sum + a[u]);
    }
}

signed main() {

    int N, M;
    cin >> N;
    vector<int> A(N);
    for (int i = 0; i < N; i++) {
        cin >> A[i];
    }
    cin >> M;
    vector<int> B(M);
    for (int i = 0; i < M; i++) {
        cin >> B[i];
    }

    if (N <= 20 and M <= 20) {

        n = N;
        vector<pair<int, int>> suma(1 << n);

        a.resize(n);
        for (int i = 0; i < n; i++) {
            a[i] = A[i];
        }
        for (int j = 1; j < (1 << n); j++) {
            int mask = j;
            int sum = 0;
            for (int i = 0; i < n; i++) {
                if (mask & 1) {
                    sum += a[i];
                }
                mask = (mask >> 1);
            }
            suma[j] = {sum, j};
        }

        m = M;
        vector<int> b(m);
        vector<pair<int, int>> sumb(1 << m);

        for (int i = 0; i < m; i++) {
            b[i] = B[i];
        }
        for (int j = 1; j < (1 << m); j++) {
            int mask = j;
            int sum = 0;
            for (int i = 0; i < m; i++) {
                if (mask & 1) {
                    sum += b[i];
                }
                mask = (mask >> 1);
            }
            sumb[j] = {sum, j};
        }

        sort(suma.begin(), suma.end());
        sort(sumb.begin(), sumb.end());

        int la = 1;
        int lb = 1;

        while (la + 1 < suma.size() or lb + 1 < sumb.size()) {
            if (suma[la].F == sumb[lb].F){
                vector<int> ans;
                int aa = suma[la].S;
                for (int i = 0; i < n; i++) {
                    if (aa & 1) {
                        ans.push_back(i);
                    }
                    aa = (aa >> 1);
                }
                cout << ans.size() << endl;
                for (int i = 0; i < ans.size(); i++) {
                    cout << ans[i] << " ";
                }
                cout << endl;


                ans.clear();
                aa = sumb[lb].S;
                for (int i = 0; i < m; i++) {
                    if (aa & 1) {
                        ans.push_back(i);
                    }
                    aa = (aa >> 1);
                }
                cout << ans.size() << endl;
                for (int i = 0; i < ans.size(); i++) {
                    cout << ans[i] << " ";
                }
                return 0;
            }
            if (suma[la].F < sumb[lb].F and la + 1 < suma.size()) {
                la++;
            }
            else if (lb + 1 < sumb.size()){
                lb++;
            }
        }


        return 0;
    }

    n = N;
    g.resize(n);
    used.resize(n);
    a.resize(n);

    for (int i = 0; i < n; i++) {
        a[i] = A[i];
        dist1[a[i]] = {i};
        for (int j = i + 1; j < n; j++) {
            g[i].push_back(j);
        }
    }

    for (int i = 0; i < n; i++) {
        dfs(i, a[i]);
        used.clear();
        used.resize(n);
    }

    dist2 = dist1;
    dist1.clear();

    g.clear();
    used.clear();
    a.clear();

    n = M;
    g.resize(n);
    used.resize(n);
    a.resize(n);

    for (int i = 0; i < n; i++) {
        a[i] = B[i];
        dist1[a[i]] = {i};
        for (int j = i + 1; j < n; j++) {
            g[i].push_back(j);
        }
    }

    for (int i = 0; i < n; i++) {
        dfs(i, a[i]);
        used.clear();
        used.resize(n);
    }


    for (auto it : dist2) {
        int sum = it.F;
        if (dist1.find(sum) != dist1.end()) {
            vector<int> d = it.S;
            cout << d.size() << endl;
            for (int i = 0; i < d.size(); i++) {
                cout << d[i] << " ";
            }
            cout << endl;
            for (auto iit : dist1) {
                if (iit.F == sum) {
                    d = iit.S;
                    cout << d.size() << endl;
                    for (int i = 0; i < d.size(); i++) {
                        cout << d[i] << " ";
                    }
                    return 0;
                }
            }
            
        }
    }

    return 0;
}
