#include <iostream>
#include <bitset>
#include <algorithm>
#include <map>
#include <queue>
#include <cassert>
#include <vector>
using namespace std;
using ll = long long;

const ll MAXN = 1000000;
const ll MAXM = 100000;
ll a[MAXN];
vector<ll> compra[MAXN];
ll b[MAXN];
vector<ll> comprb[MAXN];

vector<bitset<MAXM>> dpa;
vector<bitset<MAXM>> dpb;

void add(vector<ll>& v, vector<ll>& add) {
    for (auto x : add)
        v.push_back(x);
}

vector<pair<ll, vector<ll>>> input() {
    ll n;
    cin >> n;
    map<ll, queue<vector<ll>>> mp;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        mp[x].push({i});
    }
    return {};
    ll x0 = -1;
    //while (x0 < mp.rbegin()->first) {
        //auto& [x, comprs] = *mp.upper_bound(x0);
        //ll sz = 2;
        //while (comprs.size() > sz) {
            //vector<ll> v = comprs.front();
            //comprs.pop();
            //for (ll i = 0; i < sz - 1; ++i) {
                //add(v, comprs.front());
                //comprs.pop();
            //}
            //mp[x * sz].push(v);
            //sz *= 2;
        //}
        //x0 = x;
    //}
    vector<pair<ll, vector<ll>>> ans;
    //for (auto [x, comprs] : mp) {
        //while (comprs.size()) {
            //auto v = comprs.front();
            //ans.push_back({x, v});
            //comprs.pop();
        //}
    //}
    return ans;
}

void goback(ll i, ll sma, ll smb, vector<ll>& inca, vector<ll>& incb, ll n, ll m) {
    if (i == -1)
        return;
    if (i == 0) {
        if (sma) {
            for (auto t : compra[i])
                inca.push_back(t);
        }
        if (smb) {
            for (auto t : comprb[i])
                incb.push_back(t);
        }
        return;
    }
    if (i < n && !dpa[i - 1][sma]) {
        for (auto t : compra[i])
            inca.push_back(t);
        sma -= a[i];
    }
    if (i < m && !dpb[i - 1][smb]) {
        for (auto t : comprb[i])
            incb.push_back(t);
        smb -= b[i];
    }
    goback(i - 1, sma, smb, inca, incb, n, m);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    vector<pair<ll, vector<ll>>> a_ = input();
    ll n = a_.size();
    for (ll i = 0; i < n; ++i) {
        a[i] = a_[i].first;
        compra[i] = a_[i].second;
    }

    vector<pair<ll, vector<ll>>> b_ = input();
    ll m = b_.size();
    for (ll i = 0; i < m; ++i) {
        b[i] = b_[i].first;
        comprb[i] = b_[i].second;
    }
    return 0;
    //cout << "(" << n << ' ' << m << ")" << endl;
    if (n >= 500 && m >= 500) {
        for (int i = 0; i < n; ++i) {
            int j = lower_bound(b, b + m, a[i]) - b;
            if (a[i] == b[j]) {
                cout << compra[i].size() << endl;
                for (auto x : compra[i])
                    cout << x << ' ';
                cout << endl;
                cout << comprb[i].size() << endl;
                for (auto x : comprb[i])
                    cout << x << ' ';
                cout << endl;
                return 0;
            }
        }
        return 0;
    }

    dpa.push_back(0);
    dpb.push_back(0);
    dpa[0][0] = dpa[0][a[0]] = 1;
    dpb[0][0] = dpb[0][b[0]] = 1;

    for (ll i = 1; i < n || i < m; ++i) {
        dpa.push_back(dpa[i - 1] | (dpa[i - 1] << a[i]));
        dpb.push_back(dpb[i - 1] | (dpb[i - 1] << b[i]));
        if ((dpa[i] & dpb[i]).count() > 1) {
            for (ll k = 1; k < MAXM; ++k) {
                if (dpa[i][k] && dpb[i][k]) {
                    vector<ll> a0;
                    vector<ll> b0;
                    goback(i, k, k, a0, b0, n, m);
                    cout << a0.size() << endl;
                    for (auto x : a0)
                        cout << x << ' ';
                    cout << endl;
                    cout << b0.size() << endl;
                    for (auto x : b0)
                        cout << x << ' ';
                    cout << endl;
                    return 0;
                }
            }
        }
    }
}
