#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;

string find_reverse(int n, int m, int conect[][2])
{
    vector<vector<int>> zw(n);
    for (int i = 0; i < m; i++) {
        int s, e;
        s = conect[i][0];
        e = conect[i][1];
        s--;
        e--;
        conect[i][0] = false;
        zw[s].push_back(i + 1);
        zw[e].push_back((i + 1) * (0 - 1));
    }
    string res(m, '0');
    vector<pair<int, int>> sizes(n);
    for (int i = 0; i < n; i++)
        sizes[i] = {zw[i].size(), i};
    sort(sizes.begin(), sizes.end());
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < sizes[i].first; j++) {
            if (!conect[abs(zw[sizes[i].second][j]) - 1][0] && zw[sizes[i].second][j] > 0)
                res[abs(zw[sizes[i].second][j]) - 1] = '1';
            conect[abs(zw[sizes[i].second][j]) - 1][0] = true;
        }
    }
    return res;
}
