#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long ll;

unordered_map<int, unordered_map<int, unordered_map<ll, bool>>> cache;
vector<ll> x;
vector<ll> y;
vector<int> result_a;
vector<int> result_b;

bool recur(int a, int b, ll summ, bool st)
{
    if (summ == 0 && !st)
    {
        return true;
    }
    if (a == -1 && b == -1)
    {
        return false;
    }
    if (cache.count(a) && cache[a].count(b) && cache[a][b].count(summ))
    {
        return cache[a][b][summ];
    }
    if (a == -1)
    {
        if (recur(a, b - 1, summ - y[b], false))
        {
            result_b.push_back(b);
            return true;
        }
    }
    else if (b == -1)
    {
        if (recur(a - 1, b, summ + x[a], false))
        {
            result_a.push_back(a);
            return true;
        }
    }
    else
    {
        if (recur(a, b - 1, summ - y[b], false))
        {
            result_b.push_back(b);
            return true;
        }
        if (recur(a - 1, b, summ + x[a], false))
        {
            result_a.push_back(a);
            return true;
        }
    }
    if (!cache.count(a))
    {
        cache[a] = unordered_map<int, unordered_map<ll, bool>>();
    }
    if (!cache[a].count(b))
    {
        cache[a][b] = unordered_map<ll, bool>();
    }
    cache[a][b][summ] = false;
    return false;
}

int main()
{
    int n, m;
    cin >> n;
    x.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    cin >> m;
    y.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> y[i];
    recur(n - 1, m - 1, 0, true);
    if (result_a.size() == 0)
        throw(0);
    cout << result_a.size() << '\n';
    for (int i = 0; i < result_a.size(); ++i)
        cout << result_a[i] << ' ';
    cout << '\n';
    cout << result_b.size() << '\n';
    if (result_b.size() == 0)
        throw(0);
    for (int i = 0; i < result_b.size(); ++i)
        cout << result_b[i] << ' ';
    cout << '\n';
    return 0;
}