#include<iostream>
#include<string>
#include <vector>
#include <bits/stdc++.h>

using namespace std;

int x;
vector<pair<int, int>> edges;
vector<int> adj[500];
bool hasCycle = false;

void addOne(string &s) {
    s[0]++;
    int i = 0;
    while(s[i] > '1') {
        s[i] = '0';
        s[i+1]++;
        i++;
    }
}

void check(int v, vector<bool> vect) {
    if(hasCycle) return;
    if(vect[v]) {
        hasCycle = true;
        return;
    }
    vect[v] = true;
    for(int i = 0; i < adj[v].size(); i++) check(adj[v][i], vect);
}

bool brute(string s) {
    hasCycle = false;
    vector<int> a[500];
    for(int i = 0; i < edges.size(); i++) {
        if(s[i] == '0') a[edges[i].first].push_back(edges[i].second);
        else a[edges[i].second].push_back(edges[i].first);
    }
    swap(a, adj);
    vector<bool> v(x+1, false);
    check(1, v);
    return hasCycle;
}

string find_reverse (int N, int M, int con[][2]) {
    x = N;
    string res = "";
    for(int i = 0; i < M; i++) {
        res += "0";
        edges.push_back({con[i][0], con[i][1]});
    }
    while(brute(res)) {
        addOne(res);
//        cout << res << endl;
    }
    return res;
}