#include <bits/stdc++.h>

using namespace std;

void addOne(string &s) {
    s[0]++;
    int i = 0;
    while(s[i] > '1') {
        s[i] = '0';
        s[i+1]++;
        i++;
    }
}

bool comp(pair<int, string> &a, pair<int, string> &b) {
    return a.first < b.first;
}

int bs(int x, vector<pair<int, string>> v) {
    int l = 0, r = v.size()-1;
    while(r >= l) {
        int mid = (r+l)/2;
        if(v[mid].first == x) return mid;
        if(v[mid].first < x) l = mid+1;
        else r = mid-1;
    }
    return -1;
}

int main() {
    int n, m;
    cin >> n;
    vector<int> vn(n);
    for(int i = 0; i < n; i++) cin >> vn[i];
    cin >> m;
    vector<int> vm(m);
    for(int i = 0; i < m; i++) cin >> vm[i];
    vector<pair<int, string>> suns((1<<n), {0, ""});
    vector<pair<int, string>> sums((1<<m), {0, ""});
    string s = "";
    for(int i = 0; i < n; i++) s += "0";
    for(int i = 0; i < (1<<n); i++) {
        addOne(s);
        for(int j = 0; j < n; j++) {
            if(s[j] == '1') suns[i].first += vn[j];
        }
        suns[i].second = s;
    }
    s = "";
    for(int i = 0; i < m; i++) s += "0";
    for(int i = 0; i < (1<<m); i++) {
        addOne(s);
        for(int j = 0; j < m; j++) {
            if(s[j] == '1') sums[i].first += vm[j];
        }
        sums[i].second = s;
    }
//    for(int i = 0; i < suns.size(); i++) cout << suns[i].first << " ";
//    cout << endl;
//    for(int i = 0; i < sums.size(); i++) cout << sums[i].first << " ";
//    cout << endl;
    sort(suns.begin(), suns.end(), comp);
    sort(sums.begin(), sums.end(), comp);
    string ans1, ans2;
    int p = 0, q = 0;
    for(int i = 0; i < suns.size(); i++) {
        if(suns[i].first == 0) continue;
        if(bs(suns[i].first, sums) != -1) {
            ans1 = suns[i].second;
            ans2 = sums[bs(suns[i].first, sums)].second;
        }
    }
    for(int i = 0; i < ans1.size(); i++) p += ans1[i]-48;
    for(int i = 0; i < ans2.size(); i++) q += ans2[i]-48;
    cout << p << "\n";
    for(int i = 0; i < ans1.size(); i++) if(ans1[i] == '1') cout << i << " ";
    cout << "\n" << q << "\n";
    for(int i = 0; i < ans2.size(); i++) if(ans2[i] == '1') cout << i << " ";
    return 0;
}
