#include <iostream>
#include <unordered_map>
#define MN 2007171
using namespace std;
int n, m, A[MN], B[MN], SA[MN], SB[MN], pa, pb;

int solve(int val) {
    long long sum = 0, p1 = 1, p2 = 1;
    pa = pb = 0;
    while(p1 <= n || p2 <= m) {
        if((sum <= 0) && p1 <= n) {
            ///luam ceva random din A
            if(rand() % val == 0) {
                sum += A[p1];
                SA[++pa] = p1;
            }
            ++p1;
        } else if((sum >= 0) && p2 <= m) {
            if(rand() % val == 0) {
                sum -= B[p2];
                SB[++pb] = p2;
            }
            ++p2;
        } else break;
        if(!sum && pa) break;
    }
    if(!sum && pa) {
        cout << pa << "\n";
        for(int i = 1; i <= pa; ++i) cout << SA[i] - 1 << " ";
        cout << "\n";
        cout << pb << "\n";
        for(int i = 1; i <= pb; ++i) cout << SB[i] - 1 << " ";
        cout << "\n";
        exit(0);
    }
    return 0;
}
unordered_map<int, int> PA;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    cin >> n;
    for(int i = 1; i <= n; ++i) cin >> A[i], PA[A[i]] = i;
    cin >> m;
    /// FFT ?
    for(int j = 1; j <= m; ++j) {
        cin >> B[j];
        if(PA[B[j]]) {
            cout << "1\n" << PA[B[j]]-1 << "\n" << "1\n" << j-1 << "\n";
            return 0;
        }
    }
    while(1){
        for(int i = 1; i <= 20; ++i) solve(i);
        for(int i = 40; i <= 60; ++i) solve(i);
        for(int i = 250; i <= 260; ++i) solve(i);
    }
    return 0;
}
