#include<iostream>
#include<vector>
#include<queue>
#include<string>
#include<algorithm>
using namespace std;

//extern std::string find_reverse(int, int, int[][2]);


string to_binary_string(int n) {
    string ans = "";
    while (n) {

        if (n & 1) {
            ans += "1";
        }
        else ans += "0";

        n >>= 1;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}


vector<int> solution;
void bfs(int V, vector<vector<pair<int, pair<int, int>>>>& graph, vector<int>& seen, vector<bool>& used) {
    if (seen[V]) return;
    seen[V] = 1;
    queue<int> q;
    q.push(V);
    while (!q.empty()) {
        int v = q.front(); q.pop();
        //do stuff;
        for (auto u : graph[v]) {
            if (used[u.second.first]) continue;
            used[u.second.first] = true;
            solution[u.second.first] = u.second.second;
            q.push(u.first);
        }
    }
}


string find_reverse(int n, int m, int connections[][2]) {
         vector<vector<int>> graph(m);
         solution.resize(m);
        for (int i = 0; i < m; i++) {
            graph[i] = { connections[i][0], connections[i][1] };
        }


        bool good = 1;
        vector<vector<pair<int, pair<int, int>>>> graph_list(n + 1);
        for(int i = 0; i < m; i++){
            graph_list[graph[i][0]].push_back({ graph[i][1], {i, 1} });
            graph_list[graph[i][1]].push_back({ graph[i][0], {i, 0} });
        }
        vector<int> seen(n + 1, 0);
        vector<bool> used(m);
        bfs(1, graph_list, seen, used);
 
        string ans = "";
        for (int i = 0; i < m; i++) {
            ans += to_string(solution[i]);
        }
        
        
        return ans;
    }

