#include<bits/stdc++.h>
using namespace std;
const int MAXN = 5e5;
vector <pair <int, int>> g[MAXN];
int topsort[MAXN];
vector <bool> used(MAXN, false);
int q = 0;
void dfs(int v)
{
    used[v] = true;
    for (auto [u, id] : g[v])
    {
        if (!used[u])
            dfs(u);
    }
    topsort[q] = v;
    q++;
}
string find_reverse(int n, int m, int connections[][2])
{
string ans;
ans.resize('0', m);
for (int i = 0; i < m; i++)
{
    connections[i][0]--;
    connections[i][1]--;
    g[connections[i][0]].push_back({connections[i][1], i});
}
for (int i = 0; i < n; i++)
{
    if (!used[i])
        dfs(i);
}
for (int i = n; i >= 0; i--)
{
    int v = topsort[i];
    used[v] = false;
    for (auto [u, id] : g[v])
    {
        if (used[u])
            ans[id] = '1';
    }
}
return ans;
}

/*
6 12
1 2
1 5
2 3
2 5
3 4
3 6
4 1
4 5
5 3
5 6
6 1
6 4*/
