#include <bits/stdc++.h>
using namespace std;
vector<vector<int>> matrix;
vector<vector<float>> history;

float smaler(int x, int y){
    float s = 0;
    for(int i = 0; i < history.size(); ++i){
        if(history[i][0] == x and history[i][1] > y){
            s += history[i][2];
        }
    }
    return s;
}

float err_left(int n, int m, int x, int y){
    int i = x-1, j = y+1;
    float s = 0;
    while(i>=0 and j!=m and matrix[i][j]!=1){
        matrix[i][j]=1;
        s += smaler(i,j);
        --i;
        ++j;
    }
    if(j!=m){
        j--;
        i++;
        if(matrix[i][j] == 1 and i!=0){
            return (m-j)*(m-j)-s;
        }
        return (m-y)*(m-y)/2 - ((x-i)*(x-i)/2 + (x-i)*(m-j))-s;
    }
    else{
        return 0+s;
    }
}

float err_right(int n, int m, int x, int y){
    int i = x+1, j = y+1;
    float s = 0;
    while(i<=n and j!=m and matrix[i][j]!=1){
        matrix[i][j]=1;
        s += smaler(i,j);
        ++i;
        ++j;
    }
    if(matrix[i][j] == 1){
        return (m-j)*(m-j)-s;
    }
    else if(j!=m){
        i--;
        j--;
        return x*y/2 - ((i-x)*(i-x)/2 + (i-x)*(j-y))-s;
    }
    else{
        return 0+s;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q, x, y;
    cin >> n >> m >> q;
    float s = n*m;
    matrix.resize(n+1,vector<int>(m+1,10e7));
    for(int i = 0; i < q; ++i){
        cin >> x >> y;
        float x1 = x, y1=y,st;
        matrix[x][y]=1;
        st = (m-y)*(m-y) + err_left(n, m, x, y) + err_right(n, m, x, y);
        s = s - st;
        history.push_back({x1,y1,st});
        cout << fixed << setprecision(2) << s << endl;
    }
}