#include <string>
#include <iostream>
#include <vector>
using namespace std;

static const int MAXN = 5e5;
static string ans;
static vector<pair <int, int>> g[MAXN];
static int tin[MAXN];
static int tmr;

void dfs(int v) {
    tin[v] = ++tmr;
    for(auto to : g[v]) {
        if(!tin[to.first]) {
            ans[to.second] = '0';
            dfs(to.first);
        } else ans[to.second] = '1';
    }
}

string find_reverse(int N, int M, int connections[][2]) {
    ans.resize(M);
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        g[v].push_back(make_pair(u, i));
    }
    dfs(0);
    return ans;
}
