#include <string>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;
const int MAXN = 5e5;
string ans;
vector<int> g[MAXN];
int deg[MAXN];
int tin[MAXN];
int tmr;

string find_reverse(int N, int M, int connections[][2]) {
    ans.resize(M);
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;--v;
        ///deg[u]++;
        deg[v]++;
        g[u].push_back(v);
        ///g[v].push_back(u);
    }
    queue <int> q;
    tin[0] = ++tmr;
    q.push(0);
    while(!q.empty()) {
        v = q.front();
        q.pop();
        for(auto to : g[v]) {
            deg[to]--;
            if(deg[to] == 0) {
                tin[to] = ++tmr;
                q.push(to);
            }
        }
    }
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        ans[i] = (tin[u] < tin[v]) + '0';
    }
    return ans;
}

static const int MAXM=1.5e6;
static int connections[MAXM][2];
int main () {
    int n,m;
    n = 5e5;
    m = MAXM;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        connections[i][0] = (rand()) % n;
        connections[i][1] = (rand()) % n;
        while(connections[i][0] == connections[i][1]) {
            connections[i][1] = rand() % n;
        }
        cin >> connections[i][0] >> connections[i][1] ;
        ///+ 0ll + ((rand() * 1ll) << 15)
    }
    string ans=find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
    return 0;
}
/**
6 12
1 2
1 5
2 3
2 5
3 4
3 6
4 1
4 5
5 3
5 6
6 1
6 4
*/
