#include <string>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;
const int MAXN = 5e5;
string ans;
vector<int> g[MAXN];
int deg[MAXN];
int tin[MAXN];
int tmr;

string find_reverse(int N, int M, int connections[][2]) {
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;--v;
        ///deg[u]++;
        deg[v]++;
        g[u].push_back(v);
        ///g[v].push_back(u);
    }
    queue <int> q;
    tin[0] = ++tmr;
    q.push(0);
    while(!q.empty()) {
        v = q.front();
        q.pop();
        for(auto to : g[v]) {
            if(--deg[to] == 0) {
                tin[to] = ++tmr;
                q.push(to);
            }
        }
    }
    ans.resize(M);
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        ans[i] = (tin[u] < tin[v]) + '0';
    }
    return ans;
}
