#include <iostream>
#include <unordered_map>
#include <algorithm>
using namespace std;

const int MAXN = 1e6 + 30;
pair <int, int> was[MAXN];
bool touch[MAXN];
int a[MAXN], b[MAXN];

int main() {
    int n, m;
    cin >> n;
    long long  s1 = 0;
    for(int i = 1; i <= n; ++i) cin >> a[i], s1 += a[i];
    cin >> m;
    for(int i = 1; i <= m; ++i) cin >> b[i], s1 -= b[i];
    if(s1 > 0) {
        was[0] = make_pair(0, 0);
        touch[0] = 1;
        int ptr = 1;
        int dif = a[1];
        for(int i = 1; i <= m; ++i) {
            dif -= b[i];
            while(ptr <= n && dif < 0) {
                ++ptr;
                dif += a[ptr];
            }
            if(dif < 0) break;
            if(touch[dif]) {
                int l1 = was[dif].first;
                int l2 = was[dif].second;
                cout << ptr - l1 << '\n';
                for(int j = l1 + 1; j <= ptr; ++j) cout << j - 1 << ' ';
                cout << '\n';
                cout << i - l2 << '\n';
                for(int j = l2 + 1; j <= i; ++j) cout << j - 1 << ' ';
                return 0;
            }
            touch[dif] = 1;
            was[dif] = make_pair(ptr, i);
        }
    } else {
        was[0] = make_pair(0, 0);
        touch[0] = 1;
        int ptr = 1;
        int dif = b[1];
        for(int i = 1; i <= n; ++i) {
            dif -= a[i];
            while(ptr <= m && dif < 0) {
                ++ptr;
                dif += b[ptr];
            }
            if(dif < 0) break;
            if(touch[dif]) {
                int l1 = was[dif].first;
                int l2 = was[dif].second;
                cout << i - l2 << '\n';
                for(int j = l2 + 1; j <= i; ++j) cout << j - 1 << ' ';
                cout << '\n';
                cout << ptr - l1 << '\n';
                for(int j = l1 + 1; j <= ptr; ++j) cout << j - 1 << ' ';
                return 0;
            }
            touch[dif] = 1;
            was[dif] = make_pair(ptr, i);
        }
    }
    return 0;
}
