#pragma GCC target("avx,avx2,avx512f,sse2,sse3,ssse3,sse4,sse4.2,tune=native")
#pragma GCC optimization ("O3,unroll-loops,fast-math")
#include <bits/stdc++.h>
using namespace std;
string find_reverse (int n, int m, int connections[][2]) {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    vector<vector<int>> g(n);
    vector<unordered_set<int>> fin_g(n);
    vector<int> dist(n, 1e9 + 7);
    string ans;
    queue<pair<int, int>> q;
    for (int i = 0; i < m; ++i) {
        g[--connections[i][0]].push_back(--connections[i][1]);
        g[connections[i][1]].push_back(connections[i][0]);
    }
    q.push({0, 0});
    while (!q.empty()) {
        int v = q.front().first;
        int layer = q.front().second;
        q.pop();
        dist[v] = 0;
        for (auto ee : g[v]) {
            if (dist[ee] > dist[v] + 1) {
                dist[ee] = dist[v] + 1;
                q.push({ee, layer + 1});
            }
            if (layer & 1) {
                fin_g[v].erase(ee);
                fin_g[ee].insert(v);
            }
            else {
                fin_g[ee].erase(v);
                fin_g[v].insert(ee);
            }
        }
    }
    ans.clear();
    for (int i = 0; i < m; ++i) {
        if (fin_g[connections[i][0]].contains(connections[i][1]))
            ans.push_back('0');
        else
            ans.push_back('1');
    }
    return ans;
}