
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <cassert>
#include <fstream>
#include <queue>
#include <set>
#include <map>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <random>

using namespace std;
//mt19937 rnd(time(228));
#define ll long long
#define dl double
#define int long long
#define pii pair<int, int>
#define sz(a) (int)a.size()
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 300 * 300 + 1;

void q(vector<vector<int>> &dp, vector<vector<int>> &p, vector<int> &a, vector<int> &pos) {
    dp[0][0] = 1, p[0][0] = -1;
    int n = sz(a), s1 = sz(dp[0]) - 1;
    for (int i = 0; i < n; ++i) dp[i][a[i]] = 1, p[i][a[i]] = i;
    for (int i = 1; i < n; ++i) {
        for (int w = 0; w <= s1; ++w) {
            dp[i][w] = dp[i - 1][w];
            p[i][w] = p[i - 1][w];
            if (w >= a[i] && dp[i][w] < dp[i - 1][w - a[i]]) {
                dp[i][w] = dp[i - 1][w - a[i]];
                p[i][w] = i;
            }
            if (dp[i][w] && pos[w] == -1)pos[w] = p[i][w];
        }
    }
}

void find_way(vector<vector<int>> &dp, vector<vector<int>> &p, vector<int> &a, int w, int st) {
    vector<int> way;
    while (st != -1) {
        way.push_back(st);
        if (p[st][w] == st)w -= a[st];
        st = p[st][w];
    }
    reverse(all(way));
    cout << sz(way) << '\n';
    for (int v: way)cout << v << ' ';
    cout << '\n';
}

void solve(int n, int m, int s1, int s2, vector<int> a, vector<int> b) {
    vector<vector<int>> aa(n, vector<int>(s1 + 1)), pa(n, vector<int>(s1 + 1));
    vector<vector<int>> bb(m, vector<int>(s2 + 1, -1)), pb(m, vector<int>(s2 + 1, -1));
    vector<int> pos_a(s1 + 1, -1), pos_b(s2 + 1, -1);
    q(aa, pa, a, pos_a), q(bb, pb, b, pos_b);
    int s = min(s1, s2);
    int sa = -1, sb = -1, w = 0;
    for (int i = 1; i <= s; ++i) {
        if (pos_a[i] != -1 && pos_b[i] != -1) {
            sa = pos_a[i];
            sb = pos_b[i];
            w = i;
            break;
        }
    }
    find_way(aa, pa, a, w, sa);
    find_way(bb, pb, b, w, sb);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n;
    vector<int> a(n);
    int s1 = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s1 += a[i];
    }
    cin >> m;
    vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        s2 += b[i];
    }
    if ((n + m) * (n * m) <= 4000000) {
        solve(n, m, s1, s2, a, b);
        return 0;
    }
    vector<vector<int>> ka(m + 1), kb(n + 1);
    for (int i = 0; i < n; ++i) {
        ka[a[i]].push_back(i);
    }
    for (int i = 0; i < m; ++i) {
        kb[b[i]].push_back(i);
    }
    for (int i = 1; i <= min(n, m); ++i) {
        if (!ka[i].empty() && !kb[i].empty()) {
            cout << "1\n" << ka[i].back() << '\n';
            cout << "1\n" << kb[i].back() << '\n';
            return 0;
        }
    }
    return 0;
}