#include <bits/stdc++.h>

using namespace std;

//mt19937 rnd(228);

#define ll long long
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const int infI = 1e9 + 7;
const ll infL = 1e18;
const int maxN = 500001;

vector<pair<int, int>> gr[maxN];
int tops[maxN], idx = 0;

bool used[maxN], was[maxN];

void dfs(int v) {
    used[v] = true;
    for (auto to : gr[v]) {
        if (!used[to.first]) {
            dfs(to.first);
        }
    }
    tops[idx++] = v;
}

string find_reverse(int N, int M, int connections[][2]) {
    for (int i = 0; i < M; ++i) {
        gr[connections[i][0]].emplace_back(connections[i][1], i);
    }
    for (int i = 1; i <= N; ++i) {
        if (!used[i])
            dfs(i);
    }
    string ans;
    ans.resize(M);
    for (int i = 0; i < N; ++i) {
        int v = tops[i];
        was[v] = true;
        for (auto to : gr[v]) {
            if (!was[to.first])
                ans[to.second] = '1';
            else
                ans[to.second] = '0';
        }
    }
    return ans;
}