#include <bits/stdc++.h>

//mt19937 rnd(228);

#define ll long long
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const int infI = 1e9 + 7;
const ll infL = 1e18;
const int maxN = 500000;

std::vector<std::pair<int, int>> gr[maxN];
std::vector<int> tops;
int place[maxN];

bool used[maxN];

inline void dfs(int v) {
    used[v] = true;
    for (auto[to, i] : gr[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tops.push_back(v);
}

std::string find_reverse(int N, int M, int connections[][2]) {
    for (int i = 0; i < M; ++i) {
        int v = connections[i][0];
        int u = connections[i][1];
        --v, --u;
        gr[v].emplace_back(u, i);
    }
    for (int i = 0; i < N; ++i) {
        if (!used[i])
            dfs(i);
    }
    for (int i = 0; i < N; ++i) {
        place[tops[i]] = i;
    }
    std::string ans;
    ans.resize(M);
    for (int i = 0; i < M; ++i) {
        ans[i] = (place[connections[i][0]] < place[connections[i][1]] ? '1' : '0');
    }
    return ans;
}
