vi a[500002];
map<pii, bool> m1;
map<pii, int> m2;
bool used[500002];
set<pii> res, resLast;

void dfs(int x)
{
    used[x] = true;

    for (int i = 0; i < a[x].sz; i++)
    {
        if (used[a[x][i]])
        {
            if (!m1[{x, a[x][i]}] && !m1[{a[x][i], x}])
            {
                res.insert({ a[x][i], x });
                m1[{a[x][i], x}] = true;
                m1[{x, a[x][i]}] = true;
            }
            continue;
        }

        res.insert({ x, a[x][i] });

        m1[{a[x][i], x}] = true;
        m1[{x, a[x][i]}] = true;

        dfs(a[x][i]);
    }
}


string find_reverse(int n, int m, int connections[][2])
{
    for (int i = 0; i < m; i++)
    {
        a[connections[i][0]].pb(connections[i][1]);
        a[connections[i][1]].pb(connections[i][0]);
        m1.insert({ {connections[i][0], connections[i][1]}, false });
        m2.insert({ {connections[i][0], connections[i][1] }, i + 1 });
    }

    dfs(1);

    string s;
    s.resize(m);

    for (const auto& i : res)
    {
        auto x = m2[i];
        if (0 < x && x < 1500010)
        {
            s[x - 1] = '0';
        }
        else
        {
            s[m2[{i.ss, i.ff}] - 1] = '1';
        }
    }

    return s;
}