#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
using namespace std;
long long n,m;
int q,len;
long double x,y;
long long l,r,tt;
long double sum,ans,minp,maxh,lastp,lasth,tr,ll,rr;
struct node{
    long double pos,h;
    int kind;
    long long y;
    node *l,*r;
    node (long double pos,long double h,int kind,long long y){
        this->pos=pos;
        this->kind=kind;
        this->h=h;
        this->y=y;
        this->l=this->r=NULL;
    }
};
node *treap;
void split(node *curr,node* &l,node* &r,long double val){
    if(curr==NULL){
        l=NULL;
        r=NULL;
        return;
    }
    if(curr->pos<=val){
        l=curr;
        split(curr->r,l->r,r,val);
    }else{
        r=curr;
        split(curr->l,l,r->l,val);
    }
}
void mergev(node* &curr,node *l,node *r){
    if(l==NULL){
        curr=r;
        return;
    }
    if(r==NULL){
        curr=l;
        return;
    }
    if(l->y>r->y){
        curr=l;
        mergev(curr->r,l->r,r);
    }else{
        curr=r;
        mergev(curr->l,l,r->l);
    }
}
void insertv(long double pos,long double h,int kind){
    node *l,*r;
    split(treap,l,r,pos-0.01);
    node *tt=new node(pos,h,kind,64892);
    mergev(treap,l,tt);
    mergev(treap,treap,r);
}
void erasev(long double from,long double to){
    node *l,*r,*lt,*rt;
    split(treap,l,r,from-0.01);
    split(r,lt,rt,to);
    mergev(treap,l,rt);
}
long double calc(long double pt,long double h,int kind,long double pos){
    if(kind==0){
        return h-(pt-pos);
    }else{
        return h+(pt-pos);
    }
}
long double getval(node *curr,long double pos){
    if(pos<0.0 or pos>m)return m;
    if(curr==NULL)return 0.0;
    if(curr->l!=NULL and curr->l->pos>=pos){
        return getval(curr->l,pos);
    }else if(curr->pos>=pos){
        return calc(curr->pos,curr->h,curr->kind,pos);
    }else{
        return getval(curr->r,pos);
    }
}
long double zero;
long double getvall(node *curr,long double pos){
    return max(zero,getval(curr,pos));
}
void prnt(node *curr){
    if(curr->l!=NULL){
        prnt(curr->l);
    }
    cout<<setprecision(2)<<fixed<<curr->pos<<" "<<curr->h<<" "<<curr->kind<<"\n";
    if(curr->r!=NULL){
        prnt(curr->r);
    }
}
void calcsum(node *curr){
    if(curr->l!=NULL){
        calcsum(curr->l);
    }
    if(curr->kind==0 and lastp<curr->pos-curr->h){
        lastp=curr->pos-curr->h;
    }
    sum+=(lasth+curr->h)/2.0*(curr->pos-lastp);
    lasth=curr->h;
    lastp=curr->pos;
    if(curr->r!=NULL){
        calcsum(curr->r);
    }
}

long double a[1000007],lw[1000007],rw[1000007];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>m>>n>>q;

    if(m>1000000){
        minp=m;maxh=0.0;
        for(int i=1;i<=q;i++){
            cin>>x>>y;
            y=n-y;
            if(getvall(treap,x)>y){
                cout<<ans<<"\n";
                continue;
            }
            if(x-y<minp){
                minp=min(minp,max(x-y,zero));
                maxh=max(zero,y-x);
            }else if(x-y==minp){
                maxh=max(maxh,max(zero,y-x));
            }
            l=-1;r=x;
            while(l+1<r){
                tt=(l+r)/2;
                if(getvall(treap,tt)<=calc(x,y,0,tt)){
                    r=tt;
                }else{
                    l=tt;
                }
            }
            tr=r-0.5;
            if(tr>=0.0 and getvall(treap,tr)<=calc(x,y,0,tr)){
                rr=tr;
            }else{
                rr=r;
            }
            if(getvall(treap,rr)!=0.0){
                erasev(rr,x);
                insertv(rr,calc(x,y,0,rr),1);
            }else{
                erasev(rr+0.01,x);
            }
            
            l=x;r=m+1;
            while(l+1<r){
                tt=(l+r)/2;
                if(getvall(treap,tt)<=calc(x,y,1,tt)){
                    l=tt;
                }else{
                    r=tt;
                }
            }
            tr=l+0.5;
            if(tr<=m and getvall(treap,tr)<=calc(x,y,1,tr)){
                ll=tr;
            }else{
                ll=l;
            }
            erasev(x,ll);
            insertv(ll,calc(x,y,1,ll),1);
            insertv(x,y,0);
            sum=0;
            lastp=minp;
            lasth=maxh;
            calcsum(treap);
            ans=n*m-sum;
            cout<<setprecision(2)<<fixed<<ans<<"\n";
        }
    }else{
        for(int i=1;i<=q;i++){
            cin>>x>>y;y=n-y;
            for(int f=x;f>=1 and y-x+f>=1 and lw[f]<y-x+f-0.5;f--){
                sum-=a[f];
                lw[f]=y-x+f-0.5;
                if(lw[f]!=rw[f]){
                    a[f]=max(lw[f],rw[f]);
                }else{
                    a[f]=lw[f]+0.25;
                }
                sum+=a[f];
            }
            for(int f=x+1;f<=m and y-(f-1-x)>=1 and rw[f]<y-(f-1-x)-0.5;f++){
                sum-=a[f];
                rw[f]=y-(f-1-x)-0.5;
                if(lw[f]!=rw[f]){
                    a[f]=max(lw[f],rw[f]);
                }else{
                    a[f]=lw[f]+0.25;
                }
                sum+=a[f];
            }
            ans=n*m-sum;
            cout<<setprecision(2)<<fixed<<ans<<"\n";
        }
    }
    return 0;
}