#include <iostream>
#include <queue>
using namespace std;
const int maxn = 5e5+10, maxm = 15e5+10;

int in[maxn], last[maxn];
int tree_cnt;
int n, m;

struct edge {

    int pr, to;
    edge(){}
    edge(int from, int _to, int _ix, bool which) {

        pr = last[from];
        last[from] = _ix;
        to = _to;

    }

} v[2*maxm];

queue < int > q;
int dist[maxn];

string find_reverse(int N, int M, int connections[][2]) {

    fill(last+1, last+N+1, -1);

    n = N;
    m = M;
    for (int i = 0 ; i < m ; ++i) v[i] = edge(connections[i][0], connections[i][1], i, 0);
    for (int i = 0 ; i < m ; ++i) v[m+i] = edge(connections[i][1], connections[i][0], m+i, 0);
    
    string res(m, '0');
    for (int i = 1 ; i <= n ; ++i) {
    
        if (dist[i]) continue;

        q.push(i);
        dist[i] = 1;

        while (!q.empty()) {

            int top = q.front();
            q.pop();
            
            for (int edge_ix = last[top] ; edge_ix != -1 ; edge_ix = v[edge_ix].pr) {


                if (dist[v[edge_ix].to]) continue;
                dist[v[edge_ix].to] = dist[top]+1;

                in[v[edge_ix].to] = ++tree_cnt;
                q.push(v[edge_ix].to);

            }

        }
    
    }

    for (int i = 0 ; i < m ; ++i) {

        if (in[connections[i][0]] < in[connections[i][1]]) res[i] = '0';
        else res[i] = '1';

    }

    // cerr << "end graph:\n";
    // for (int i = 0 ; i < m ; ++i) {

    //     if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
    //     else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    // }

    return res;

}
