#include <iostream>
#include <algorithm>
using namespace std;
const int maxn = 1e6+10, maxlog = 20;

int a[maxn], n;
int b[maxn], m;

struct sums {

    long long sum;
    int l, r;
    sums(){

        sum = 0;

    }

    sums(long long _sum, int _l, int _r){

        sum = _sum;
        l = _l;
        r = _r;

    }

    inline friend bool operator < (sums x, sums y) {

        return x.sum < y.sum;

    }

} asums[maxn*maxlog], bsums[maxn*maxlog];

int acnt, bcnt;

void solve() {

    long long sum;
    for (int i = 1 ; i <= n ; ++i) {

        sum = 0;
        for (int j = i ; j <= min(n, i+20) ; ++j) {

            sum += a[j];
            asums[++acnt] = {sum, i, j};

        }

    }
    
    for (int i = 1 ; i <= m ; ++i) {

        sum = 0;
        for (int j = i ; j <= min(m, i+20) ; ++j) {

            sum += b[j];
            bsums[++bcnt] ={sum, i, j};


        }

    } 

    sort(asums+1, asums+acnt+1);
    sort(bsums+1, bsums+bcnt+1);

    int l = 1;
    for (int i = 1 ; i <= acnt ; ++i) {

        while (bsums[l].sum < asums[i].sum) ++l;
        if (asums[i].sum == bsums[l].sum) {

            cout << asums[i].r - asums[i].l+1 << '\n';
            for (int curr = asums[i].l ; curr <= asums[i].r ; ++curr)
                cout << curr << ' ';
            cout << '\n';
            cout << bsums[l].r - bsums[l].l+1 << '\n';
            for (int curr = bsums[l].l ; curr <= bsums[l].r ; ++curr)
                cout << curr << ' ';
            cout << '\n';
            return;


        }

    }

    exit(-1);

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

void read() {

    cin >> n;
    for (int i = 1 ; i <= n ; ++i) cin >> a[i];

    cin >> m;
    for (int i = 1 ; i <= m ; ++i) cin >> b[i];

}

int main () {

    fast_io();
    read();
    solve();

    return 0;

}