#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1000000 + 10;
const int MAXSUM = 2e2 + 8;
int n, m;
int a[MAXN];
int b[MAXN];
int s1[MAXSUM] = {1};
int s2[MAXSUM] = {1};
int u1[MAXSUM] = {1};
int u2[MAXSUM] = {1};
int R1 = 0, R2 = 0;

void solve (int ind1, int ind2)
{
//    cerr << ind1 << " " << ind2 << endl;
    vector <int> seq1;
    vector <int> seq2;

    while (ind1 != 0)
    {
        seq1.push_back(u1[ind1]-1);
        ind1 = s1[ind1];
    }
    while (ind2 != 0)
    {
        seq2.push_back(u2[ind2]-1);
        ind2 = s2[ind2];
    }

    cout << seq1.size() << endl;
    for (int i = 0; i < seq1.size(); i++)
        cout << seq1[i] << " ";
    cout << endl;

    cout << seq2.size() << endl;
    for (int i = 0; i < seq2.size(); i++)
        cout << seq2[i] << " ";
    cout << endl;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    cin >> m;
    for (int j = 1; j <= m; j++)
        cin >> b[j];

    memset(s1, -1, sizeof(s1));
    memset(s2, -1, sizeof(s2));
    s1[0] = 0;
    s2[0] = 0;

    for (int i = 1; i <= n; i++)
    {
        R1 += a[i];
        R1 = min(R1, MAXSUM);
        for (int j = R1; j - a[i] >= 0; j--)
        {
            if (s1[j] == -1 && s1[j - a[i]] >= 0)
            {
                s1[j] = j - a[i];
                u1[j] = i;
            }
        }

    }

    for (int i = 1; i <= m; i++)
    {
        R2 += b[i];
        R2 = min(R2, MAXSUM);
        for (int j = R2; j - b[i] >= 0; j--)
        {
            if (s2[j] == -1 && s2[j - b[i]] >= 0)
            {
                s2[j] = j - b[i];
                u2[j] = i;
            }
        }
    }

//    for (int i = 0; i <= R1; i++)
//        cerr << s1[i] << " ";
//        cerr << endl;
//    for (int i = 0; i <= R2; i++)
//        cerr << s2[i] << " ";
//        cerr << endl;

    for (int i = 1; i <= min(R1, R2); i++)
    {
        if (s1[i] != -1 && s2[i] != -1)
        {
            solve(i, i);
            return 0;
//cerr << endl << endl;
        }
    }

    return 0;
}

/**
5
2 3 3 2 3
3
4 5 5


3
1 2 4
2
0 1
*/
