#include <bits/stdc++.h>
#include <ios>
#define endl '\n'

int n, m, a, b;
int queries;
int height[1000001];
long double prefix[1000001];

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(NULL);
  std::cout.tie(NULL);
  std::cin >> n >> m;
  std::cin >> queries;
  for (int i = 0; i <= n; ++i) {
    height[i] = m;
    prefix[i] = i * m;
  }
  for (int q = 0; q < queries; ++q) {
    std::cin >> a >> b;
    for (int x = std::max(a - (m - b) + 1, 0); x < a; ++x) {
      height[x] = std::min(height[x], -x + b + a);
    }
    for (int x = a; x <= std::min(n, a + m - b); ++x) {
      height[x] = std::min(height[x], x + b - a);
    }
    for (int x = std::max(a - (m - b) + 1, 1); x <= n; ++x) {
      prefix[x] = prefix[x - 1] + 0.5 * (height[x] + height[x - 1]);
    }
    std::cout << std::fixed << std::setprecision(2) << prefix[n] << endl;
  }
  return 0;
}
