#include<iostream>
#include<vector>
using namespace std;

const int MAXM = 1e7;
vector <int> a[MAXM];
vector <pair<int, int>> ans;
int used[MAXM];

void DFS(int u, int p)
{
    used[u] = 1;
    used[0]++;
    for (int i=0; i<a[u].size(); i++)
    {
        int v = a[u][i];
        if (used[v] == 0) DFS(v, u);
        else if (p != v)  ans.push_back({u, v});
    }
}

std::string find_reverse (int N, int M, int connections[][2])
{
    string otg = "";
    for (int i=0; i<M; i++)
        a[connections[i][0]].push_back(connections[i][1]);
    int i = 1;
    while (used[0] != N)
        if (used[i] == 0) DFS(i, 0);
    for (int i=0; i<M; i++)
    {
        for (int j=0; j<ans.size(); j++)
            if (connections[i][0] == ans[j].first && connections[i][1] == ans[j].second) { otg += '1'; break; }
        if (otg.size() != i + 1) otg += '0';
    }
    return otg;
}
