#include<bits/stdc++.h>
using namespace std;

const int maxn=500004;

vector< pair <int, int > > nbrs[maxn];

bool on_route[maxn], vis[maxn], has_cycle=false;
bool obr[maxn];
vector <int> curr;
int seg=-1;

void cycle(int x){
	vis[x]=true;
	on_route[x]=true;

	for(int i=0; i<nbrs[x].size(); i++){
		if(!obr[nbrs[x][i].second] or nbrs[x][i].second==-1 ){
			int next=nbrs[x][i].first;
			if(!vis[next]){
				curr.push_back(nbrs[x][i].second);
				cycle(next);
			}else{
				if(on_route[next] and !has_cycle){
					curr.push_back(nbrs[x][i].second);
					has_cycle=true;
				
					/*cerr<<"found cycle: "<<endl;
					for(int j=0; j<curr.size(); j++){
						cerr<<curr[j]<<" ";
					}*/

					for(int j=0; j<curr.size(); j++){
						if(!obr[ curr[j] ]){
							obr[ curr[j] ]=true;
							seg=curr[j];
							return;
						}
					}
				}
			}
		}
	}
	on_route[x]=false;
	curr.pop_back();
}

string find_reverse(int n, int m, int con[][2]){
	string ans;

	for(int i=0; i<m; i++){
		nbrs[ con[i][0] ].push_back({con[i][1], i});
		ans+='0';
		obr[i]=false;
	}
	//cerr<<"NACHALO: "<<endl;
	//cerr<<"ans="<<ans<<endl;

	has_cycle=false;
	do{
		for(int i=1; i<=n; i++){
			vis[i]=false;
			on_route[i]=false;
		}
		for(int i=1; i<=n; i++){
			if(!vis[i]){
				seg=-1;
				has_cycle=false;
				curr.clear();
				cycle(i);
				if(has_cycle){
					//cerr<<"has cycle from "<<i<<endl;
					ans[seg]='1';
					int from=con[seg][0];
					int to=con[seg][1];
					
					//remove and push other way
					
					nbrs[to].push_back({from, -1});

					//cerr<<"seg="<<seg<<endl;
					//cerr<<"ans="<<ans<<endl;
					break;
				}
			}
		}

	}while(has_cycle);
	
	return ans;

}

