#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll Size=1e6+1;
ll depth[Size];
bool visited[Size];
vector<pair<ll,ll>> adj[Size];
queue<ll> to_process;
string ans;

void bfs(ll start_node){
    to_process.push(start_node);
    while(!to_process.empty()){
        ll curr_node=to_process.front();
        to_process.pop();
        visited[curr_node]=true;
        for(auto itr:adj[curr_node]){
            if(!visited[itr.first]){
                depth[itr.first]=depth[curr_node]+1;
                to_process.push(itr.first);
            }else{
                if(depth[curr_node]>depth[itr.first]){
                    ans[itr.second]='1';
                }
            }
        }
    }
}

string find_reverse(ll n, ll m, ll connections[][2]){
    while(ans.size()<m){
        ans+='0';
    }
    for(ll i=0;i<m;i++){
        adj[connections[i][0]].push_back({connections[i][1],i});
    }
    depth[1]=0;
    bfs(1);
    return ans;
}

