#include <iostream>
#include <map>
using namespace std;
pair<int, int> intersect(int a, int b) {
    return {(a - b) / 2, (a + b) / 2};
}
///a = x + y; b = y - x slopes

int main () {
    multimap<int, int> left_slope;
    /// min x + y
    multimap<int, int> right_slope;
    /// max x - y -> min y - x


    int m, n;
    cin >> n >> m;
    int q;
    cin >> q;
    pair<int, int> covers_all = {0, m};
    double s = n * m;
    int x, y;
    cin >> x >> y;
    covers_all = {x, y};
    s = n * m - (m - y) * (m - y);
    left_slope.insert({x + y, y});
    right_slope.insert({y - x, y});
    cout << s << " ";
    if (x + y < m) {
        double add = (m - (x + y)) * (m - (x + y));
        add /= 2;
        s += add;
    }
    if (x - y > n - m) {
        double add = (y + (n - x)) * (y + (n - x));
        add /= 2;
        s += add;
            }
    for (int j = 1; j < q; j++) {
        cin >> x >> y;
        if (y <= covers_all.second && x - y >= covers_all.first - covers_all.second && x + y <= covers_all.first + covers_all.second) {
            covers_all = {x, y};
            s = n * m - (m - y) * (m - y);
            if (x + y < m) {
                double add = (m - (x + y)) * (m - (x + y));
                add /= 2;
                s += add;
            }
            if (x - y > n - m) {
                double add = (y + (n - x)) * (y + (n - x));
                add /= 2;
                s += add;
            }
            left_slope.clear();
            right_slope.clear();
            left_slope.insert({x + y, y});
            right_slope.insert({y - x, y});
            cout << s;
            if (j != q - 1) {
                cout << " ";
            }
            continue;
        }
        bool covered = false;
        for (auto curr : left_slope) {
            if (curr.first <= x + y && curr.second <= y && curr.second - (curr.first - curr.second) <= y - x) {
                covered = true;
                break;
            }
        }
        if (covered) {
            cout << s;
            if (j != q - 1) {
                cout << " ";
            }
            continue;
        }
//        for (auto curr : right_slope) {
//            if (curr.first <= y - x && curr.second <= y && curr.second - (curr.first - curr.second) <= x + y) {
//                covered = true;
//                break;
//            }
//        }
//        if (covered) {
//            cout << "second_right: " << s;
//            if (j != q - 1) {
//                cout << " ";
//            }
//            continue;
//        }
        double sub = (m - y) * (m - y);
        s -= sub;
        pair<int, int> cross_left = {-1, -1}, cross_right = {-1, -1};
        bool crossed_left = false, crossed_right = false;
        for (auto curr_left : left_slope) {
            cross_left = intersect(curr_left.first, y - x);
            if (cross_left.second >= curr_left.second && cross_left.second > y && cross_left.second <= m) {
                double add = (m - cross_left.second) * (m - cross_left.second);
                s += add;
                crossed_left = true;
                break;
            }
        }
        for (auto curr_right : right_slope) {
            cross_right = intersect(x + y, curr_right.first);
            if (cross_right.second >= curr_right.second && cross_right.second > y && cross_right.second <= m) {
                double add = (m - cross_left.second) * (m - cross_left.second);
                s += add;
                crossed_right = true;
                break;
            }
        }
        if (crossed_left && crossed_right) {
            pair<int, int> double_cross = intersect(cross_right.first + cross_right.second, cross_left.second - cross_left.first);
            if (double_cross.second <= m) {
                double sub = (m - double_cross.second) * (m - double_cross.second);
                s -= sub;
            }
        }
        if (x + y < m) {
            double add = (m - (x + y)) * (m - (x + y));
            add /= 2;
            s += add;
        }
        if (x - y > n - m) {
            double add = (y + (n - x)) * (y + (n - x));
            add /= 2;
            s += add;
        }
        if (crossed_left) {
            if (cross_left.first + cross_left.second < m) {
                double sub = (m - (cross_left.first + cross_left.second)) * (m - (cross_left.first + cross_left.second));
                sub /= 2;
                s -= sub;
            }
            if (cross_left.first - cross_left.second > n - m) {
                double sub = (cross_left.second + (n - cross_left.first)) * (cross_left.second + (n - cross_left.first));
                sub /= 2;
                s -= sub;
            }
        }
        if (crossed_right) {
            if (cross_right.first + cross_right.second < m) {
                double sub = (m - (cross_right.first + cross_right.second)) * (m - (cross_right.first + cross_right.second));
                sub /= 2;
                s -= sub;
            }
            if (cross_right.first - cross_right.second > n - m) {
                double sub = (cross_right.second + (n - cross_right.first)) * (cross_right.second + (n - cross_right.first));
                sub /= 2;
                s -= sub;
            }
        }
        for (auto curr : left_slope) {
            if (curr.first >= x + y && curr.second >= y && curr.second - (curr.first - curr.second) >= y - x) {
                int nx = (curr.first - curr.second), ny = curr.second;
                s += (m - ny) * (m - ny);
                for (auto curr_left : left_slope) {
                    if (curr_left.first == nx + ny && curr_left.second == ny) {
                        continue;
                    }
                    cross_left = intersect(curr_left.first, ny - nx);
                    if (cross_left.second >= curr_left.second && cross_left.second > ny && cross_left.second <= m) {
                        double sub = (m - cross_left.second) * (m - cross_left.second);
                        s -= sub;
                        crossed_left = true;
                        break;
                    }
                }
                for (auto curr_right : right_slope) {
                    if (curr_right.first == ny - nx && curr_right.second == ny) {
                        continue;
                    }
                    cross_right = intersect(nx + ny, curr_right.first);
                    if (cross_right.second >= curr_right.second && cross_right.second > ny && cross_right.second <= m) {
                        double sub = (m - cross_left.second) * (m - cross_left.second);
                        s -= sub;
                        crossed_right = true;
                        break;
                    }
                }
                if (crossed_left && crossed_right) {
                    pair<int, int> double_cross = intersect(cross_right.first + cross_right.second, cross_left.second - cross_left.first);
                    if (double_cross.second <= m) {
                        double add = (m - double_cross.second) * (m - double_cross.second);
                        s += add;
                    }
                }
                if (nx + ny < m) {
                    double sub = (m - (nx + ny)) * (m - (nx + ny));
                    sub /= 2;
                    s -= sub;
                }
                if (nx - ny > n - m) {
                    double sub = (ny + (n - nx)) * (ny + (n - nx));
                    sub /= 2;
                    s -= sub;
                }
                if (crossed_left) {
                    if (cross_left.first + cross_left.second < m) {
                        double add = (m - (cross_left.first + cross_left.second)) * (m - (cross_left.first + cross_left.second));
                        add /= 2;
                        s += add;
                    }
                    if (cross_left.first - cross_left.second > n - m) {
                        double add = (cross_left.second + (n - cross_left.first)) * (cross_left.second + (n - cross_left.first));
                        add /= 2;
                        s += add;
                    }
                }
                if (crossed_right) {
                    if (cross_right.first + cross_right.second < m) {
                        double add = (m - (cross_right.first + cross_right.second)) * (m - (cross_right.first + cross_right.second));
                        add /= 2;
                        s += add;
                    }
                    if (cross_right.first - cross_right.second > n - m) {
                        double add = (cross_right.second + (n - cross_right.first)) * (cross_right.second + (n - cross_right.first));
                        add /= 2;
                        s += add;
                    }
                }

            }
        }
        left_slope.insert({x + y, y});
        right_slope.insert({y - x, y});
        cout << s;
        if (j != q - 1) {
            cout << " ";
        }
    }
    return 0;
}

