#include<bits/stdc++.h>
#define endl '\n'
#define pii pair<int, int>
using namespace std;

const int maxn = 5e+5+64;
vector<int> graph[maxn];
map<pii, int> isRev;
map<pii, int> revCount;
map<pii, int> edgeIndex;
bitset<maxn> isVisited;

void DFS(int from, int current)
{
    // check if visited
    if(isVisited[current])
    {
        // if edge is already reversed reverse again
        // continue and do not reverse edge again
        if(revCount[{from, current}] > 0)
        {
            isRev[{min(from, current), max(from, current)}] = 0;
            graph[from][edgeIndex[{from, current}]] *= -1;
            graph[current][edgeIndex[{current, from}]] *= -1;
        }
        else
        {
            isRev[{min(from, current), max(from, current)}] = 1;
            revCount[{min(from, current), max(from, current)}] = 1;
            graph[from][edgeIndex[{from, current}]] *= -1;
            graph[current][edgeIndex[{current, from}]] *= -1;
        }
        return;
    }
    isVisited[current] = 1;
    // iterate through neigbours
    for(int i = 0; i < graph[current].size(); i++)
    {
        if(graph[current][i] < 0) continue;
        DFS(current, graph[current][i]);
        DFS(current, graph[current][i]);
    }
    isVisited[current] = 0;
}

string find_reverse(int n, int m, int connections[][2])
{
    for(int i = 0; i < m; i++)
    {
        edgeIndex[{connections[i][0], connections[i][1]}] = graph[connections[i][0]].size();
        graph[connections[i][0]].push_back(connections[i][1]);
        edgeIndex[{connections[i][1], connections[i][0]}] = graph[connections[i][1]].size();
        graph[connections[i][1]].push_back(-connections[i][0]);
    }
    isVisited.reset();
    DFS(-1, 1);
    char l[m];
    for(int i = 0; i < m; i++)
    {
        l[i] = isRev[{min(connections[i][0], connections[i][1]), max(connections[i][0], connections[i][1])}]+'0';
    }
    return l;
}
