#include<bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int int64_t
#define pii pair<int,int>
#define F first
#define S second
typedef tree <pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> oset;

const int inf  = 1000000000000000;

pii WA = {-inf, inf};

int S (oset a, oset b) {
    vector <pii> v, v1;
    for (auto i:a) {
        v.push_back(i);
    }
    for (auto i:b) {
        v1.push_back(i);
    }
    reverse (v1.begin(), v1.end());
    for (int i=1;i<v1.size()-1;++i) {
        v.push_back(v1[i]);
    }
    int ans = v.back().F * v[0].S - v.back().S * v[0].F;
    for (int i=0;i<v.size()-1;++i) {
        ans += v[i].F * v[i+1].S - v[i].S * v[i+1].F;
    }
    return abs(ans);
}
int S (vector <pii> v) {
    if (v.size() == 0) return 0;
    int ans = v.back().F * v[0].S - v.back().S * v[0].F;
    for (int i=0;i<v.size()-1;++i) {
        ans += v[i].F * v[i+1].S - v[i].S * v[i+1].F;
    }
    return abs(ans);
}

pii per (pii a, pii b, pii c, pii d) {
    if (a.F == b.F && c.F == d.F) {
        return WA;
    }
    if (a.S == b.S&& c.S == d.S) {
        return WA;
    }
    pii ans;
    if (a.F == b.F) {
        ans.F = a.F;
        ans.S = c.S;
    }
    else if (a.S == b.S){
        ans = {c.F, a.S};
    }
    else {
        int K = (a.S - b.S) / (a.F - b.F), B = a.F - K * a.S;
        if (c.F == d.F) {
            ans = {c.F, K * c.F - B};
        }
        else {
            ans = {K * c.S + B, c.S};
        }
    }
    return ans;
}

bool in (pii a, pii b, pii c) {
    return (c.F >= min(a.F, b.F) && c.F <= max(a.F, b.F)) && (c.S >= min(a.S, b.S) && c.S <= max(a.S, b.S));
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    oset a, b;
    a.insert({0, 0});
    a.insert({m, -m});
    a.insert({n+m, n-m});
    b.insert({n+m, n-m});
    b.insert({n, n});
    b.insert({0, 0});
    int s = S(a, b);
    int topx = n+m, topy = n - m;
    int q;
    cin >> q;
    for (;q;--q) {
        int X, Y;
        cin >> X >> Y;
        int x = X + Y, y = X - Y;
        auto it = a.upper_bound({x, y});
        it--;
        vector <pii> v;
//        cout << x << ' ' << y << endl;
//        cout << "START" << endl;
        if (topy >= y) {
            auto it2 = a.upper_bound({x, y});it2--;
            pii f1 = *it, f2  = *(++it);it--;
            pii p1 = per(f1, f2, {x, y}, {x, -inf});
            pii p2;
            do {
                if (it2 == a.end()) break;
                f1 = *it2, f2  = *(++it2);it2--;
                if (per(f1, f2, {x, y}, {inf, y}) == WA || !in(f1, f2, per(f1, f2, {x, y}, {inf, y}))  || !in({x, y}, {inf, y}, per(f1, f2, {x, y}, {inf, y})) || per(f1, f2, {x, y}, {inf, y}) == make_pair(x, y)) {
                    it2++;
                    continue;
                }
                p2 = per(f1, f2, {x, y}, {inf, y});
                break;
            } while (1);
//            cout << "P: " << it->F << ' ' << it->S << ' ' << it2->F << ' ' << it2->S << '\n';
            if (it != it2) {
                it++;
                while (it != it2) {
                    auto del = it;
                    v.push_back(*del);
                    it++;
                    a.erase(del);
                }
                if (it2 != a.end()) {
                    auto del = it2;
                    v.push_back(*del);
                    a.erase(del);
                }
            }
            v.push_back(p2);
            v.push_back({x, y});
            v.push_back(p1);
            a.insert(p1);
            a.insert({x, y});
            a.insert(p2);
        }
        else {
            auto it2 = b.upper_bound({x, y});it2--;
            pii f1 = *it, f2  = *(++it );it--;
            pii p1 = per(f1, f2, {x, y}, {x, -inf});
            f1 = *it2, f2  = *(++it2);it2--;
            pii p2 = per(f1, f2, {x, y}, {inf, y});
            auto saveit2 = it2;
            do {
                if (it2 == b.end()) break;
                f1 = *it2, f2  = *(++it2);it2--;
                if (per(f1, f2, {x, y}, {inf, y}) == WA || !in(f1, f2, per(f1, f2, {x, y}, {inf, y}))  || !in({x, y}, {inf, y}, per(f1, f2, {x, y}, {inf, y})) || per(f1, f2, {x, y}, {inf, y}) == make_pair(x, y)) {
                    it2++;
                    continue;
                }
                p2 = per(f1, f2, {x, y}, {inf, y});
                break;
            } while (1);
            vector <pii> v2;
            it++;
            while (it != a.end()) {
                auto del = it;
                v.push_back(*it);
                it++;
                a.erase(del);
            }
            it2++;
            while (it2 != b.end()) {
                v2.push_back(*it2);
                auto del = it2;
                it2++;
                b.erase(del);
            }
            reverse(v2.begin(), v2.end());
            for (auto j:v2) {
                v.push_back(j);
            }
            v.push_back(p2);
            v.push_back({x, y});
            v.push_back(p1);
            
            topx = p2.F, topy = p2.S;
            a.insert(p1);
            a.insert({x, y});
            a.insert(p2);
            b.insert(p2);
        }
        s -= S(v);
//        cout << "S: " << s << ' ' << s/4 << '\n';
//        cout << "V: " << endl;
//        for (pii p:v) {
//            cout << p.F << ' ' << p.S << endl;
//        }
//        cout << "A: " << endl;
//        for (pii p:a) {
//            cout << p.F << ' ' << p.S << endl;
//        }
//        cout << "B: " << endl;
//        for (pii p:b) {
//            cout << p.F << ' ' << p.S << endl;
//        }
//        cout << endl << ' ' << endl;
        cout << fixed << setprecision(2) << s/4.0 << '\n';
    }
    return 0;
}
