#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
/*
extern std::string find_reverse (int, int, int[][2]);

static const int MAXM=1.5e6;
static int connections[MAXM][2];
int main () {
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        cin >> connections[i][0] >> connections[i][1] ;
    }
    string ans=find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
}
*/


unordered_set<int> G[1007];
int used[1007];
bool dfs(int v,int p){
    if(used[v] == 1){
        G[v].insert(p);
        G[p].erase(v);
        return 1;
    }
    if(used[v] == 2) return 0;
    used[v] = 1;
    for (auto e:G[v]) {
        if(used[e] == 2) continue;
        if(dfs(e,v)) return 1;
    }
    used[v] = 2;
    return 0;
}
ll n;
bool check(){
    for (int i = 0; i <= n; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i <=n; ++i) {
        if(used[i]) continue;
        if(dfs(i,-1)) return 1;
    }
    return 0;
}
pair<int,int> ed[5007];
string ans;
ll m;
void add_edge(int v,int u){
    for (int i = 0; i < m; ++i) {
        if(ed[i].second == v and ed[i].first == u) ans[i] = '1';
    }
}
string find_reverse (int N, int M, int connections[][2]){
    n = N;
    m = M;
    for (int i = 0; i < M; ++i) {
        G[connections[i][0]].insert(connections[i][1]);
        ed[i] = {connections[i][0],connections[i][1]};
    }
    ans.resize(m);
    for (int i = 0; i < m; ++i) {
        ans[i] = '0';
    }
    while (check());
    for (int v = 1; v <=N; ++v) {
        for (auto e:G[v]) {
            add_edge(v,e);
        }
    }
    return ans;
}