#pragma GCC optimize("O3,inline")
#pragma GCC target("avx2,bmi,sse2,popcnt,lzcnt")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int Nm = 1e5+7;
const int Mm = 5e5+7;
pair<int,int> sgt[4*Nm];
int out[Nm];
void build(int v,int l,int r){
    if(l == r) sgt[v] = {out[l],l};
    else{
        int m = (l+r) >> 1;
        build((v<<1),l,m);
        build((v<<1)|1,m+1,r);
        sgt[v] = min(sgt[(v<<1)],sgt[(v<<1)|1]);
    }
}
void update(int v,int l,int r,int t,int val){
    while(l != r){
        int m = (l+r) >> 1;
        v = (v<<1);
        if(t <= m) r = m;
        else l = m+1,v|=1;
    }
    sgt[v].first+=val;
    while(v > 1){
        v>>=1;
        sgt[v] = min(sgt[(v<<1)],sgt[(v<<1)|1]);
    }
}
set<int> G[Nm];
set<int> Gin[Nm];
unordered_map<int,int> Gtable[Nm];
string ans;
int n,m;
void reverse_edge(int v,int u){
    int x = Gtable[v][u];
    ans[x] = '1';
    G[v].erase(u);
    Gin[v].insert(u);
    Gin[u].erase(v);
    G[u].insert(v);
    //update(1,1,n,v,-1);
    out[v]--;
    out[u]++;
    //update(1,1,n,u,1);
}
void remove_edge(int v,int u){
    G[v].erase(u);
    Gin[u].erase(v);
    if(Gtable[v].count(u))
    update(1,1,n,v,-1);
    out[v]--;
}
void remove_vertex(int v){
    while(G[v].size()){
        reverse_edge(v,*G[v].begin());
    }
    while(Gin[v].size()){
        remove_edge(*Gin[v].begin(),v);
    }
    update(1,1,n,v,(int)1e9);
}
void solve(){
    for (int i = 0; i < n; ++i) {
        ll tmp_vertex = sgt[1].second;
        remove_vertex(tmp_vertex);
    }
}
string find_reverse (int N, int M, int connections[][2]){
    n = N,m=M;
    ans.resize(m);
    for (int i = 0; i < m; ++i) {
        ans[i] = '0';
        int u = connections[i][0],v = connections[i][1];
        G[u].insert(v);
        Gin[v].insert(u);
        Gtable[u][v] = i;
        out[u]++;
    }
    build(1,1,n);
    solve();
    return ans;
}
/*
extern std::string find_reverse (int, int, int[][2]);

static const int MAXM=1.5e6;
static int connections[MAXM][2];
int main () {
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        cin >> connections[i][0] >> connections[i][1] ;
    }
    string ans=find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
}
*/
/*
 *
6 12
1 2
1 5
2 3
2 5
3 4
3 6
4 1
4 5
5 3
5 6
6 1
6 4

 */