#pragma GCC optimize("O3,inline")
#pragma GCC target("avx2,bmi,sse2,popcnt,lzcnt")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int Nm = 1e5+7;
const int Mm = 5e5+7;
pair<int,int> sgt[4*Nm];
pair<int,int> sgtT[4*Nm];
vector<int> G[Nm];
bool deleted[Nm];
int n,m;
void build(int v,int l,int r){
    sgtT[1] = {l,r};
    for (int i = 1; i < 4*n; ++i) {
        if(sgtT[i].first != sgtT[i].second){
            int m = (sgtT[i].first+sgtT[i].second) >> 1;
            sgtT[(i<<1)].first = l;
            sgtT[(i<<1)].second = m;
            sgtT[(i<<1)|1].first = m+1;
            sgtT[(i<<1)|1].second = r;
        }
        else sgt[i] = {G[i].size(),sgtT[i].first};
    }
    for (int i = 4*n-1; i >= 1; --i) {
        if(sgtT[i].first != sgtT[i].second){
            sgt[i] = min(sgt[(i<<1)],sgt[(i<<1)|1]);
        }
    }
}
void update(int l,int r,int t,int val){
    int v = 1;
    while(l != r){
        int m = (l+r) >> 1;
        v = (v<<1);
        if(t <= m) r = m;
        else l = m+1,v|=1;
    }
    sgt[v].first+=val;
    while(v > 1){
        v>>=1;
        sgt[v] = min(sgt[(v<<1)],sgt[(v<<1)|1]);
    }
}
vector<int> Gin[Nm];
map<int,int> Gtable[Nm];
string ans;
void reverse_edge(int v,int u){
    int x = Gtable[v][u];
    ans[x] = '1';
    Gin[v].push_back(u);

    //update(1,1,n,v,-1);
    //update(1,1,n,u,1);
}
void remove_edge(int v,int u){
    if(Gtable[v].count(u))
    update(1,n,v,-1);
}
void remove_vertex(int v){
    for (int i = 0; i < G[v].size(); ++i) {
        if(deleted[G[v][i]]) continue;
        reverse_edge(v,G[v][i]);
    }
    for (int i = 0; i < Gin[v].size(); ++i) {
        if(deleted[Gin[v][i]]) continue;
        else remove_edge(Gin[v][i],v);
    }

    update(1,n,v,(int)1e9);
    deleted[v] = 1;
}
void solve(){
    for (int i = 0; i < n; ++i) {
        ll tmp_vertex = sgt[1].second;
        remove_vertex(tmp_vertex);
    }
}
string find_reverse (int N, int M, int connections[][2]){
    n = N,m = M;
    ans.resize(m);
    for (int i = 0; i < m; ++i) {
        ans[i] = '0';
        int u = connections[i][0],v = connections[i][1];
        G[u].push_back(v);
        Gin[v].push_back(u);
        Gtable[u][v] = i;
    }
    build(1,1,n);
    solve();
    return ans;
}
/*
extern std::string find_reverse (int, int, int[][2]);

static const int MAXM=1.5e6;
static int connections[MAXM][2];
int main () {
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        cin >> connections[i][0] >> connections[i][1] ;
    }
    string ans=find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
}
*/
/*
 *
6 12
1 2
1 5
2 3
2 5
3 4
3 6
4 1
4 5
5 3
5 6
6 1
6 4

 */