#include <bits/stdc++.h>

using namespace std;

const int NMAX = 5e5 + 2;
const int MMAX = 15e5;
bool viz[NMAX + 2];
vector <int> v[NMAX + 2];
int connections[MMAX + 2][2];
bool already[NMAX + 2];
int root;
int isCycle;

bool dfs( int node ){
  if( !viz[node] ) {
    viz[node] = 1;
    already[node] = 1;

    for( int i = 0; i < v[node].size(); ++i )
      if( !viz[v[node][i]] && dfs(v[node][i]) )
        return 1;
      else if( already[v[node][i]] )
        return 1;
  }
  already[node] = 0;
  return 0;
}

string find_reverse (int n, int m, int connections[][2]) {
  int i, mask;
  string s;

  for( mask = 0; mask < (1 << m); ++mask ){
    s = "";
    for( i = 0; i < m; ++i ) {
      if( mask & (1 << i) ) {
        s += '1';
        v[connections[i][1]].push_back(connections[i][0]);
      }
      else {
        v[connections[i][0]].push_back(connections[i][1]);
        s += '0';
      }
    }

    isCycle = 0;
    for( i = 1; i <= n; ++i ) {
      root = i;
      isCycle = dfs(i);

      if( isCycle == 1 )
        break;
    }

    if( isCycle == 0 ) {
      return s;
    }

    for( i = 1; i <= n; ++i ) {
      v[i].clear();
      viz[i] = 0;
    }

  }
}

int main () {
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<m; i++) {
        cin >> connections[i][0] >> connections[i][1] ;
    }
    string ans=find_reverse(n,m,connections);
    cout << ans ;
    cout << endl ;
}



