#include <iostream>
#include <vector>
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

using namespace std;

const int NMAX = 5e5 + 2;
const int MMAX = 1500000;
bool viz[NMAX + 2];
vector <int> v[NMAX + 2];
int depth[NMAX + 2];
int connections[MMAX + 2][2];

void dfs( int node ){
  viz[node] = 1;
  for( int i = 0; i < v[node].size(); ++i ) {
    if( !viz[v[node][i]] ) {
      depth[v[node][i]] = depth[node] + 1;
      dfs(v[node][i]);
    }
  }
}

string find_reverse (int n, int m, int connections[][2]) {
  int i;
  string s;


  depth[1] = 1;
  for( i = 0; i < m; ++i ) {
    v[connections[i][0]].push_back(connections[i][1]);
    v[connections[i][1]].push_back(connections[i][0]);
  }

  dfs(1);

  s = "";
  for( i = 0; i < m; ++i )
    if( depth[connections[i][0]] < depth[connections[i][1]] )
      s += '0';
    else
      s += '1';
  return s;
}