#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define point pair<ll,ll>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define c connections

using namespace std;

const int N = 5e5 + 64;
const int INF = INT_MAX;
const int LOG = 31;

string ans;

vector<int> g[N], gr[N];
vector<int> used(N);
map<point,int> mp;

void dfs(int v) {
    used[v] = 2;
    for (auto to : g[v])
        if (used[to] == 2)
            ans[mp[{v, to}]] = '1';
        else if (!used[to])
            dfs(to);
    used[v] = 1;
}

string find_reverse(int n, int m, int connections[][2]) {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ans.resize(m, '0');
    for (int i = 0; i < m; ++i) {
        mp[{c[i][0], c[i][1]}] = i;
        g[c[i][0]].push_back(c[i][1]);
    }

    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);
    return ans;
}

//signed main() {
//    int n, m;
//    cin >> n >> m;
//    int connections[m][2];
//    for (int i = 0; i < m; ++i)
//        cin >> c[i][0] >> c[i][1];
//
//    cout << find_reverse(n, m, c);
//}
