#include <iostream>
#include <vector>
#include <string>
#include <climits>

#define ll long long
#define ld long double
#define point std::pair<int,int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

const int N = 500000;
const int INF = INT_MAX;
const int LOG = 31;

std::vector<point> g[N];
char used[N], ans[N];

void dfs(int v) {
    used[v] = 2;
    for (int i = 0; i < g[v].size(); ++i) {
        point to = g[v][i];
        if (used[to.ff] == 2)
            ans[to.ss] = 1;

        if (!used[to.ff])
            dfs(to.ff);
    }
    used[v] = 1;
}

std::string find_reverse(int n, int m, int c[][2]) {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cerr.tie(0);

    for (int i = 0; i < m; ++i)
        g[c[i][0]].push_back({c[i][1], i});

    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);

    std::string s; s.resize(m);
    for (int i = 0; i < m; ++i)
        s[i] = ans[i] + '0';
    return s;
}

//come on people, 0.1 secs??? on a task with constraints 1.5kk?
//that was rude.

//signed main() {
//    int n, m;
//    cin >> n >> m;
//    int connections[m][2];
//    for (int i = 0; i < m; ++i)
//        cin >> c[i][0] >> c[i][1];
//
//    cout << find_reverse(n, m, c);
//}
