
#ifdef MY_MAC
#include <iostream>
#include <fstream>

std::ifstream f("input.txt");

std::string find_reverse(int N, int M, int connections[][2]);

int main() {
	int n, m;
	f >> n >> m;
	int connections[m+5][2];
	for (int i = 1; i <= m; i++)
		f >> connections[i][0] >> connections[i][1];
	std::cout << find_reverse(n, m, connections);
	return 0;
}
#endif

const int mxN = 5e5+5;

int n, m, a[mxN][mxN];
bool viz[mxN];

void dfs(int x, std::string &ans) {
	viz[x] = 1;
	for (int i = 1; i <= n; i++)
		if (a[x][i]) {
			if (viz[i]) {
				ans[a[x][i] - 1] = '1';
				a[x][i] = 0;
			}
			else
				dfs(i, ans);
		}
}

std::string find_reverse(int N, int M, int connections[][2]) {
	n = N, m = M;
	std::string ans("");

	for (int i = 0; i < m; i++)
		ans.push_back('0');

	for (int i = 1; i <= m; i++)
		a[connections[i][0]][connections[i][1]] = i;

	dfs(1, ans);

	return ans;
}

