#include <string>

const int mxN = 5e5+5;

int a[mxN][mxN];
bool viz[mxN];

void dfs(int x, std::string &ans, int n, int m) {
	viz[x] = 1;
	for (int i = 1; i <= n; i++)
		if (a[x][i]) {
			if (viz[i]) {
				ans[a[x][i] - 1] = '1';
				a[x][i] = 0;
				a[i][x] = -1;
				break;
			}
			else
				dfs(i, ans, n, m);
		}
	for (int i = 1; i <= n; i++)
		if (a[x][i])
			viz[i] = 0;
}

std::string find_reverse(int N, int M, int connections[][2]) {
	std::string ans("");

	for (int i = 0; i < M; i++)
		ans.push_back('0');

	for (int i = 0; i < M; i++)
		a[connections[i][0]][connections[i][1]] = i+1;

	dfs(1, ans, N, M);

	return ans;
}

