#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define ll long long
#define pb push_back

const int N = 10000005;
bool dp1[N], dp2[N];
ll from1[N], from2[N];
ll pref1[N], pref2[N];
pair<int, int> a[N], b[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(a, a + n);
    sort(b, b + m);
    ll sum = 0;
    map<ll, int> mp;
    for (int i = 0; i < n; i++) {
        sum += a[i].first;
        pref1[i] = sum;
        mp[sum] = i + 1;
    }
    int ind1 = -1, ind2 = -1;
    sum = 0;
    for (int i = 0; i < m; i++) {
        sum += b[i].first;
        if (mp[sum]) {
            //cout << sum << endl;
            ind1 = mp[sum];
            ind2 = i + 1;
            break;
        }
    }
    vector<int> ans1, ans2;
    for (int i = 0; i < ind1; i++) {
        ans1.push_back(a[i].second);
    }
    for (int i = 0; i < ind2; i++) {
        ans2.push_back(b[i].second);
    }
    sort(ans1.begin(), ans1.end());
    sort(ans2.begin(), ans2.end());
    cout << ans1.size() << endl;
    for (auto i : ans1) {
        cout << i << ' ';
    }
    cout << endl;
    cout << ans2.size() << endl;
    for (auto i : ans2) {
        cout << i << ' ';
    }
    cout << endl;
}



