#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int n, m;
vector< pair<int,int> > a, b;

int solve2()
{
    sort( a.begin(), a.end() );
    sort( b.begin(), b.end() );

    map< ll, vector<int> > sum1;
    map< ll, vector<int> > sum2;

    ll sum = a[0].first;
    vector<int> cur({ a[0].second });

    for ( int i=1; i<n; i++ )
    {
        if ( a[i].first == a[i-1].first )
        {
            sum += a[i].first;
            cur.push_back( a[i].second );

            if ( cur.size() <= 3 )
            sum1[sum].assign( cur.begin(), cur.end() );

        } else
        {
            sum1[sum].assign( cur.begin(), cur.end() );
            sum = a[i].first;
            cur = { a[i].second };
        }
    }
    sum1[sum].assign( cur.begin(), cur.end() );

    for ( int i=0; i<n; i++ )
        sum1[ a[i].first ].assign({ a[i].second });

    for ( int i=0; i<1000; i++ )
    {
        int x = rand() % n;
        int y = rand() % n;
        while ( y == x )
            y = rand() % n;
        sum1[ a[x].first + a[y].first ] = { a[x].first, a[y].first };
    }

    sum = b[0].first;
    cur = { b[0].second };

    for ( int i=1; i<m; i++ )
    {
        if ( b[i].first == b[i-1].first )
        {
            sum += b[i].first;
            cur.push_back( b[i].second );

            if ( cur.size() <= 3 )
            sum2[sum].assign( cur.begin(), cur.end() );

        } else
        {
            sum2[sum].assign( cur.begin(), cur.end() );
            sum = b[i].first;
            cur = { b[i].second };
        }
    }
    sum2[sum].assign( cur.begin(), cur.end() );

    for ( int i=0; i<m; i++ )
        sum2[ b[i].first ].assign({ b[i].second });

    for ( int i=0; i<1000; i++ )
    {
        int x = rand() % m;
        int y = rand() % m;
        while ( y == x )
            y = rand() % m;
        sum2[ b[x].first + b[y].first ] = { b[x].first, b[y].first };
    }

    for ( auto& pr : sum1 )
    if ( sum2[pr.first].size() )
    {
        vector<int> ans1( pr.second.begin(), pr.second.end() );
        vector<int> ans2( sum2[pr.first].begin(), sum2[pr.first].end() );

        cout << ans1.size() << '\n';
        for ( auto& el : ans1 )
            cout << el << ' ';
        cout << '\n';

        cout << ans2.size() << '\n';
        for ( auto& el : ans2 )
            cout << el << ' ';
        cout << '\n';
    }

    return 0;
}

int solve1 ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    vector< pair<int,int> > dp1(int(2e5), pair<int,int>( 1e9, 0 ));
    vector< pair<int,int> > dp2(int(2e5), pair<int,int>( 1e9, 0 ));

    dp1[0] = {-1, -1};
    dp2[0] = {-1, -1};

    for ( int p=0; p<a.size(); p++ )
    for ( int i=int(2e5)-a[p].first-1; i>=0; i-- )
    if ( dp1[i].first != 1e9 && dp1[i+a[p].first ].first == 1e9 )
        dp1[i+a[p].first ] = { i, p };

    for ( int p=0; p<b.size(); p++ )
    for ( int i=int(2e5)-b[p].first-1; i>=0; i-- )
    if ( dp2[i].first != 1e9 && dp2[i+b[p].first ].first == 1e9 )
        dp2[i+b[p].first ] = { i, p };

    for ( int i=1; i<2e5; i++ )
    if ( dp1[i].first != 1e9 && dp2[i].first != 1e9 )
    {
        vector<int> ans1, ans2;

        int cur = i;
        while ( cur > 0 )
        {
            ans1.push_back( dp1[cur].second );
            cur = dp1[cur].first;
        }

        cur = i;
        while ( cur > 0 )
        {
            ans2.push_back( dp2[cur].second );
            cur = dp2[cur].first;
        }

        cout << ans1.size() << '\n';
        for ( auto& el : ans1 )
            cout << el << ' ';
        cout << '\n';

        cout << ans2.size() << '\n';
        for ( auto& el : ans2 )
            cout << el << ' ';
        cout << '\n';

        return 0;
    }

    return 0;
}

int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    a.resize( n );
    for ( int i=0; i<n; i++ )
    {
        cin >> a[i].first;
        a[i].second = i;
    }

    cin >> m;
    b.resize( m );
    for ( int i=0; i<m; i++ )
    {
        cin >> b[i].first;
        b[i].second = i;
    }

    if ( n < 10000 && m < 10000 )
        solve1();

    else
        solve2();

    return 0;
}
