#include <bits/stdc++.h>

using namespace std ;

const int inf = 1e6 ;
pair<int , int> gr[inf][inf] ;
vector<int> color(inf) ;
vector<bool> used(inf) ;
bool ans = true ;
int from , to ;
void dfs(int v , int n){
    used[v] = true ;
    color[v] = 1 ;
    for(int i = 0 ; i < n ; i++){
        if(i != v && gr[v][i].first == 1){
            if(color[i] == 0){
                dfs(i , n) ;
            } else if(color[i] == 1){
                ans = true ;
                from = v ;
                to = i ;
            }
        }
    }
    color[v] = 2 ;
}
string find_reverse(int n , int m , int connections[][2]){
    for(int i = 0 ; i < m ; i++){
        int a = connections[i][0] ;
        int b = connections[i][1] ;
        a-- ;
        b-- ;
        gr[a][b] = {1 , i} ;
    }
    vector<int> rev(m , 0) ;
    while(ans == true){
        ans = false ;
        for(int j = 0 ; j < n ; j++){
            used[j] = false ;
            color[j] = 0 ;
        }
        for(int j = 0 ; j < n ; j++){
            if(used[j] == false){
                dfs(j , n) ;
            }
        }
        if(ans == true){
            rev[gr[from][to].second] = 1 ;
            gr[to][from] = {1 , -1} ;
            gr[from][to] = {0 , -1} ;
        }
    }
    string s = "" ;
    for(int i = 0 ; i < m ; i++){
        if(rev[i] == 0){
            s.push_back('0') ;
        } else {
            s.push_back('1') ;
        }
    }
    return s ;
}
