#include <bits/stdc++.h>
using namespace std ;
const int inf = 1e6 ;
vector<int> gr[inf] ;
vector<int> color(inf) ;
vector<bool> used(inf) ;
map<pair<int , int> , bool> mp1 ;
map<pair<int , int> , int> mp2 ;
vector<pair<int ,int>> ans ;
int from , to ;
void dfs(int v , int start){
    used[v] = true ;
    color[v] = 1 ;
    for(auto i : gr[v]){
        if(mp1[{v , i}] == true){
            if(color[i] == 0){
                dfs(i , start) ;
            } else if(color[i] == 1 && i == start){
                ans.push_back({v , start}) ;
            }
        }
    }
    color[v] = 2 ;
}
string find_reverse(int n , int m , int connections[][2]){
    for(int i = 0 ; i < m ; i++){
        int a = connections[i][0] ;
        int b = connections[i][1] ;
        a-- ;
        b-- ;
        gr[a].push_back(b) ;
        mp1[{a , b}] = true ;
        mp2[{a , b}] = i ;
    }
    vector<int> rev(m , 0) ;
    for(int i = 0 ; i < n ; i++){
        used.assign(n , false) ;
        color.assign(n , 0) ;
        ans.clear() ;
        dfs(i ,  i) ;
        for(int j = 0 ; j < ans.size() ; j++){
            int from = ans[i].first ;
            int to = ans[i].second ;
            rev[mp2[{from , to}]] = 1 ;
            mp1[{from , to}] = false ;
            mp1[{to , from}] = true ;
        }
    }
    string s = "" ;
    for(int i = 0 ; i < m ; i++){
        if(rev[i] == 0){
            s.push_back('0') ;
        } else {
            s.push_back('1') ;
        }
    }
    return s ;
}
