#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

void dfs(int v,int p,int n,int m,vector <vector<int>> &h,vector<int> &used,vector <int> &rebrs,map<pair<int,int>,int> &d) {
    used[v]=1;
    for (int i=0;i<h[v].size();i++) {
        int to=h[v][i];
        if (used[to]==0) {
            dfs(to,v,n,m,h,used,rebrs,d);
        } else if (used[to]==1) {
            used[v]=2;
            if (p==-1) {
                rebrs.push_back(d[{v,to}]);
            } else {
                rebrs.push_back(d[{p,v}]);
            }
        }
    }
    used[v]=2;
}

string find_reverse(int n,int m,int g[][2]) {
    vector<int> used;
    vector <vector <int>> h(n);
    map<pair<int,int>,int> d;
    for (int i=0;i<m;i++) {
        d[{g[i][0]-1,g[i][1]-1}]=i;
        h[g[i][0]-1].push_back(g[i][1]-1);
    }
    vector <int> rebrs;
    used.resize(n);
    for (int i=0;i<n;i++) {
        used[i]=0;
    }
    for (int i=0;i<n;i++) {
        dfs(i,-1,n,m,h,used,rebrs,d);
    }
    string ans;
    for (int i=0;i<m;i++) {
        ans.push_back('0');
    }
    for (int i=0;i<rebrs.size();i++) {
        ans[rebrs[i]]=(ans[rebrs[i]]-'0'+1)%2+'0';
    }
    return ans;
}


/*
int main() {
    int n,m;
    cin >> n >> m;
    int g[m][2];
    for (int i=0;i<m;i++) {
        int s,t;
        cin >> s >> t;
        g[i][0]=s;
        g[i][1]=t;
    }
    cout << find_reverse(n,m,g);
}
*/
