#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
const long long MOD=4242743;

long long getSumOfMask(int mask,vector <long long> a) {
    int i=0;
    long long ans=0;
    while (mask>0) {
        if (mask&1) {
            ans+=a[i];
        }
        i++;
        mask=mask>>1;
    }
    return ans;
}

vector<int> getArrayOfMask(int mask) {
    int i=0;
    vector <int> ans;
    while (mask>0) {
        if (mask&1) {
            ans.push_back(i);
        }
        i++;
        mask=mask>>1;
    }
    return ans;
}

int main() {
    int n,m;
    cin >> n;
    vector <long long> a(n);
    for (int i=0;i<n;i++) {
        cin >> a[i];
    }
    cin >> m;
    vector <long long> b(m);
    for (int j=0;j<m;j++) {
        cin >> b[j];
    }
    vector <int> can(MOD);
    for (int mask=0;mask<(1<<m);mask++) {
        can[getSumOfMask(mask,b)%MOD]=mask+1;
    }
    long long amask,bmask;
    for (int mask=0;mask<(1<<n);mask++) {
        long long su=getSumOfMask(mask,a);
        if (can[su%MOD]!=0) {
            amask=mask;
            bmask=can[su%MOD]-1;
        }
    }
    vector <int> ansa=getArrayOfMask(amask);
    vector <int> ansb=getArrayOfMask(bmask);
    cout << ansa.size() << "\n";
    for (int i=0;i<ansa.size();i++) {
        cout << ansa[i] << " ";
    }
    cout << "\n";
    cout << ansb.size() << "\n";
    for (int i=0;i<ansb.size();i++) {
        cout << ansb[i] << " ";
    }
    cout << "\n";
}
