#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

ll a[1000002],b[1000002];

void solve()
{
    ll n,m;
    cin>>n;

    for(ll i=0;i<n;i++)
        cin>>a[i];

    cin>>m;

    for(ll i=0;i<m;i++)
        cin>>b[i];

    auto func = [&](set<ll> &v1, set<ll> &v2)
    {
        ll s1=0,s2=0;

        for(ll i:v1)
            s1+=a[i];

        for(ll i:v2)
            s2+=b[i];

        return abs(s1-s2);
    };

    set<ll> v1,v2;

    for(ll i=0;i<n;i++)
    {
        if(gen()&1)
            v1.insert(i);
    }

    for(ll i=0;i<m;i++)
    {
        if(gen()&1)
            v2.insert(i);
    }

    if(v1.size()==0) v1.insert(gen()%n);
    if(v2.size()==0) v2.insert(gen()%m);

    ll ans=func(v1,v2);
    ld t=1;
    uniform_real_distribution<ld> unif(0,1);

    while(ans>0)
    {
        t*=0.99999;
        set<ll> u1=v1,u2=v2;

        if(gen()&1)
        {
            if(u1.size()<=1||(gen()&1)) u1.insert(gen()%n);
            else u1.erase(gen()%n);
        }

        else
        {
            if(u2.size()<=1||(gen()&1)) u2.insert(gen()%m);
            else u2.erase(gen()%m);
        }

        ll cur=func(u1,u2);

        if(cur<ans||unif(gen)<exp((ans-cur)/t))
        {
            ans=cur;
            v1=u1, v2=u2;
        }
    }

    cout<<v1.size()<<endl;

    for(ll i:v1)
        cout<<i<<' ';

    cout<<endl<<v2.size()<<endl;

    for(ll i:v2)
        cout<<i<<' ';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
