#include <unordered_map>
#include <queue>
#include <vector>

using std::vector;
using std::string;
using std::swap;
using std::queue;
using std::unordered_map;
using std::pair;

vector<int> graph[500000];
unordered_map<int,unordered_map<int,int> > actedge;
int level[500000];

queue< pair<int,int> > que;

static void bfs() {
  if(que.empty())
    return;
  int node=que.front().first,f=que.front().second;
  que.pop();
  if(level[node]!=-1) {
    if(level[node]<level[f]) {
      actedge[node][f]=1;
      //std::cerr << node+1 << ' ' <<  f+1  << '\n';
    }
    else if(level[node]==level[f]) {
      if(node>f)
        swap(node,f);
      actedge[node][f]=1;
      //std::cerr << node+1 << ' ' <<  f+1  << '\n';
    }
    else {
      actedge[f][node]=1;
      //std::cerr << f+1 << ' ' << node+1 << '\n';
    }
    return;
  }
  level[node]=level[f]+1;
  actedge[f][node]=1;
  //std::cerr << f+1 << ' ' << node+1 << '\n';
  for(auto x: graph[node]) {
    if(x!=f) {
      que.push({x,node});
    }
  }
  bfs();
  return;
}

std::string find_reverse(int n, int m, int edge[][2]) {
  for(int i=0; i<m; i++)
    graph[--edge[i][0]].push_back(--edge[i][1]);
  for(int i=0; i<n; i++) {
    level[i]=-1;
  }
  for(int i=0; i<n; i++) {
    if(level[i]==-1)
      que.push({i,i}),bfs();
  }
  std::string s;
  s.resize(m);
  for(int i=0,val; i<m; i++) {
    if(actedge.find(edge[i][0])==actedge.end())
      val=0;
    else if(actedge[edge[i][0]].find(edge[i][1])==actedge[edge[i][0]].end())
      val=0;
    else
      val=1;
    s[i]='1'-val;
  }
  return s;
}
