#include <unordered_map>
#include <queue>
#include <random>
#include <vector>

using std::vector;
using std::string;
using std::swap;
using std::queue;
using std::unordered_map;
using std::pair;
using std::mt19937;

using ll = long long;
mt19937 rng(time(0));

const ll rnd=rng();


struct dinaiabunadetot {
  ll getsussy(ll x) {
    x=x^0xf76a6ea5a0193c01;
    x=((x^x))*(x+x)%(1LL<<32);
    return x;
  }
  ll operator ()(const ll x) const {
    int temp=x;
    temp+=rnd;
    temp=temp^0xf76a6ea5a0193c01;
    temp=((temp^temp))*(temp+temp)%(1LL<<32);
    return x;
  }
};

vector<int> graph[500000];
unordered_map<int,unordered_map<int,int,dinaiabunadetot>, dinaiabunadetot> actedge;
int level[500000];

queue< pair<int,int> > que;

static void bfs() {
  if(que.empty())
    return;
  int node=que.front().first,f=que.front().second;
  //std::cerr << "+\n";
  que.pop();
  if(level[node]!=-1) {
    if(level[node]<level[f]) {
      actedge[node][f]=1;
      //std::cerr << node+1 << ' ' <<  f+1  << '\n';
    }
    else if(level[node]==level[f]) {
      if(node>f)
        swap(node,f);
      actedge[node][f]=1;
      //std::cerr << node+1 << ' ' <<  f+1  << '\n';
    }
    else {
      actedge[f][node]=1;
      //std::cerr << f+1 << ' ' << node+1 << '\n';
    }
    bfs();
    return;
  }
  level[node]=level[f]+1;
  actedge[f][node]=1;
  //std::cerr << f+1 << ' ' << node+1 << '\n';
  for(auto x: graph[node]) {
    if(x!=f) {
      que.push({x,node});
    }
    //else
      //std::cerr << "-\n";
  }
  bfs();
  return;
}

std::string find_reverse(int n, int m, int edge[][2]) {
  for(int i=0; i<m; i++) {
    graph[--edge[i][0]].push_back(--edge[i][1]);
    graph[edge[i][1]].push_back(edge[i][0]);
  }
  for(int i=0; i<n; i++) {
    level[i]=-1;
  }
  for(int i=0; i<n; i++) {
    if(level[i]==-1)
      que.push({i,i}),bfs();
  }
  std::string s;
  s.resize(m);
  for(int i=0,val; i<m; i++) {
    if(actedge.find(edge[i][0])==actedge.end())
      val=0;
    else if(actedge[edge[i][0]].find(edge[i][1])==actedge[edge[i][0]].end())
      val=0;
    else
      val=1;
    s[i]='1'-val;
  }
  return s;
}
