#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
//#define int long long
#define pii pair <int, int>
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define fir first
#define sec second
#define un unsigned
#define double long double
using namespace std;

const int N = 100009, R = 1 << 20, MOD = 1e9 + 7;

bool flag = 0;

vector<int> used(N, 0);

void dfs(vector<vector<int>> &gr, int v)
{
    used[v] = 1;

    for  (auto u : gr[v])
    {
        if (!used[u])
        {
            dfs(gr, u);
        }
        else if (used[u] == 1)
        {
            flag = 1;
            return;
        }
    }

    used[v] = 2;
    return;
}

string to_str (int n, int m)
{
    string ans = "";

    for (int i = 0; i < m; i++)
    {
        ans += "0";
    }

    int i = m - 1;

    while (n != 0)
    {
        if (n & 1)
        {
            ans[i] = '1';
        }

        n >>= 1;
        i--;
    }

    return ans;
}

std::string find_reverse(int N, int M, int connections[][2])
{
    int n = N, m = M;

    vector<vector<int>> gr(n + 1);

    for (int i = 0; i < m; i++)
    {
        gr[connections[i][0]].pb(connections[i][1]);
    }

    for (int i = 0; i < (1 << m); i++)
    {
        vector<vector<int>> grr(n + 1);
        int mask = i;

        for (int i = m - 1; i >= 0; i--)
        {
            if (mask & 1)
            {
                grr[connections[i][1]].pb(connections[i][0]);
            }
            else
            {
                grr[connections[i][0]].pb(connections[i][1]);
            }

            mask >>= 1;
        }

        flag = 0;
        used = vector<int>(N, 0);

        for (int i = 1; i <= n; i++)
        {
            if (!used[i])
            {
                dfs(grr, i);
            }
        }

        if (!flag)
        {
            string ans = to_str(i, m);

            return ans;
        }
    }
}
