#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
//#define int long long
#define pii pair <int, int>
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define fir first
#define endl "\n"
#define sec second
#define un unsigned
#define double long double
using namespace std;

const int N = 500, R = 1 << 20, MOD = 1e9 + 7;

vector<int> sum;
unordered_map<int, vector<int>> mp;
unordered_map<int, vector<int>> mp1;
vector<int> vc1;
vector<int> vc2;
vector<bool> used;

void dfs(vector<vector<pii>>& gr, int v, int summ)
{
    used[v] = 1;
    mp[summ + vc1[v]] = mp[summ];

    mp[summ + vc1[v]].pb(v);

    for (auto uu : gr[v])
    {
        int u = uu.sec;

        if (!used[u])
        {
            dfs(gr, u, summ + vc1[v]);
        }
    }
}

void dfs1(vector<vector<pii>>& gr, int v, int summ)
{
    used[v] = 1;
    mp1[summ + vc2[v]] = mp1[summ];
    mp1[summ + vc2[v]].pb(v);

    if (mp.find(summ + vc2[v]) != mp.end())
    {
        summ += vc2[v];

        cout << mp[summ].size() << endl;

        for (auto p : mp[summ])
        {
            cout << p << " ";
        }

        cout << endl << mp1[summ].size() << endl;

        for (auto p : mp1[summ])
        {
            cout << p << " ";
        }

        exit(0);
    }

    for (auto uu : gr[v])
    {
        int u = uu.sec;

        if (!used[u])
        {
            dfs(gr, u, summ + vc2[v]);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vc1.resize(n);

    for (int i = 0; i < n; i++)
    {

        cin >> vc1[i];
    }

    int m;
    cin >> m;

    vc2.resize(m);

    for (int i = 0; i < m; i++)
    {

        cin >> vc2[i];
    }

    vector<vector<pii>> gr1(n);

    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            gr1[i].pb({ vc1[j], j });
            gr1[j].pb({ vc1[i], i });
        }
    }

    vector<vector<pii>> gr2(m);

    for (int i = 0; i < m; i++)
    {
        for (int j = i + 1; j < m; j++)
        {
            gr2[i].push_back({ vc2[j],j });
            gr2[j].push_back({ vc2[i], i });
        }
    }

    for (int i = 0; i < n; i++)
    {
        used = vector<bool>(n, 0);
        dfs(gr1, i, 0);
    }

    for (int i = 0; i < m; i++)
    {
        used = vector<bool>(m, 0);
        dfs1(gr2, i, 0);
    }

    return 0;
}

/*
5
2 3 3 2 3
3
4 5 5
*/
