#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define ll long long

mt19937 rnd(51);

int get(int i, pair<int,int> p){
    if (p == make_pair(-1ll, -1ll)){
        return 0;
    }
    return p.second - abs(i - p.first);
}

vector<ld> solve(int n, int m, int q, vector<pair<int,int>> p){
    vector<pair<int,int>> mx(n, {-1, -1});
    vector<int> left(n), right(n);
    vector<ld> arr;
    ld ans = n * m;
    for (auto to : p){
        int i = to.first - 1, j = to.second;
        while(j > 0 && i >= 0){
            int val = get(i, mx[i]);
            if (val < j){
                ans -= (ld)j - (ld)val - 0.5;
                if (left[i] + right[i] == 2){
                    ans -= 0.25;
                }
                else if (left[i] + right[i] == 1){
                    ans -= 0.5;
                }
                mx[i] = {to.first - 1, to.second};
                left[i] = 0;
                right[i] = 1;
            }
            else if (val == j){
                if (right[i]){
                    break;
                }
                right[i] = 1;
                ans -= 0.25;
                break;
            }
            else break;
            j--;
            i--;
        }
        i = to.first, j = to.second;
        while(j > 0 && i < n){
            int val = get(i, mx[i]);
            if (val < j){
                ans -= (ld)j - (ld)val - 0.5;
                if (left[i] + right[i] == 2){
                    ans -= 0.25;
                }
                else if (left[i] + right[i] == 1){
                    ans -= 0.5;
                }
                mx[i] = to;
                right[i] = 0;
                left[i] = 1;
            }
            else if (val == j){
                if (left[i]){
                    break;
                }
                ans -= 0.25;
                left[i] = 1;
                break;
            }
            else break;
            j--;
            i++;
        }
        arr.pb(ans);
    }
    return arr;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    vector<pair<int,int>> p(q);
    for (int i = 0; i < q; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first = n - p[i].first;
        p[i].second = m - p[i].second;
    }
    vector<ld> ans = solve(n, m, q, p);
    for (auto to : ans){
        cout << setprecision(2) << fixed << to << endl;
    }
    return 0;
}
