#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define ll long long

mt19937 rnd(51);

int get(int i, pair<int,int> p){
    if (p == make_pair(-1ll, -1ll)){
        return 0;
    }
    return p.second - abs(i - p.first);
}

vector<ld> solve(int n, int m, int q, vector<pair<int,int>> p){
    vector<pair<int,int>> mx(n, {-1, -1});
    vector<int> left(n), right(n);
    vector<ld> arr;
    set<int> super, zero;
    for (int i = 0; i < n; i++){
        zero.insert(i);
    }
    ld ans = n * m;
    for (auto to : p){
        int i = to.first - 1, j = to.second;
        if (j >= get(i, mx[i])){
            int l = -1, r = n;
            while(r - l > 1){
                int mid = (r + l) / 2;
                if (i - mid < 0 || j - mid <= 0){
                    r = mid;
                    continue;
                }
                if (get(i - mid, mx[i - mid]) < j - mid){
                    l = mid;
                }
                else{
                    r = mid;
                }
            }
            while(super.lower_bound(i - l) != super.end()){
                int val = *super.lower_bound(i - l);
                if (val > i) break;
                ans += 0.25;
                super.erase(val);
            }
            while(zero.lower_bound(i - l) != zero.end()){
                int val = *zero.lower_bound(i - l);
                if (val > i) break;
                ans += 0.5;
                zero.erase(val);
            }
            ans -= (ld)(l + 1) * 0.5;
            for (int f = i - l; f <= i; f++){
                ans -= (ld)j - (ld)get(f, mx[f]) - 0.5;
                mx[f] = {to.first - 1, to.second};
                left[f] = 0, right[f] = 1;
                j--;
            }
            i = i - l - 1;
            if (j > 0 && i >= 0 && get(i, mx[i]) == j){
                if (!right[i]){
                    ans -= 0.25;
                    right[i] = 1;
                    super.insert(i);
                }
            }
        }
        i = to.first, j = to.second;
        if (j >= get(i, mx[i])){
            int l = -1, r = n;
            while(r - l > 1){
                int mid = (r + l) / 2;
                if (i + mid >= n || j - mid <= 0){
                    r = mid;
                    continue;
                }
                if (get(i + mid, mx[i + mid]) < j - mid){
                    l = mid;
                }
                else{
                    r = mid;
                }
            }
            while(super.lower_bound(i) != super.end()){
                int val = *super.lower_bound(i);
                if (val > i + l) break;
                ans += 0.25;
                super.erase(val);
            }
            while(zero.lower_bound(i) != zero.end()){
                int val = *zero.lower_bound(i);
                if (val > i + l) break;
                ans += 0.5;
                zero.erase(val);
            }
            ans -= (ld)(l + 1) * 0.5;
            for (int f = i; f <= i + l; f++){
                ans -= (ld)j - (ld)get(f, mx[f]) - 0.5;
                mx[f] = {to.first, to.second};
                right[f] = 0, left[f] = 1;
                j--;
            }
            i = i + l + 1;
            if (j > 0 && i < n && get(i, mx[i]) == j){
                if (!left[i]){
                    ans -= 0.25;
                    left[i] = 1;
                    super.insert(i);
                }
            }
        }
        arr.pb(ans);
    }
    return arr;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    vector<pair<int,int>> p(q);
    for (int i = 0; i < q; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first = n - p[i].first;
        p[i].second = m - p[i].second;
    }
    vector<ld> ans = solve(n, m, q, p);
    for (auto to : ans){
        cout << setprecision(2) << fixed << to << endl;
    }
    return 0;
}
