#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define ll long long

mt19937 rnd(51);

const int INF = 1e18;

int calc(int l, int r, int i, int j){
    int sum;
    if (make_pair(i, j) == make_pair(-1ll, -1ll)){
        sum = 0;
    }
    else{
        int dl = (r - l + 1);
        if (i >= l){
            sum = j * dl - i * dl + r * (r + 1) / 2 - l * (l - 1) / 2;
        }
        else{
            sum = j * dl + i * dl - r * (r + 1) / 2 + l * (l - 1) / 2;
        }
    }
    return sum;
}

map<pair<int,int>, int> sum;
map<pair<int,int>, pair<int,int>> mx;

int get(int i, pair<int,int> p){
    if (p == make_pair(-1ll, -1ll)){
        return 0;
    }
    return p.second - abs(i - p.first);
}

set<pair<int,int>> st;

void add_seg(int l, int r, int i, int j){
    st.insert({l, r});
    mx[{l, r}] = {i, j};
    sum[{l, r}] = calc(l, r, i, j);
}

void show(){
    /*for (auto to : st){
        cout << "SEG " << to.first << ' ' << to.second << endl;
    }*/
}

void add(int l, int r, int i, int j){
    if (l > r) return;
    while(st.lower_bound({l, -1}) != st.end()){
        pair<int,int> p = *st.lower_bound({l, -1});
        if (p.second <= r){
            st.erase(p);
            continue;
        }
        if (p.first <= r){
            st.erase(p);
            add_seg(r + 1, p.second, mx[p].first, mx[p].second);
            break;
        }
        else break;
    }
    auto it = st.upper_bound({l, INF});
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        st.erase(p);
        add_seg(p.first, l - 1, mx[p].first, mx[p].second);
    }
    if (p.first <= r){
        add_seg(r + 1, p.second, mx[p].first, mx[p].second);
    }
    show();
    add_seg(l, r, i, j);
}

int get_val(int i){
    auto it = st.upper_bound({i, INF});
    it--;
    return get(i, mx[*it]);
}

vector<ld> solve(int n, int m, int q, vector<pair<int,int>> p){
    vector<pair<int,int>> mx(n, {-1, -1});
    vector<int> left(n), right(n);
    vector<ld> arr;
    set<int> super, zero;
    add_seg(-1, n, -1, -1);
    for (int i = 0; i < n; i++){
        zero.insert(i);
    }
    ld ans = n * m;
    for (auto to : p){
        int i = to.first - 1, j = to.second;
        if (j >= get_val(i)){
            int l = -1, r = n;
            while(r - l > 1){
                int mid = (r + l) / 2;
                if (i - mid < 0 || j - mid <= 0){
                    r = mid;
                    continue;
                }
                if (get_val(i - mid) < j - mid){
                    l = mid;
                }
                else{
                    r = mid;
                }
            }
            while(super.lower_bound(i - l) != super.end()){
                int val = *super.lower_bound(i - l);
                if (val > i) break;
                ans += 0.25;
                super.erase(val);
            }
            while(zero.lower_bound(i - l) != zero.end()){
                int val = *zero.lower_bound(i - l);
                if (val > i) break;
                ans += 0.5;
                zero.erase(val);
            }
            ans -= (ld)(l + 1) * 0.5;
            for (int f = i - l; f <= i; f++){
                ans -= (ld)j - (ld)get_val(f) - 0.5;
                mx[f] = {to.first - 1, to.second};
                left[f] = 0, right[f] = 1;
                j--;
            }
            add(i - l, i, to.first - 1, to.second);
            i = i - l - 1;
            if (j > 0 && i >= 0 && get_val(i) == j){
                if (!right[i]){
                    ans -= 0.25;
                    right[i] = 1;
                    super.insert(i);
                }
            }
        }
        i = to.first, j = to.second;
        if (j >= get_val(i)){
            int l = -1, r = n;
            while(r - l > 1){
                int mid = (r + l) / 2;
                if (i + mid >= n || j - mid <= 0){
                    r = mid;
                    continue;
                }
                if (get_val(i + mid) < j - mid){
                    l = mid;
                }
                else{
                    r = mid;
                }
            }
            while(super.lower_bound(i) != super.end()){
                int val = *super.lower_bound(i);
                if (val > i + l) break;
                ans += 0.25;
                super.erase(val);
            }
            while(zero.lower_bound(i) != zero.end()){
                int val = *zero.lower_bound(i);
                if (val > i + l) break;
                ans += 0.5;
                zero.erase(val);
            }
            ans -= (ld)(l + 1) * 0.5;
            show();
            for (int f = i; f <= i + l; f++){
                ans -= (ld)j - (ld)get_val(f) - 0.5;
                mx[f] = {to.first, to.second};
                right[f] = 0, left[f] = 1;
                j--;
            }
            add(i, i + l, to.first, to.second);
            i = i + l + 1;
            if (j > 0 && i < n && get_val(i) == j){
                if (!left[i]){
                    ans -= 0.25;
                    left[i] = 1;
                    super.insert(i);
                }
            }
        }
        arr.pb(ans);
    }
    return arr;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    vector<pair<int,int>> p(q);
    for (int i = 0; i < q; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first = n - p[i].first;
        p[i].second = m - p[i].second;
    }
    vector<ld> ans = solve(n, m, q, p);
    for (auto to : ans){
        cout << setprecision(2) << fixed << to << endl;
    }
    return 0;
}
