#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define ll long long

mt19937 rnd(51);

const int INF = 1e18;
ld ans;

int calc(int l, int r, int i, int j){
    int sum;
    if (make_pair(i, j) == make_pair(-1ll, -1ll)){
        sum = 0;
    }
    else{
        int dl = (r - l + 1);
        sum = 0;
        if (i >= r){
            sum += j * dl + r * (r + 1) / 2 - l * (l - 1) / 2 - i * dl;
        }
        else{
            sum += j * dl - r * (r + 1) / 2 + l * (l - 1) / 2 + i * dl;
        }
    }
    return sum;
}

map<pair<int,int>, pair<int,int>> mx;
set<pair<int,int>> Left, Right, zero;

int get(int i, pair<int,int> p){
    if (p == make_pair(-1ll, -1ll)){
        return 0;
    }
    return p.second - abs(i - p.first);
}

set<pair<int,int>> st;

void add_seg(int l, int r, int i, int j){
    st.insert({l, r});
    mx[{l, r}] = {i, j};
}

void add(int l, int r, int i, int j, bool f = 1){
    if (l > r) return;
    while(st.lower_bound({l, -1}) != st.end()){
        pair<int,int> p = *st.lower_bound({l, -1});
        int I = mx[p].first, J = mx[p].second;
        if (p.first <= r){
            st.erase(p);
            if (f) ans += calc(p.first, r, I, J);
            add_seg(r + 1, p.second, I, J);
            mx.erase(p);
        }
        break;
    }
    auto it = st.upper_bound({l, INF});
    it--;
    pair<int,int> p = *it;
    int I = mx[p].first, J = mx[p].second;
    if (l <= p.second){
        st.erase(p);
        mx.erase(p);
        if (f) ans += calc(l, min(r, p.second), I, J);
        add_seg(p.first, l - 1, I, J);
        if (r < p.second){
            add_seg(r + 1, p.second, I, J);
        }
    }
    add_seg(l, r, i, j);
}

int get_val(int i){
    auto it = st.upper_bound({i, INF});
    it--;
    return get(i, mx[*it]);
}

pair<int,int> mx_please(int i){
    auto it = st.upper_bound({i, INF});
    it--;
    return mx[*it];
}

bool is_Left(int i){
    auto it = Left.upper_bound({i, INF});
    it--;
    return (i <= it->second);
}

bool is_Right(int i){
    auto it = Right.upper_bound({i, INF});
    it--;
    return (i <= it->second);
}

void clear_Right(int l, int r){
    if (l > r) return;
    while(Right.lower_bound({l, -1}) != Right.end()){
        pair<int,int> p = *Right.lower_bound({l, -1});
        if (p.second <= r){
            Right.erase(p);
            continue;
        }
        if (p.first <= r){
            Right.erase(p);
            Right.insert({r + 1, p.second});
        }
        break;
    }
    auto it = Right.lower_bound({l, INF});
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        Right.erase(p);
        Right.insert({p.first, l - 1});
        if (r < p.second){
            Right.insert({r + 1, p.second});
        }
    }
}

void clear_Left(int l, int r){
    if (l > r) return;
    while(Left.lower_bound({l, -1}) != Left.end()){
        pair<int,int> p = *Left.lower_bound({l, -1});
        if (p.second <= r){
            Left.erase(p);
            continue;
        }
        if (p.first <= r){
            Left.erase(p);
            Left.insert({r + 1, p.second});
        }
        break;
    }
    auto it = Left.lower_bound({l, INF});
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        Left.erase(p);
        Left.insert({p.first, l - 1});
        if (r < p.second){
            Left.insert({r + 1, p.second});
        }
    }
}

void Zero(int l, int r){
    if (l > r) return;
    while(zero.lower_bound({l, -1}) != zero.end()){
        pair<int,int> p = *zero.lower_bound({l, -1});
        if (p.second <= r){
            zero.erase(p);
            ans += (ld)(p.second - p.first + 1) * 0.5;
            continue;
        }
        if (p.first <= r){
            zero.erase(p);
            ans += (ld)(r - p.first + 1) * 0.5;
            zero.insert({r + 1, p.second});
        }
        break;
    }
    auto it = zero.lower_bound({l, INF});
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        zero.erase(p);
        ans += (ld)(min(r, p.second) - l + 1) * 0.5;
        zero.insert({p.first, l - 1});
        if (r < p.second){
            zero.insert({r + 1, p.second});
        }
    }
}

vector<ld> solve(int n, int m, int q, vector<pair<int,int>> p){
    vector<ld> arr;
    set<int> super;
    add_seg(-1, n, -1, -1);
    Left.insert({-1, -1});
    Right.insert({-1, -1});
    zero.insert({-1, n});
    ans = n * m;
    for (auto to : p){
        int i = to.first - 1, j = to.second;
        pair<int,int> p = mx_please(i);
        if (i >= 0 && j >= get_val(i)){
            add(i, i, p.first, p.second, 0);
            auto it = st.lower_bound({i, -1});
            int need = -1;
            vector<pair<int,int>> del;
            while(1){
                pair<int,int> p = *it;
                pair<int,int> kek = mx[p];
                int dif = i - p.first;
                if (p.first == -1 || get_val(p.first) >= j - dif){
                    int l = p.first, r = p.second + 1;
                    while(r - l > 1){
                        int mid = (r + l) / 2;
                        if (get(mid, kek) < j - (i - mid)){
                            r = mid;
                        }
                        else{
                            l = mid;
                        }
                    }
                    need = i - r;
                    break;
                }
                else {
                    ans += calc(p.first, p.second, kek.first, kek.second);
                    del.pb(p);
                    it--;
                }
            }
            for (auto to : del){
                st.erase(to);
                mx.erase(to);
            }
            int l = need;
            while(super.lower_bound(i - l) != super.end()){
                int val = *super.lower_bound(i - l);
                if (val > i) break;
                ans += 0.25;
                super.erase(val);
            }
            ans -= j * (j + 1) / 2 - (j - l) * (j - l - 1) / 2;
            clear_Left(i - l, i);
            clear_Right(i - l, i);
            Right.insert({i - l, i});
            Zero(i - l, i);
            j -= (l + 1);
            add(i - l, i, to.first - 1, to.second);
            i = i - l - 1;
            if (j > 0 && i >= 0 && get_val(i) == j){
                if (!is_Right(i)){
                    ans -= 0.25;
                    Right.insert({i, i});
                    super.insert(i);
                }
            }
        }
        i = to.first, j = to.second;
        p = mx_please(i);
        if (i < n && j >= get_val(i)){
            add(i, i, p.first, p.second, 0);
            auto it = st.lower_bound({i, -1});
            int need = -1;
            vector<pair<int,int>> del;
            while(1){
                pair<int,int> p = *it;
                pair<int,int> kek = mx[p];
                int dif = p.second - i;
                if (p.second == n || get_val(p.second) >= j - dif){
                    int l = p.first - 1, r = p.second;
                    while(r - l > 1){
                        int mid = (r + l) / 2;
                        if (get(mid, kek) < j - (mid - i)){
                            l = mid;
                        }
                        else{
                            r = mid;
                        }
                    }
                    need = l - i;
                    break;
                }
                else {
                    ans += calc(p.first, p.second, kek.first, kek.second);
                    del.pb(p);
                    it++;
                }
            }
            for (auto to : del){
                st.erase(to);
                mx.erase(to);
            }
            int l = need;
            while(super.lower_bound(i) != super.end()){
                int val = *super.lower_bound(i);
                if (val > i + l) break;
                ans += 0.25;
                super.erase(val);
            }
            ans -= j * (j + 1) / 2 - (j - l) * (j - l - 1) / 2;
            clear_Left(i, i + l);
            clear_Right(i, i + l);
            Left.insert({i, i + l});
            Zero(i, i + l);
            add(i, i + l, to.first, to.second);
            j -= (l + 1);
            i = i + l + 1;
            if (j > 0 && i < n && get_val(i) == j){
                if (!is_Left(i)){
                    ans -= 0.25;
                    Left.insert({i, i});
                    super.insert(i);
                }
            }
        }
        arr.pb(ans);
    }
    return arr;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    vector<pair<int,int>> p(q);
    for (int i = 0; i < q; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first = n - p[i].first;
        p[i].second = m - p[i].second;
    }
    vector<ld> ans = solve(n, m, q, p);
    for (auto to : ans){
        cout << setprecision(2) << fixed << to << '\n';
    }
    return 0;
}
