#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define pb push_back
#define ll long long

mt19937 rnd(51);

const int INF = 1e18, N = 3e5 + 10;
int ans;
pair<int,int> mx[N];
vector<int> cnt(N);

int calc(int l, int r, int i, int j){
    int sum;
    if (make_pair(i, j) == make_pair(-1ll, -1ll)){
        sum = 0;
    }
    else{
        int dl = (r - l + 1);
        sum = 0;
        if (i >= r){
            sum += j * dl + r * (r + 1) / 2 - l * (l - 1) / 2 - i * dl;
        }
        else{
            sum += j * dl - r * (r + 1) / 2 + l * (l - 1) / 2 + i * dl;
        }
    }
    return sum;
}

set<pair<int,int>> Left, zero;

int get(int i, pair<int,int> p){
    if (p == make_pair(-1ll, -1ll)){
        return 0;
    }
    return p.second - abs(i - p.first);
}

set<pair<pair<int,int>, int>> st;

void add_seg(int l, int r, int i, int j){
    mx[cnt.back()] = {i, j};
    st.insert(make_pair(make_pair(l, r), cnt.back()));
    cnt.pop_back();
}

void add(int l, int r, int i, int j, bool f = 1){
    if (l > r) return;
    while(1){
        auto kek = *st.lower_bound(make_pair(make_pair(l, -1), -1));
        pair<int,int> p = kek.first;
        int I = mx[kek.second].first, J = mx[kek.second].second;
        if (p.first <= r){
            st.erase(kek);
            cnt.pb(kek.second);
            if (f) ans += calc(p.first, r, I, J) * 4;
            add_seg(r + 1, p.second, I, J);
        }
        break;
    }
    auto it = st.upper_bound(make_pair(make_pair(l, INF), -1));
    it--;
    auto kek = *it;
    pair<int,int> p = kek.first;
    int I = mx[kek.second].first, J = mx[kek.second].second;
    if (l <= p.second){
        st.erase(kek);
        cnt.pb(kek.second);
        if (f) ans += calc(l, min(r, p.second), I, J) * 4;
        add_seg(p.first, l - 1, I, J);
        if (r < p.second){
            add_seg(r + 1, p.second, I, J);
        }
    }
    add_seg(l, r, i, j);
}

int get_val(int i){
    auto it = st.upper_bound(make_pair(make_pair(i, INF), -1));
    it--;
    return get(i, mx[(*it).second]);
}

pair<int,int> mx_please(int i){
    auto it = st.upper_bound(make_pair(make_pair(i, INF), -1));
    it--;
    return mx[(*it).second];
}

bool is_Left(int i){
    auto it = Left.upper_bound(make_pair(i, INF));
    it--;
    return (i <= it->second);
}

void clear_Left(int l, int r){
    if (l > r) return;
    while(1){
        pair<int,int> p = *Left.lower_bound(make_pair(l, -1));
        if (p.second <= r){
            Left.erase(p);
            continue;
        }
        if (p.first <= r){
            Left.erase(p);
            Left.insert(make_pair(r + 1, p.second));
        }
        break;
    }
    auto it = Left.lower_bound(make_pair(l, INF));
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        Left.erase(p);
        Left.insert(make_pair(p.first, l - 1));
        if (r < p.second){
            Left.insert(make_pair(r + 1, p.second));
        }
    }
}

void Zero(int l, int r){
    if (l > r) return;
    while(1){
        pair<int,int> p = *zero.lower_bound(make_pair(l, -1));
        if (p.second <= r){
            zero.erase(p);
            ans += (ld)(p.second - p.first + 1) * 2;
            continue;
        }
        if (p.first <= r){
            zero.erase(p);
            ans += (ld)(r - p.first + 1) * 2;
            zero.insert(make_pair(r + 1, p.second));
        }
        break;
    }
    auto it = zero.lower_bound(make_pair(l, INF));
    it--;
    pair<int,int> p = *it;
    if (l <= p.second){
        zero.erase(p);
        ans += (ld)(min(r, p.second) - l + 1) * 2;
        zero.insert(make_pair(p.first, l - 1));
        if (r < p.second){
            zero.insert(make_pair(r + 1, p.second));
        }
    }
}

vector<int> solve(int n, int m, int q, vector<pair<int,int>> p){
    iota(cnt.begin(), cnt.end(), 0);
    vector<int> arr;
    set<int> super;
    add_seg(INF, INF, INF, INF);
    add_seg(-1, n, -1, -1);
    Left.insert({-1, -1});
    Left.insert({INF, INF});
    zero.insert({INF, INF});
    zero.insert({-1, n});
    ans = n * m * 4;
    for (auto to : p){
        int i = to.first - 1, j = to.second;
        pair<int,int> p = mx_please(i);
        if (i >= 0 && j >= get(i, p)){
            add(i, i, p.first, p.second, 0);
            auto it = st.lower_bound(make_pair(make_pair(i, -1), -1));
            int need = -1;
            vector<pair<pair<int,int>, int>> mem;
            while(1){
                auto quq = *it;
                pair<int,int> p = quq.first;
                pair<int,int> kek = mx[quq.second];
                int dif = i - p.first;
                if (p.first == -1 || get(p.first, kek) >= j - dif){
                    int l = p.first, r = p.second + 1;
                    while(r - l > 1){
                        int mid = (r + l) / 2;
                        if (get(mid, kek) < j - (i - mid)){
                            r = mid;
                        }
                        else{
                            l = mid;
                        }
                    }
                    need = i - r;
                    break;
                }
                else {
                    mem.pb(quq);
                    ans += calc(p.first, p.second, kek.first, kek.second) * 4;
                    it--;
                }
            }
            for (auto to : mem) {
                st.erase(to);
                cnt.pb(to.second);
            }
            int l = need;
            while(super.lower_bound(i - l) != super.end()){
                int val = *super.lower_bound(i - l);
                if (val > i) break;
                ans += 1;
                super.erase(val);
            }
            ans -= (j * (j + 1) / 2 - (j - l) * (j - l - 1) / 2) * 4;
            clear_Left(i - l, i);
            Zero(i - l, i);
            j -= (l + 1);
            add(i - l, i, to.first - 1, to.second);
            i = i - l - 1;
            if (j > 0 && i >= 0 && get_val(i) == j){
                if (is_Left(i)){
                    ans -= 1;
                    super.insert(i);
                }
            }
        }
        i = to.first, j = to.second;
        p = mx_please(i);
        if (i < n && j >= get(i, p)){
            add(i, i, p.first, p.second, 0);
            auto it = st.lower_bound(make_pair(make_pair(i, -1), -1));
            int need = -1;
            vector<pair<pair<int,int>, int>> mem;
            while(1){
                auto quq = *it;
                pair<int,int> p = quq.first;
                pair<int,int> kek = mx[quq.second];
                int dif = p.second - i;
                if (p.second == n || get(p.second, kek) >= j - dif){
                    int l = p.first - 1, r = p.second;
                    while(r - l > 1){
                        int mid = (r + l) / 2;
                        if (get(mid, kek) < j - (mid - i)){
                            l = mid;
                        }
                        else{
                            r = mid;
                        }
                    }
                    need = l - i;
                    break;
                }
                else {
                    mem.pb(quq);
                    ans += calc(p.first, p.second, kek.first, kek.second) * 4;
                    it++;
                }
            }
            for (auto to : mem){
                st.erase(to);
                cnt.pb(to.second);
            }
            int l = need;
            while(super.lower_bound(i) != super.end()){
                int val = *super.lower_bound(i);
                if (val > i + l) break;
                ans += 1;
                super.erase(val);
            }
            ans -= (j * (j + 1) / 2 - (j - l) * (j - l - 1) / 2) * 4;
            clear_Left(i, i + l);
            Left.insert({i, i + l});
            Zero(i, i + l);
            add(i, i + l, to.first, to.second);
            j -= (l + 1);
            i = i + l + 1;
            if (j > 0 && i < n && get_val(i) == j){
                if (!is_Left(i)){
                    ans -= 1;
                    Left.insert({i, i});
                    super.insert(i);
                }
            }
        }
        arr.pb(ans);
    }
    return arr;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    vector<pair<int,int>> p(q);
    for (int i = 0; i < q; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first = n - p[i].first;
        p[i].second = m - p[i].second;
    }
    vector<int> ans = solve(n, m, q, p);
    for (auto to : ans){
        cout << setprecision(2) << fixed << (ld)to / (ld)4.0 << '\n';
    }
    return 0;
}
