#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int NMAX = 5e5;

vector <int> edges[NMAX + 1];

int depth[NMAX + 1];
bool viz[NMAX + 1];

void dfs( int node, int d ) {
    viz[node] = 1;
    depth[node] = d;
    for ( auto it : edges[node] ) {
        if ( !viz[it] ) {
            dfs( it, d + 1 );
        }
    }
}
string find_reverse (int N, int M, int connections[][2] ) {
    int i;
    string ans;
    ans.resize( M );
    for ( i = 0; i < M; i ++ ) {
        edges[connections[i][0]].push_back( connections[i][1] );
    }
    for ( i = 1; i <= N; i ++ ) {
        if ( !viz[i] )
            dfs( i, 0 );
    }
    for ( i = 0; i < M; i ++ ) {
        if ( depth[connections[i][0]] > depth[connections[i][1]] )
            ans[i] = '1';
        else
            ans[i] = '0';
    }
    return ans;
}
//int v[NMAX + 1][2];
//
//int main() {
//    int n, m, i;
//    cin >> n >> m;
//    for ( i = 0; i < m; i ++ ) {
//        cin >> v[i][0] >> v[i][1];
//    }
//    cout << find_reverse( n, m, v );
//    return 0;
//}
