#include <iostream>
#include <vector>
#include <string>
#include <stack>

using namespace std;

const int NMAX = 5e5;

vector <int> edges[NMAX + 1];

int depth[NMAX + 1];

int d;
void dfs( int node ) {
    depth[node] = d;
    for ( auto it : edges[node] ) {
        if ( !depth[it] ) {
            d ++;
            dfs( it );
            d --;
        }
    }
}
string find_reverse (int N, int M, int connections[][2]) {
    int i;
    string ans = "";
    for ( i = 0; i < M; i ++ ) {
        edges[connections[i][0]].push_back( connections[i][1] );
    }
    d = 1;
    for ( i = N; i >= 1; i -- ) {
        if ( !depth[i] )
            dfs( i );
    }
    for ( i = 0; i < M; i ++ ) {
        if ( depth[connections[i][0]] > depth[connections[i][1]] )
            ans += '1';
        else
            ans += '0';
    }
    return ans;
}
//int v[NMAX + 1][2];
//
//int main() {
//    int n, m, i;
//    cin >> n >> m;
//    for ( i = 0; i < m; i ++ ) {
//        cin >> v[i][0] >> v[i][1];
//    }
//    cout << find_reverse( n, m, v );
//    return 0;
//}
