#include <iostream>

using namespace std;

const int NMAX = 1e5;

double v[NMAX + 1];
int n, m;

void update( int x, double height, int add ) {
    while ( x <= n && x >= 1 && height > v[x] ) {
        v[x] = height;
        height --;
        x += add;
    }
}
double sum() {
    double s = 0;
    for ( int i = 1; i <= n; i ++ ) {
        s += v[i];
    }
    return s;
}
int main() {
    int q, x, y, i, area;
    cin >> n >> m >> q;
    area = n * m;
    for ( i = 0; i < q; i ++ ) {
        cin >> x >> y;
        update( x + 1, m - y - 0.5, 1 );
        update( x, m - y - 0.5, -1 );

        cout << "The Area is: " << area - sum() << endl;
    }
    return 0;
}
