#include <iostream>
#include <iomanip>

using namespace std;

const int NMAX = 1e5;

long long v[NMAX + 1];
long long n, m;

void update( int x, long long height, int add ) {
    while ( x <= n && x >= 1 && height > v[x] ) {
        v[x] = height;
        height --;
        x += add;
    }
}
int half;
long long sum() {
    long long s = 0;
    half = 0;
    for ( int i = 1; i <= n; i ++ ) {
        s += v[i];
        if ( v[i] > 0 )
            half ++;
    }
    return s;
}
int main() {
    int q, x, y, i;
    long long area;
    cin >> n >> m >> q;
    area = n * m;
    for ( i = 0; i < q; i ++ ) {
        cin >> x >> y;
        update( x + 1, m - y, 1 );
        update( x, m - y, -1 );

        cout << area - sum() + ( half ) / 2;
        if ( half % 2 == 1 )
            cout << ".50";
        else
            cout << ".00";
        cout << '\n';
    }
    return 0;
}
