#include <iostream>
#include <iomanip>
using namespace std;
const int NMAX = 1e6 + 5;
long double v[NMAX + 1];
long long n, m;
void update( int x, long double height, int add ) {
    while ( x <= n && x >= 1 && height >= v[x] ) {
        if ( height == 0 )
            return;
        if ( height == v[x] && height - 1 != v[x + add] ) {
            v[x] = height + 0.25;
            return;
        } else
            v[x] = height;
        height --;
        x += add;
    }
}
long double sum() {
    long double s = 0;
    for ( int i = 1; i <= n; i ++ ) {
        s += v[i];
    }
    return s;
}
int main() {
    int q, x, y, i;
    long double area;
    cin >> n >> m >> q;
    area = n * m;
    for ( i = 0; i < q; i ++ ) {
        cin >> x >> y;
        update( x + 1, m - y - 0.5, 1 );
        update( x, m - y - 0.5, -1 );
        cout << fixed << setprecision( 2 ) << area - sum() << '\n';
    }
    return 0;
}
