#include <bits/stdc++.h>

using namespace std;

const int MAX = 15005;

int N[2], A[2][MAX], B[2][MAX], CNT[MAX];
pair<bool, bool> dp[MAX][MAX + 5][2];

void Solve(int t, int MX) {
	dp[0][0][t] = {true, true};
	for (int i = 1; i <= N[t]; i++) {
		for (int j = 0; j <= MX; j++) {
			dp[i][j][t] = dp[i - 1][j][t];
			dp[i][j][t].second = false;
			if (j >= A[t][i] && dp[i - 1][j - A[t][i]][t].first) {
				dp[i][j][t] = {true, true};
			}
		}
	}
}

void Rec(int t, int f) {
	vector<int> ans;
	int x = N[t];
	while (x > 0) {
		if (dp[x][f][t].second) {
			ans.push_back(x);
			f -= A[t][x];
		}
		x--;
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] - 1 << " ";
	}
	cout << '\n';
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> N[0];
	for (int i = 1; i <= N[0]; i++) {
		cin >> A[0][i];
		B[0][i] = A[0][i];
	}
	cin >> N[1];
	for (int i = 1; i <= N[1]; i++) {
		cin >> A[1][i];
		B[1][i] = A[1][i];
	}
	sort(B[0] + 1, B[0] + 1 + N[0]);
	sort(B[1] + 1, B[1] + 1 + N[1]);
	for (int i = 1; i <= sqrt(N[0]); i++) {
		CNT[B[0][i]]++;
	}
	for (int i = 1; i <= sqrt(N[1]); i++) {
		CNT[B[1][i]]++;
	}
	/*function<void(vector<vector<tuple<bool, int, bool>>>&, vector<int>)> Solve = [&](vector<vector<tuple<bool, int, bool>>>& dp, vector<int> a) {
		int n = a.size() - 1;
		dp[0][0] = {true, 0, true};
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j <= N * M; j++) {
				dp[i][j] = dp[i - 1][j];
				get<2>(dp[i][j]) = false;
				if (j >= a[i] && get<0>(dp[i - 1][j - a[i]])) {
					get<0>(dp[i][j]) = true;
					get<1>(dp[i][j]) = i - 1;
					get<2>(dp[i][j]) = true;
				}
			}
		}
	};*/
	/*function<void(vector<vector<tuple<bool, int, bool>>>, int, int, vector<int>)> Rec = [&](vector<vector<tuple<bool, int, bool>>> dp, int x, int k, vector<int> a) {
		vector<int> ans;
		int pos = k;
		while (pos > 0) {
			if (get<2>(dp[pos][x])) {
				ans.push_back(pos);
				x -= a[pos];
			}
			pos--;
		}
		reverse(ans.begin(), ans.end());
		cout << ans.size() << '\n';
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] - 1 << " ";
		}
		cout << '\n';
	};*/
	/*vector<vector<tuple<bool, int, bool>>> dp_a(N + 1, vector<tuple<bool, int, bool>>(N * M + 1));
	vector<vector<tuple<bool, int, bool>>> dp_b(M + 1, vector<tuple<bool, int, bool>>(N * M + 1));
	Solve(dp_a, A);
	Solve(dp_b, B);*/
	if (N[0] <= 0 && N[1] <= 0) {
		Solve(0, MAX * MAX);
		Solve(1, MAX * MAX);
		/*for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n * m; j++) {
				cout << get<0>(dp_a[i][j]) << " ";
			}
			cout << '\n';
		}*/
		for (int x = 1; x <= MAX * MAX; x++) {
			if (dp[N[0]][x][0].first && dp[N[1]][x][1].first) {
				//cout << x << '\n';
				Rec(0, x);
				Rec(1, x);
				return 0;
			}
		}
	}
	Solve(0, max(N[0], N[1]));
	Solve(1, max(N[0], N[1]));
	for (int x = 1; x <= max(N[0], N[1]); x++) {
		if (dp[N[0]][x][0].first && dp[N[1]][x][1].first && CNT[x]) {
			Rec(0, x);
			Rec(1, x);
			return 0;
		}
	}
	return 0;
}