#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define SPEED ios_base::sync_with_stdio(false); cin.tie(0), cout.tie(0)
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define endl '\n'
using namespace std;

int n, m, a[1000005], b[1000005], p1[305][90005], p2[305][90005], sum;
bool dp1[305][90005], dp2[305][90005];
vector<int>ans1, ans2;

void path1(int s, int pos)
{
    if(!s or !pos) return;
    //cout<<s<<' '<<pos<<' '<<p1[pos][s]<<endl;
    ans1.pb(p1[pos][s]);
    path1(s-a[p1[pos][s]], p1[p1[pos][s]][s-a[p1[pos][s]]]);
}

void path2(int s, int pos)
{
    if(!s or !pos) return;
    //cout<<s<<' '<<pos<<' '<<p1[pos][s]<<endl;
    ans2.pb(p2[pos][s]);
    path2(s-b[p2[pos][s]], p2[p2[pos][s]][s-b[p2[pos][s]]]);
}

void solve()
{
	dp1[0][0]=1;
    for(int i=1; i<=n; i++)
    {
        for(int j=300*300; j>=0; j--)
        {
            if(dp1[i-1][j])
            {
                if(!dp1[i][j+a[i]])
                {
                    dp1[i][j+a[i]]=1;
                    p1[i][j+a[i]]=i;
                }
                dp1[i][j]=1;
                p1[i][j]=p1[i-1][j];
            }
        }
    }
    dp2[0][0]=1;
    for(int i=1; i<=m; i++)
    {
        for(int j=300*300; j>=0; j--)
        {
            if(dp2[i-1][j])
            {
                if(!dp2[i][j+b[i]])
                {
                    dp2[i][j+b[i]]=1;
                    p2[i][j+b[i]]=i;
                }
                dp2[i][j]=1;
                p2[i][j]=p2[i-1][j];
            }
        }
    }
    
    for(int i=1; i<=300*300; i++)
        if(dp1[n][i] and dp2[m][i])
        {
            sum=i;
            break;
        }
    
    path1(sum, n);
    path2(sum, m);
    
    cout<<ans1.size()<<endl;
    for(int u : ans1)cout<<u-1<<' ';
    cout<<endl<<ans2.size()<<endl;
    for(int u : ans2)cout<<u-1<<' ';
    
}

int main()
{
    SPEED;
    
    cin>>n;
    for(int i=1; i<=n; i++)
        cin>>a[i];
    
    cin>>m;
    for(int j=1; j<=m; j++)
        cin>>b[j];

    if(n==1 or m==1) while(1)b[0]++;

    if(n<=300 and m<=300)
    {
    	solve();
    	return 0;
    }
    
    int xa[1000005], xb[1000005];
    memset(xa, -1, sizeof(xa));
    memset(xb, -1, sizeof(xb));

    for(int i=1; i<=n; i++)
        xa[a[i]]=i-1;

    for(int j=1; j<=m; j++)
        xb[b[j]]=j-1;

    for(int i=1; i<=1000000; i++)
    {
        if(xa[i]!=-1 and xb[i]!=-1)
        {
            cout<<1<<endl<<xa[i]<<endl<<1<<endl<<xb[i]<<endl;
            return 0;
        }
    }
    return 0;
}
