#include <iostream>
#include <queue>
#include <vector>

#define MAX_N 500000
#define MAX_M 1500000

using namespace std;

int viz[MAX_N], rev[MAX_N];
queue <int> q;
vector <int> edge[MAX_N + 1][2];

void bfs( int nod, int c[][2] ) {
    int e, i;

    while ( !q.empty() )
        q.pop();

    viz[nod] = 1;
    q.push( nod );
    while ( !q.empty() ) {
        nod = q.front();
        q.pop();


        for ( i = 0; i < edge[nod][0].size(); i++ ) {
            e = edge[nod][0][i];
            if ( viz[c[e][1]] == 0 )
                rev[e] = 1;
        }

        for ( i = 0; i < edge[nod][1].size(); i++ ) {
            e = edge[nod][1][i];
            if ( viz[c[e][0]] == 0 ) {
                viz[c[e][0]] = 1;
                q.push( c[e][0] );
            }
        }
    }
}

std::string find_reverse( int n, int m, int connections[][2] ) {
    int i;
    string ans;

    for ( i = 0; i < m; i++ ) {
        edge[connections[i][0]][0].push_back( i );
        edge[connections[i][1]][1].push_back( i );
    }

    bfs( n, connections );

    ans = "";
    for ( i = 0; i < m; i++ )
        ans += char( rev[i] + '0' );

    return ans;
}

/*int main() {
    int n, m, c[100][2], i;

    cin >> n >> m;
    for ( i = 0; i < m; i++ )
        cin >> c[i][0] >> c[i][1];

    cout << find_reverse( n, m, c );

    return 0;
}*/
