#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct seq {
    int sum;
    vector<int> inds;
    bool operator<(const seq& s) {
        return sum < s.sum;
    }
    bool operator==(const seq& s) {
        return sum == s.sum;
    }
};
int n, m;
vector<int> A;
vector<int> B;
vector<seq> getSeqA(int i) {
    if (i == n) {
        return {};
    }
    if (i == n - 1) {
        return { {A[i],{i}},{0,{}} };
    }
    vector<seq> v = getSeqA(i + 1);
    vector<seq> v1(v);
    for (int j = 0; j < v1.size(); j++) {
        v.push_back(v1[j]);
        v[v.size() - 1].sum += A[i];
        v[v.size() - 1].inds.push_back(i);
    }
    return v;
}
vector<seq> getSeqB(int i) {
    if (i == m) {
        return {};
    }
    if (i == m - 1) {
        return { {B[i],{i}},{0,{}} };
    }
    vector<seq> v = getSeqB(i + 1);
    int s = v.size();
    for (int j = 0; j < s; j++) {
        v.push_back(v[j]);
        v[v.size() - 1].sum += B[i];
        v[v.size() - 1].inds.push_back(i);
    }
    return v;
}
int main()
{
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    cin >> m;
    B.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> B[i];
    }
    vector<seq> va = getSeqA(0);
    vector<seq> vb = getSeqB(0);
    /*for (int i = 0; i < vb.size(); i++) {
        cout << vb[i].sum << " - ";
        for (int j = 0; j < vb[i].inds.size(); j++) {
            cout << vb[i].inds[j] << " ";
        }
        cout << endl;
    }*/
    sort(va.begin(), va.end());
    sort(vb.begin(), vb.end());
    int i = 0;
    int j = 0;
    while (1) {
        if (va[i] == vb[j] && va[i].sum != 0) {
            cout << va[i].inds.size() << endl;
            for (int k = 0;k < va[i].inds.size();k++) {
                cout << va[i].inds[k] << " ";
            }
            cout << endl;
            cout << vb[j].inds.size() << endl;
            for (int k = 0;k < vb[j].inds.size();k++) {
                cout << vb[j].inds[k] << " ";
            }
            cout << endl;
            break;
        }
        if (va[i] < vb[j]) {
            i++;
        }
        else
            j++;
    }
}