#include <bits/stdc++.h>

using namespace std;
/*
const int maxa = 300;
const int maxn = 300;

int dp1[maxa*maxn][maxn+1] = {0};
int dp2[maxa*maxn][maxn+1] = {0};

int main()
{
    int64_t n;
    cin >> n;
    int64_t a[n];
    for(int i = 0;i < n;++i)
    {
        cin >> a[i];
    }
    int64_t m;
    cin >> m;
    int64_t b[m];
    for(int i = 0;i < m;++i)
    {
        cin >> b[i];
    }
    for(int i = 0;i < maxa*maxn;++i)
    {
        for(int j = 0;j < n+1;++j)
        {
            if(j == 0)
            {
                if(i == 0)
                    dp1[i][j] = 1;
                else
                    dp1[i][j] = 0;
            }
            else
            {
                dp1[i][j] = 0;
                if(dp1[i][j-1] > 0)
                    dp1[i][j] = 1;
                if(i >= a[j-1])
                {
                    if(dp1[i][j] == 0 && dp1[i-a[j-1]][j-1] > 0)
                    {
                        dp1[i][j] = 2;
                    }
                }
            }
        }
    }
    for(int i = 0;i < maxa*maxn;++i)
    {
        for(int j = 0;j < m+1;++j)
        {
            if(j == 0)
            {
                if(i == 0)
                    dp2[i][j] = 1;
                else
                    dp2[i][j] = 0;
            }
            else
            {
                dp2[i][j] = 0;
                if(dp2[i][j-1] > 0)
                    dp2[i][j] = 1;
                if(i >= b[j-1])
                {
                    if(dp2[i][j] == 0 && dp2[i-b[j-1]][j-1] > 0)
                    {
                        dp2[i][j] = 2;
                    }
                }
            }

        }
    }
    for(int i = 1;i < maxa*maxn;++i)
    {
        if(dp1[i][n] > 0 && dp2[i][m] > 0)
        {
            vector<int> ans1;
            int64_t y = n;
            int64_t jj = i;
            while(y)
            {
                if(dp1[jj][y] == 2)
                {
                    ans1.push_back(y-1);
                    jj-=a[y-1];
                }
                y--;
            }
            vector<int> ans2;
            y = m;
            jj = i;
            while(y)
            {
                if(dp2[jj][y] == 2)
                {
                    ans2.push_back(y-1);
                    jj-=b[y-1];
                }
                y--;
            }
            cout << ans1.size() << "\n";
            for(auto c:ans1)
                cout << c << ' ';
            cout << "\n" << ans2.size() << "\n";
            for(auto c:ans2)
                cout << c << ' ';
            cout << "\n";
            return 0;
        }
    }
    return 0;
}*/
const int maxn = 1000000;

int64_t segTree[4*maxn] = {0};
pair<int,int> p[4*maxn];
int segTree2[4*maxn][3] = {0};
int p2[4*maxn];

void push(int64_t l,int64_t r,int64_t indV)
{
    if(l == r)
    {
        if(p[indV].first != -1)
            segTree[indV] = p[indV].first;
        p[indV].first = -1;
        return ;
    }
    if(p[indV].first == -1)
        return ;
    if(p[indV].second == 0)
    {
        segTree[indV] = p[indV].first*(r-l+1)-(r-l)*(r-l+1)/2;
        p[indV*2+1] = p[indV];
        p[indV*2+2] = {p[indV].first-((l+r)/2-l+1),p[indV].second};
    }
    else
    {
        segTree[indV] = p[indV].first*(r-l+1) + (r-l)*(r-l+1)/2;
        p[indV*2+1] = p[indV];
        p[indV*2+2] = {p[indV].first+((l+r)/2-l+1),p[indV].second};
    }
    p[indV].first = -1;
    return ;
}
void push2(int64_t l,int64_t r,int64_t indV)
{
    if(l == r)
    {
        if(p2[indV] != -1)
        {
            segTree2[indV][0] = 0;
            segTree2[indV][1] = 0;
            segTree2[indV][2] = 0;
            segTree2[indV][p2[indV]] = r-l+1;
        }
        p2[indV] = -1;
        return ;
    }
    if(p2[indV] != -1)
    {
        segTree2[indV][0] = 0;
        segTree2[indV][1] = 0;
        segTree2[indV][2] = 0;
        segTree2[indV][p2[indV]] = r-l+1;
        p2[indV*2+1] = p2[indV];
        p2[indV*2+2] = p2[indV];
        p2[indV] = -1;
    }
    return ;
}

void build(int64_t l,int64_t r,int64_t indV)
{
    p2[indV] = -1;
    p[indV].first = -1;
    if(l != r)
    {
        build(l,(l+r)/2,indV*2+1);
        build((l+r)/2+1,r,indV*2+2);
    }
    return ;
}
int64_t get(int64_t lx,int64_t rx,int64_t l,int64_t r,int64_t indV)
{
    push(l,r,indV);
    if(l > rx || r < lx)
    {
        return 0;
    }
    else if(l >= lx && r <= rx)
    {
        return segTree[indV];
    }
    int64_t sl = get(lx,rx,l,(l+r)/2,indV*2+1);
    int64_t sr = get(lx,rx,(l+r)/2+1,r,indV*2+2);
    return sl+sr;
}
int64_t g[3] = {0};
void get2(int64_t lx,int64_t rx,int64_t l,int64_t r,int64_t indV)
{
    push2(l,r,indV);
    if(l > rx || r < lx)
    {
        g[0] = 0;
        g[1] = 0;
        g[2] = 0;
        return ;
    }
    else if(l >= lx && r <= rx)
    {
        g[0] = segTree2[indV][0];
        g[1] = segTree2[indV][1];
        g[2] = segTree2[indV][2];
        return ;
    }
    get2(lx,rx,l,(l+r)/2,indV*2+1);
    int64_t sl[3];
    sl[0] = g[0];
    sl[1] = g[1];
    sl[2] = g[2];
    get2(lx,rx,(l+r)/2+1,r,indV*2+2);
    g[0] += sl[0];
    g[1] += sl[1];
    g[2] += sl[2];
    return ;
}
void modify(int64_t x,int64_t t,int64_t lx,int64_t rx,int64_t l,int64_t r,int64_t indV)
{
    push(l,r,indV);
    if(l > rx || r < lx)
    {
        return ;
    }
    else if(l >= lx && r <= rx)
    {
        if(t == 0)
            p[indV] = {x+lx,t};
        else
            p[indV] = {x-lx,t};
        push(l,r,indV);
        return ;
    }
    if(t == 0)
    {
        modify(x,t,lx,rx,l,(l+r)/2,indV*2+1);
        modify(x-((l+r)/2-l+1),t,lx,rx,(l+r)/2+1,r,indV*2+2);
    }
    else
    {
        modify(x,t,lx,rx,l,(l+r)/2,indV*2+1);
        modify(x+((l+r)/2-l+1),t,lx,rx,(l+r)/2+1,r,indV*2+2);
    }
    segTree[indV] = segTree[indV*2+1] + segTree[indV*2+2];
    return ;
}
void modify2(int64_t x,int64_t lx,int64_t rx,int64_t l,int64_t r,int64_t indV)
{
    push2(l,r,indV);
    if(l > rx || r < lx)
    {
        return ;
    }
    else if(l >= lx && r <= rx)
    {
        p2[indV] = x;
        push2(l,r,indV);
        return ;
    }
    modify2(x,lx,rx,l,(l+r)/2,indV*2+1);
    modify2(x,lx,rx,(l+r)/2+1,r,indV*2+2);
    segTree2[indV][0] = segTree2[indV*2+1][0]+segTree2[indV*2+2][0];
    segTree2[indV][1] = segTree2[indV*2+1][1]+segTree2[indV*2+2][1];
    segTree2[indV][2] = segTree2[indV*2+1][2]+segTree2[indV*2+2][2];
    return ;
}

int main()
{
    cout.precision(18);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int64_t n,m;
    cin >> n >> m;
    build(0,n-1,0);
    int64_t q;
    cin >> q;
    while(q--)
    {
        int64_t x,y;
        cin >> x >> y;
        y = m-y;
        int64_t l = max(int64_t(0),x-y),r = x;
        while(l < r)
        {
            int64_t t = (l+r)/2;
            if(get(t,t,0,n-1,0) > y-(x-t))
            {
                l = t+1;
            }
            else
                r = t;
        }
        int64_t l2 = x-1,r2 = min(n-1,x+y-1);
        while(l2 < r2)
        {
            int64_t t = (l2+r2+1)/2;
            if(get(t,t,0,n-1,0) > y-(t-x+1))
            {
                r2 = t-1;
            }
            else
                l2 = t;
        }
        if(l != x)
        {
            get2(l,l,0,n-1,0);
            modify2(1,l,x-1,0,n-1,0);
            if(get(l,l,0,n-1,0) == (y-(x-l)) && (g[0] == 1 || g[2] == 1))
            {
                modify2(2,l,l,0,n-1,0);
            }
            modify(y-(x-l),1,l,x-1,0,n-1,0);
        }
        if(l2 != x-1)
        {
            get2(l2,l2,0,n-1,0);
            modify2(0,x,l2,0,n-1,0);
            if(get(l2,l2,0,n-1,0) == y-(l2-x+1) && (g[1] == 1 || g[2] == 1))
            {
                modify2(2,l2,l2,0,n-1,0);
            }
            modify(y-1,0,x,l2,0,n-1,0);
        }
        get2(0,n-1,0,n-1,0);
        /*for(int i =0;i < segTree.size();++i)
        {
            cout << segTree[i] << ' ' << p[i].first << ' ' << p[i].second << "\n";
        }*/
        double res = (get(0,n-1,0,n-1,0)*4 + g[0]*2 + g[1]*2 + g[2]*3);
        cout << (double(n*m)-res/(4.0));
        if(int64_t(res)%4 == 0)
            cout << ".00\n";
        else if(int64_t(res)%4 == 2)
        {
            cout << "0\n";
        }
        else
            cout << "\n";
        /*y = m-y;
        int64_t tt = y-1;
        for(int i = x-1;i >= 0 && tt >= 0;--i)
        {
            if(a[i].first < tt)
            {
                a[i].first = tt;
                a[i].second = 2;
            }
            else if(a[i].first == tt)
            {
                if(a[i].second == 0)
                    a[i].second = 2;
                else if(a[i].second != 2)
                {
                    a[i].second = 3;
                }
            }
            tt--;
        }
        tt = y-1;
        for(int i = x;i < n && tt >= 0;++i)
        {
            if(a[i].first < tt)
            {
                a[i].first = tt;
                a[i].second = 1;
            }
            else if(a[i].first == tt)
            {
                if(a[i].second == 0)
                    a[i].second = 1;
                else if(a[i].second != 1)
                {
                    a[i].second = 3;
                }
            }
            tt--;
        }
        double ans = 0;
        for(int i =0;i < n;++i)
        {
            if(a[i].second != 1)
                ans += a[i].first*4 + a[i].second;
            else
                ans += a[i].first*4 + 2;
        }

        cout << (double(n*m)-(ans/4.0));

        if(int64_t(ans)%4 == 0)
            cout << ".00\n";
        else if(int64_t(ans)%4 == 2)
        {
            cout << "0\n";
        }
        else
            cout << "\n";*/
    }
}

