#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>

using namespace std;

const int MAX_N = 5e5 + 128;
vector <char> used(MAX_N);
string ans = "";
vector < set<int> > g(MAX_N);
map <pair<int, int>, int> edges;

void make(int v, int u) {
//    cout << "we make swap : " << v << " and " << u << '\n';
    ans[edges[{v, u}]] = (ans[edges[{v, u}]] == '0' ? '1' : '0');
    g[v].erase(u);
    g[u].insert(v);
    edges[{u, v}] = edges[{v, u}];
    edges[{v, u}] = -1;
}

void dfs(int v) {
    used[v] = true;
    vector <point> save_swap;
    for (auto u : g[v]) {
        if (used[u]) continue;
        dfs(u);
    }
    for (auto u : g[v])
        if (used[u])
            save_swap.pb({v, u});
//    cout << "swaps maked : " << (int) save_swap.size() << '\n';
    for (auto c : save_swap)
        make(c.first, c.second);
}

extern std::string find_reverse (int N, int M, int connections[][2]) {
    for (int i = 0; i < M; i++) ans += "0";
    for (int i = 0; i < M; i++)
        g[connections[i][0]-1].insert(connections[i][1]-1), edges[{connections[i][0]-1, connections[i][1]-1}] = i;
    dfs(0);
    return ans;
}
