#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>

using namespace std;

#define state second
#define id first

const ll MAX_M = 1.5e6 + 128;

vector <char> used;
vector < vector<ll> > g;
vector < vector<ll> > inv;

int ans[MAX_M];

unordered_map < ll , unordered_map<ll, pair<ll, char>> > edges;

void make(ll v, ll u) {
    ans[edges[v][u].id] = !ans[edges[v][u].id];
    edges[v][u].state = false;
    edges[u][v].state = true;
}

void dfs(ll v) {
    used[v] = true;

    for (auto u : g[v]) {
        if (edges[v][u].state == false)
            continue;
        if (used[u])
            continue;
        dfs(u);
    }
    for (auto u : inv[v]) {
        if (edges[v][u].state == false)
            continue;
        if (used[u])
            continue;
        dfs(u);
    }
    for (auto u : g[v])
        if (edges[v][u].state && used[u])
            make(v, u);
    for (auto u : inv[v])
        if (edges[v][u].state && used[u])
            make(u, v);
}

std::string find_reverse (int N, int M, int connections[][2]) {
    boost;
    g.resize(N); inv.resize(N); used.resize(N);
    for (int i = 0; i < M; i++) {
        ll u = connections[i][0] - 1;
        ll v = connections[i][1] - 1;
        g[u].push_back(v);
        inv[v].push_back(u);
        edges[u][v] = {i, true};
        edges[v][u] = {i, false};
    }
    for (int i = 0; i < N; i++)
        if (!used[i])
            dfs(i);
    string res = "";
    for (int i = 0; i < M; i++)
        res += char(ans[i] + '0');
    return res;
}
