#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>

using namespace std;

void test_case() {
    int n;
    cin >> n;
    vector <point> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first, a[i].second = i;
    int m;
    cin >> m;
    vector <point> b(m);
    for (int i = 0; i < m; i++)
        cin >> b[i].first, b[i].second = i;

    sort(all(a));
    sort(all(b));

    vector < vector < pair <int, vector<int>> > > sumA(n);
    vector < vector < pair <int, vector<int>> > > sumB(m);

    sumA[0].pb({a[0].first, {a[0].second}});

    for (int i = 1; i < n; i++) {
        int len = (int) sumA[i-1].size();
        sumA[i] = sumA[i-1];
        sumA[i].pb({a[i].first, {a[i].second}});
        for (int j = 0; j < len; j++) {
            sumA[i].pb(sumA[i][j]);
            sumA[i][j].first += a[i].first;
            sumA[i][j].second.pb(a[i].second);
        }
    }

    sumB[0].pb({b[0].first, {b[0].second}});

    for (int i = 1; i < m; i++) {
        int len = (int) sumB[i].size();
        sumB[i] = sumB[i-1];
        sumB[i].pb({b[i].first, {b[i].second}});
        for (int j = 0; j < len; j++) {
            sumB[i].pb(sumB[i][j]);
            sumB[i][j].first += a[i].first;
            sumB[i][j].second.pb(a[i].second);
        }
    }

    unordered_map < int, vector<int> > lstA;
    unordered_map < int, vector<int> > lstB;

    for (auto c : sumA.back())
        lstA[c.first] = c.second;
    for (auto c : sumB.back())
        lstB[c.first] = c.second;

    for (auto [l, r] : lstA)
        if (lstB.find(l) != lstB.end()) {
            cout << (int) r.size() << '\n';
            for (auto c : r)
                cout << c << ' ';
            cout << '\n';
            cout << (int) lstB[l].size() << '\n';
            for (auto c : lstB[l])
                cout << c << ' ';
            cout << '\n';
            return;
        }
    cout << "not found\n";
}

main () {
    boost;
    test_case();
    return 0;
}
