#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'
#define point pair<int, int>

using namespace std;

void test_case() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto &x : a)
        cin >> x;
    int m;
    cin >> m;
    vector <int> b(m);
    for (auto &x : b)
        cin >> x;

    unordered_map <int, vector<int>> sumA;
    for (int mask = 1; mask < (1ll << n); mask++) {
        vector <int> cur; ll sum = 0;
        for (int bit = 0; bit < n; bit++)
            if ((mask >> bit) & 1)
                cur.pb(bit), sum += a[bit];
        sumA[sum] = cur;
    }

    unordered_map <int, vector<int>> sumB;
    for (int mask = 1; mask < (1ll << m); mask++) {
        vector <int> cur; ll sum = 0;
        for (int bit = 0; bit < m; bit++)
            if ((mask >> bit) & 1)
                cur.pb(bit), sum += b[bit];
        sumB[sum] = cur;
    }

    for (auto [l, r] : sumA) {
        if (sumB.find(l) == sumB.end()) continue;
        cout << (int) r.size() << '\n';
        for (auto c : r)
            cout << c << ' ';
        cout << '\n';
        cout << (int) sumB[l].size() << '\n';
        for (auto c : sumB[l])
            cout << c << ' ';
        cout << '\n';
        return;
    }
}

main () {
    boost;
    test_case();
    return 0;
}
