#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef long double ld;

ll n, m, k;
ll cnt = 0;
ll a[30001], b[30001];
bool dp1[10001][100002];
bool dp2[10001][100002];
ll sm = 0, sm2 = 0;

void gets(ll val) {
    ll tmp = val;
    vector<int>ans1, ans2;
    int i1 = n, i2 = m;
    while (i1 != 0 && val != 0) {
        if (a[i1] <= val) {
            if (dp1[i1 - 1][val - a[i1]]) {
                val -= a[i1];
                i1--;
                ans1.push_back(i1);
            }
            else {
                i1--;
            }
        }
        else {
            i1--;
        }
    }
    val = tmp;
    while (i2 != 0 && val != 0) {
        if (b[i2] <= val) {
            if (dp2[i2 - 1][val - b[i2]]) {
                val -= b[i2];
                i2--;
                ans2.push_back(i2);
            }
            else {
                i2--;
            }
        }
        else {
            i2--;
        }
    }
    sort(ans1.begin(), ans1.end());
    sort(ans2.begin(), ans2.end());
    cout << ans1.size() << endl;
    for (int i = 0; i < ans1.size(); i++) {
        cout << ans1[i] << " ";
    }
    cout << endl;
    cout << ans2.size() << endl;
    for (int i = 0; i < ans2.size(); i++) {
        cout << ans2[i] << " ";
    }
    cout << endl;
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> b[i];
    }
    for (int i = 0; i <= n; i++) {
        dp1[i][0] = 1;
        if (i == 0) {
            continue;
        }
        sm += a[i];
        for (int j = 1; j <= sm; j++) {
            if (j >= a[i]) {
                dp1[i][j] = (dp1[i - 1][j] || dp1[i - 1][j - a[i]]);
            }
            else {
                dp1[i][j] = dp1[i - 1][j];
            }
        }
    }
    for (int i = 0; i <= m; i++) {
        dp2[i][0] = 1;
        if (i == 0) {
            continue;
        }
        sm2 += b[i];
        for (int j = 1; j <= sm2; j++) {
            if (j >= b[i]) {
                dp2[i][j] = (dp2[i - 1][j] || dp2[i - 1][j - b[i]]);
            }
            else {
                dp2[i][j] = dp2[i - 1][j];
            }
        }
    }
    for (int i = 1; i <= min(sm, sm2); i++) {
        if (dp1[n][i] && dp2[m][i]) {
            gets(i);
            break;
        }
    }
}