﻿#pragma GCC optimize("O3")
#include <string>
#include <vector>

using namespace std;

const int maxn = 5e5 + 5;

vector<pair<int, int>> g[maxn];

string ans;

int used[maxn];

void dfs(int v) {
    used[v] = 1;
    for (auto [u, ind] : g[v]) {
        if (used[u] == 0) {
            dfs(u);
        } else if (used[u] == 1) {
            if (ind > 0) {
                ans[ind - 1] = '1';
            }
        }
    }
    used[v] = 2;
}

string find_reverse (int n, int m, int connections[][2]) {
    ans = string(m, '0');
    for (int i = 0; i < m; ++i) {
        connections[i][0]--, connections[i][1]--;
        g[connections[i][0]].emplace_back(connections[i][1], i + 1);
        g[connections[i][1]].emplace_back(connections[i][0], -i - 1);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    return ans;
}