﻿#pragma GCC optimize("O3")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    int m;
    cin >> m;
    vector<pair<int, int>> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    unordered_set<int> s;
    for (int i = 0; i < n; ++i) {
        int sm = 0;
        for (int j = i; j < n; ++j) {
            sm += a[j].first;
            s.insert(sm);
        }
    }
    for (int i = 0; i < m; ++i) {
        int sm = 0;
        for (int j = i; j < m; ++j) {
            sm += b[j].first;
            if (s.count(sm)) {
                return 0;
            }
        }
    }
    return 1;
}