﻿#pragma GCC optimize("O3")

#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int maxn = 1e6 + 6;

vector<pair<int, int>> p_a[maxn], p_b[maxn];

long long pr[maxn], suf[maxn];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
        p_a[a[i].first].push_back(a[i]);
        sum += a[i].first;
    }
    int m;
    cin >> m;
    long long sum2 = 0;
    vector<pair<int, int>> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].first;
        b[i].second = i;
        p_b[b[i].first].push_back(b[i]);
        sum2 += b[i].first;
    }
//    sort(a.begin(), a.end());
//    sort(b.begin(), b.end());
    a.clear();
    b.clear();
    for (int i = 1; i <= m; ++i) {
        for (auto p : p_a[i]) {
            a.push_back(p);
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (auto p : p_b[i]) {
            b.push_back(p);
        }
    }
    vector<int> pos(m + 1, -1);
    for (int i = 0; i < n; ++i) {
        pos[a[i].first] = a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        if (b[i].first <= m && pos[b[i].first] != -1) {
            cout << 1 << '\n' << pos[b[i].first] << '\n' << 1 << '\n' << b[i].second;
            return 0;
        }
    }
    long long sm = 0;
    for (int j = 0; j < n; ++j) {
        sm += a[j].first;
        pr[j + 1] = sm;
        suf[n - j - 1] = sum - sm;
    }
    sm = 0;
    int p1 = 0, p2 = 0;
    for (int j = 0; j < m; ++j) {
        sm += b[j].first;
        while (p1 < n && pr[p1] < sm) {
            p1++;
        }
        while (p2 < n && suf[p2] < sm) {
            p2++;
        }
        if (p1 < n && pr[p1] == sm) {
            cout << p1 << '\n';
            for (int i = 0; i < p1; ++i) {
                cout << a[i].second << ' ';
            }
            cout << '\n';
            cout << j + 1 << '\n';
            for (int i = 0; i <= j; ++i) {
                cout << b[i].second << ' ';
            }
            return 0;
        }
        if (p2 + 1 < n && suf[p2] == sm) {
            cout << p2 << '\n';
            for (int i = n - p2; i < n; ++i) {
                cout << a[i].second << ' ';
            }
            cout << '\n';
            cout << j + 1 << '\n';
            for (int i = 0; i <= j; ++i) {
                cout << b[i].second << ' ';
            }
            return 0;
        }
    }
    p1 = 0, p2 = 0;
    for (int j = 0; j + 1 < m; ++j) {
        sm += b[j].first;
        while (p1 < n && pr[p1] < sum2 - sm) {
            p1++;
        }
        while (p2 < n && suf[p2] < sum2 - sm) {
            p2++;
        }
        if (p1 < n && pr[p1] == sum2 - sm) {
            cout << p1 << '\n';
            for (int i = 0; i < p1; ++i) {
                cout << a[i].second << ' ';
            }
            cout << '\n';
            cout << m - j - 1 << '\n';
            for (int i = j + 1; i < m; ++i) {
                cout << b[i].second << ' ';
            }
            return 0;
        }
        if (p2 + 1 < n && suf[p2] == sum2 - sm) {
            cout << p2 << '\n';
            for (int i = n - p2; i < n; ++i) {
                cout << a[i].second << ' ';
            }
            cout << '\n';
            cout << m - j - 1 << '\n';
            for (int i = j + 1; i < m; ++i) {
                cout << b[i].second << ' ';
            }
            return 0;
        }
    }
    return 1;
}