#include <iostream>
#include <algorithm>
#include <vector>

#define int long long

using namespace std;


main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    vector<pair<int, int> > s1, s2;

    int n, m;
    cin >> n;
    vector<pair<int, int> > a(n);
    int ma1 = -1;
    for(int i = 0; i < n; i ++){
        cin >> a[i].first;
        a[i].second = i;
        ma1 = max(ma1, a[i].first);
    }
    cin >> m;
    vector<pair<int, int> > b(m);
    int ma2 = -1;
    for(int i = 0; i < m; i ++){
        cin >> b[i].first;
        b[i].second = i;
        ma2 = max(ma2, b[i].first);
    }

    s1.resize(n * ma1 + 5);
    s2.resize(ma2 * m + 5);
    s1[0].first = s2[0].first = 1;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    for(int i = 0; i < n; i ++)
        for(int j = s1.size() - 1; j >= 0; j --)
            if (s1[j].first > 0 && j + a[i].first < s1.size() && s1[j + a[i].first].first == 0){
                s1[j + a[i].first].first = i + 1;
                s1[j + a[i].first].second = a[i].second;
            }

//    for(int i = 1; i <= n * m; i ++)
//        if (s1[i] > 0)
//            cout << i << ' ' << s1[i] - 1 << ' ' << a[s1[i] - 1].first << '\n';

    for(int i = 0; i < m; i ++)
        for(int j = s2.size() - 1; j >= 0; j --)
            if (s2[j].first > 0 && j + b[i].first < s2.size() && s2[j + b[i].first].first == 0){
                s2[j + b[i].first].first = i + 1;
                s2[j + b[i].first].second = b[i].second;
            }

    for(int i = 1; i <= n * m; i ++)
        if (s1[i].first > 0 && s2[i].first > 0){
            vector<int> ans;
            int sum = i;
            while(sum > 0){
                ans.push_back(s1[sum].second);
                sum -= a[s1[sum].first - 1].first;
            }
            cout << ans.size() << '\n';
            for(int i = 0; i < ans.size(); i ++)
                cout << ans[i] << ' ';
            cout << '\n';

            ans.clear();
            sum = i;
            while(sum > 0){
                ans.push_back(s2[sum].second);
                sum -= b[s2[sum].first - 1].first;
            }
            cout << ans.size() << '\n';
            for(int i = 0; i < ans.size(); i ++)
                cout << ans[i] << ' ';


            break;
        }
}

/*
5
2 2 4 4 6
4
10 7 7 1
*/
