#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#define fi first
#define se second
#define all(m) (m).begin(), (m).end()
#define mp make_pair
#define vec vector

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef tuple <int, int, int> tui;

const int maxn = 5e5;

int used[maxn];
vector <pii> g[maxn], gt[maxn];

vector <int> order;

mt19937 rng((uint64_t) new char);

int val[maxn], cnt, z, st;

void dfs(int v){
    order.push_back(v);
    used[v] = 1;
    for (auto [to, r]: g[v]){
        if (!used[to]){
            dfs(to);
        }
    }
}

void color(int v, int col){
    used[v] = col;
    for (auto [to, r]: gt[v]){
        if (used[to] == -1){
            color(to, col);
        }
    }
}

void dfs2(int v, vector <int> &cycle, vector <bool> &u){
    u[val[v]] = 1;
    for (auto [to, r]: g[v]){
        if (used[to] != used[v]) continue;
        if (!u[val[to]]){
            cycle.push_back(r);
            dfs2(to, cycle, u);
        }
        if (cnt == z && to == st){
            cycle.push_back(r);
            return;
        }
    }
}

string find_reverse(int n, int m, int connections[][2]){
    string res(m, '0');
    for (int i = 0; i < m; ++i){
        auto [u, v] = connections[i];
        g[u].push_back({v, i});
        gt[v].push_back({u, i});
    }
    for (int i = 1; i <= n; ++i){
        if (!used[i]){
            dfs(i);
        }
    }
    reverse(all(order));
    for (int i = 1; i <= n; ++i){
        used[i] = -1;
    }
    int c = 0;
    for (auto &v: order){
        if (used[v] == -1){
            color(v, c);
            c++;
        }
    }
    vector <vector <int>> cm(c + 42);
    for (int i = 1; i <= n; ++i){
        cm[used[i]].push_back(i);
    }
    for (int i = 0; i < c; ++i){
        if (cm[i].size() <= 1) continue;
        int z = 0;
        for (auto &v: cm[i]){
            val[v] = z++;
        }
        vector <bool> u(z, 0);
        vector <int> cycle;
        st = cm[i][0];
        cnt = 0;
        dfs2(st, cycle, u);
        for (int i = 0; i < cycle.size(); i++){
            if (rng() & 1) res[cycle[i]] = '1';
        }
    }
    return res;
}


