#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#define fi first
#define se second
#define all(m) (m).begin(), (m).end()
#define mp make_pair
#define vec vector

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef tuple <int, int, int> tui;

const int maxn = 9050;

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector <int> a(n), b(m);
    for (auto &i: a) cin >> i;
    for (auto &i: b) cin >> i;
    bitset <maxn> s1, s2;
    s1[0] = 1;
    for (int i = 0; i < n; ++i){
        s1 |= (s1 << a[i]);
    }
    s2[0] = 1;
    for (int i = 0; i < m; ++i){
        s2 |= (s2 << b[i]);
    }
    for (int j = 1; j < maxn; ++j){
        if (s1[j] && s2[j]){
            int maxs = j + 1;
            vector <int> p(maxs, -1);
            p[0] = -2;
            for (int i = 0; i < n; ++i){
                for (int s = 0; s + a[i] < maxs; ++s){
                    if (p[s] != -1 && p[s + a[i]] == -1){
                        p[s + a[i]] = i;
                    }
                }
            }
            vector <int> f;
            int st = j;
            while(st != 0){
                f.push_back(p[st]);
                st -= a[f.back()];
            }
            p = vector <int> (maxs, -1);
            p[0] = -2;
            for (int i = 0; i < m; ++i){
                for (int s = 0; s + b[i] < maxs; ++s){
                    if (p[s] != -1 && p[s + b[i]] == -1){
                        p[s + b[i]] = i;
                    }
                }
            }
            vector <int> sc;
            st = j;
            while(st != 0){
                sc.push_back(p[st]);
                st -= b[sc.back()];
            }
            cout << f.size() << "\n";
            for (auto &i: f) cout << i << " ";
            cout << sc.size() << "\n";
            for (auto &i: sc) cout << i << " ";
            return 0;
        }
    }
    return 0;
}
