#include <iostream>
#include <vector>
#include <queue>
#include <map>
using namespace std;

vector<int> g[500005];

vector<pair<int, int>> vv;

bool visit[500005];

queue<int> q, qq;

map<pair<int, int>, int> mp, mp0;

void bfs()
{
	int i, j;
	int u, v;
	visit[1] = true;
	q.push(1);
	while (!q.empty()) {
		u = q.front();
		q.pop();
		for (i = 0; i < g[u].size(); i++) {
			v = g[u][i];
			if (mp0[{u, v}] == 0) {
				vv.push_back(make_pair(u, v));
				mp0[{ u, v }] = 10;
				mp0[{ v, u }] = 20;
			}
			if (visit[v]) {
				continue;
			}
			q.push(v);
			visit[v] = true;
		}
	}
	return;
}

string find_reverse(int N, int M, int connections[][2])
{
	int i, j;
	for (i = 0; i < M; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		g[x].push_back(y);
		g[y].push_back(x);
		mp[make_pair(x, y)] = 10;
		mp[make_pair(y, x)] = 20;
	}
	bfs();
	string s = "";
	for (i = 0; i < M; i++) {
		int x = connections[i][0];
		int y = connections[i][1];
		if (mp[make_pair(x, y)] == mp0[make_pair(x, y)]) {
			s += '0';
		}
		else {
			s += '1';
		}
	}
	return s;
}