#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second

vector<vector<pair<int, int>>> g;
vector<int> used;
vector<int> ans;
map<pair<int, int>, int> mp;

void dfs(int v) {
    used[v] = 1;
    for (auto it : g[v]) {
        int u = it.F;
        int id = it.S;
        if (mp.find({v, u}) != mp.end()) {
            continue;
        }
        if (used[u] == 1) {
            ans.push_back(id);
            mp[{v, u}];
        }
        else {
            dfs(u);
        }
    }
    used[v] = 2;
}
string find_reverse (int N, int M, int connections[][2]) {

    int n, m;

    n = N;
    m = M;

    g.resize(n + 1);
    used.resize(n + 1);

    for (int i = 0; i < m; i++) {
        int u, v;
        u = connections[i][0];
        v = connections[i][1];
        g[u].push_back({v, i});
    }

    for (int i = 1; i <= n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }

    string s;
    for (int i = 0; i < m; i++) {
        s += "0";
    }

    for (int i = 0; i < ans.size(); i++) {
        s[ans[i]] = '1';
    }

    return s;

}
