#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second

int n, m;
vector<int> a;
vector<vector<int>> g;
map<int, vector<int>> dist1, dist2;
vector<bool> used;

void dfs(int v, int sum) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) {
            continue;
        }
        dist1[sum + a[u]] = dist1[sum];
        dist1[sum + a[u]].push_back(u);
        dfs(u, sum + a[u]);
    }
}

signed main() {

    cin >> n;
    g.resize(n);
    used.resize(n);
    a.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        dist1[a[i]] = {i};
        for (int j = i + 1; j < n; j++) {
            g[i].push_back(j);
        }
    }

    for (int i = 0; i < n; i++) {
        dfs(i, a[i]);
        used.clear();
        used.resize(n);
    }

    dist2 = dist1;
    dist1.clear();

    g.clear();
    used.clear();
    a.clear();

    cin >> n;
    g.resize(n);
    used.resize(n);
    a.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        dist1[a[i]] = {i};
        for (int j = i + 1; j < n; j++) {
            g[i].push_back(j);
        }
    }

    for (int i = 0; i < n; i++) {
        dfs(i, a[i]);
        used.clear();
        used.resize(n);
    }


    for (auto it : dist2) {
        int sum = it.F;
        if (dist1.find(sum) != dist1.end()) {
            vector<int> d = it.S;
            cout << d.size() << endl;
            for (int i = 0; i < d.size(); i++) {
                cout << d[i] << " ";
            }
            cout << endl;
            for (auto iit : dist1) {
                if (iit.F == sum) {
                    d = iit.S;
                    cout << d.size() << endl;
                    for (int i = 0; i < d.size(); i++) {
                        cout << d[i] << " ";
                    }
                }
            }
            return 0;
        }
    }

    return 0;
}
