#include <iostream>
#include <bitset>
#include <cassert>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 401;
int a[MAXN];
int b[MAXN];
bitset<MAXN * MAXN> dpa[MAXN];
bitset<MAXN * MAXN> dpb[MAXN];

void goback(int i, int sma, int smb, vector<int>& inca, vector<int>& incb, int n, int m) {
    if (i == -1)
        return;
    if (i == 0) {
        if (sma)
            inca.push_back(0);
        if (smb)
            incb.push_back(0);
        return;
    }
    if (i < n && !dpa[i - 1][sma]) {
        inca.push_back(i);
        sma -= a[i];
    }
    if (i < m && !dpb[i - 1][smb]) {
        incb.push_back(i);
        smb -= b[i];
    }
    goback(i - 1, sma, smb, inca, incb, n, m);
}

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i)
        cin >> b[i];
    dpa[0][0] = dpa[0][a[0]] = 1;
    for (int i = 1; i < n; ++i) {
        dpa[i] = dpa[i - 1] | (dpa[i - 1] << a[i]);
    }
    dpb[0][0] = dpb[0][b[0]] = 1;
    for (int i = 1; i < m; ++i) {
        dpb[i] = dpb[i - 1] | (dpb[i - 1] << b[i]);
    }
    for (int k = 1; k <= n * m; ++k) {
        if (dpa[n - 1][k] && dpb[m - 1][k]) {
            vector<int> b0;
            vector<int> a0;
            goback(n + m, k, k, a0, b0, n, m);
            cout << a0.size() << endl;
            for (auto x : a0)
                cout << x << ' ';
            cout << endl;
            cout << b0.size() << endl;
            for (auto x : b0)
                cout << x << ' ';
            cout << endl;
            return 0;
        }
    }
}
