#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int MAXN = 5005;
const int MAXM = 10005;

vector<int> G[MAXN];
//int edges[MAXM][2];
int viz[MAXN];

int init, val;
bool ok;

void dfs( int u ) {
  viz[u] = val;
  for ( auto v : G[u] ) {
    if ( viz[v] != val ) {
      dfs(v);
    } else {
      if ( v == init ) {
        ok = false;
      }
    }
  }
}

string find_reverse( int n, int m, int edges[][2] ) {
  string res;

  val = 1;
  int fine;
  for ( int i = 0; i < (1 << m); ++i ) {
    for ( int j = 1; j <= n; ++j ) {
      G[j].clear();
    }
    for ( int j = 0; j < m; ++j ) {
      if ( (i >> j) & 1 ) {
        G[edges[j][1]].push_back(edges[j][0]);
      } else {
        G[edges[j][0]].push_back(edges[j][1]);
      }
    }
    bool okt = true;
    for ( int i = 1; i <= n; ++i ) {
      ++val;
      ok = true;
      init = i;
      dfs(i);
      okt &= ok;

    }
    if ( okt == true ) {
      fine = i;
      break;
    }
  }
  for ( int i = 0; i < m; ++i ) {
    res.push_back( ((fine >> i) & 1) + '0' );
  }
  return res;
}
/*
int main() {
  int n, m, u, v;

  cin >> n >> m;
  for ( int i = 1; i <= m; ++i ) {
    cin >> u >> v;
    edges[i][0] = u;
    edges[i][1] = v;
  }
  cout << find_reverse( n, m, edges );
  return 0;
}*/

/**
5 6
1 2
1 3
3 5
4 5
3 4
2 4
**/
