#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

string find_reverse(int n, int m, int conect[][2])
{
    vector<vector<pair<pair<int, bool>, pair<bool, int>>>> zw(n);
    vector<pair<pair<int, int>, bool>> str(m);
    for (int i = 0; i < m; i++) {
        int s, e;
        s = conect[i][0];
        e = conect[i][1];
        s--;
        e--;
        str[i] = {{s, e}, false};
        zw[s].push_back({{e, 0}, {0, i}});
        zw[e].push_back({{s, 1}, {0, i}});
    }
    string res(m, '0');
    vector<pair<int, int>> sizes(n);
    for (int i = 0; i < n; i++)
        sizes[i] = {zw[i].size(), i};
    sort(sizes.begin(), sizes.end());
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < sizes[i].first; j++) {
            if (!str[zw[sizes[i].second][j].second.second].second && !zw[sizes[i].second][j].first.second) {
                zw[sizes[i].second][j].first.second = true;
                res[zw[sizes[i].second][j].second.second] = '1';
            }
            str[zw[sizes[i].second][j].second.second].second = true;
        }
    }
    return res;
}
