#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define X first
#define Y second
#define mp make_pair

using namespace std;
const int maxn=1e6+10;
const int inf=1e17+10;

int n;
vector<int>tree(maxn);

void build(int v,int t_l,int t_r)
{
    tree[v]=-inf;
    if(t_l==t_r)return;
    int t_m=(t_l+t_r)/2;
    build(v<<1,t_l,t_m);
    build((v<<1)+1,t_m+1,t_r);
}

void update(int x,int i,int v,int t_l,int t_r)
{
    if(t_l>x||x>t_r)return;
    if(t_l==t_r){tree[v]=i;return;}
    int t_m=(t_l+t_r)/2;
    update(x,i,v<<1,t_l,t_m);
    update(x,i,(v<<1)+1,t_m+1,t_r);
    tree[v]=max(tree[v<<1],tree[(v<<1)+1]);
    return;
}

int Max(int l,int r,int v,int t_l,int t_r)
{
    if(l>t_r||t_l>r)return -inf;
    if(l<=t_l&&t_r<=r)return tree[v];
    int t_m=(t_l+t_r)/2;
    return max(Max(l,r,v<<1,t_l,t_m),Max(l,r,(v<<1)+1,t_m+1,t_r));
}

pair<int,int>get1(int r,int m,int v,int t_l,int t_r)
{
    if(t_l==t_r)return mp(tree[v]+t_l,t_r);
    int t_m=(t_l+t_r)/2;
    if(Max(0,r,(v<<1)+1,t_m+1,t_r)>=m)return get1(r,m,(v<<1)+1,t_m+1,t_r);
    return get1(r,m,v<<1,t_l,t_m);
}

pair<int,int>get2(int l,int m,int v,int t_l,int t_r)
{
    if(t_l==t_r)return mp(tree[v]+t_l,t_r);
    int t_m=(t_l+t_r)/2;
    if(Max(l,n,(v<<1),t_l,t_m)>=m)return get2(l,m,(v<<1),t_l,t_m);
    return get2(l,m,(v<<1)+1,t_m+1,t_r);
}

long double res=0;

vector<long double>tr(maxn*4),z(maxn*4);
vector<bool>used(maxn*4);

void push(int v,int t_l,int t_r,bool B)
{
    if(!used[v])return;
    used[v]=0;
    tr[v]=(z[v]-1)*(1.0*(t_r-t_l+1))+((t_r-t_l+1)*(t_r-t_l+1))*0.5;
    if(t_l==t_r)return;
    used[v<<1]=used[(v<<1)+1]=1;
    int t_m=(t_l+t_r)/2;
    if(B)
    {
        z[v<<1]=z[v];
        z[(v<<1)+1]=z[v]+((t_m+1)-t_l);
    }else
    {
        z[v<<1]=z[v]+t_r-t_m;
        z[(v<<1)+1]=z[v];
    }
}

void upd(int l,int r,int h,int v,int t_l,int t_r,bool B)
{
    if(l>t_r||t_l>r)return;
    //cout<<l<<' '<<r<<' '<<h<<' '<<v<<' '<<t_l<<' '<<t_r<<'\n';
    push(v,t_l,t_r,B);
    if(l<=t_l&&t_r<=r)
    {
        //cout<<t_l<<' '<<t_r<<':';
        //cout<<tr[v]<<' ';
        res-=tr[v];
        used[v]=1;
        z[v]=h;
        push(v,t_l,t_r,B);
        //cout<<tr[v]<<'\n';
        res+=tr[v];
        return;
    }
    int t_m=(t_l+t_r)/2;
    if(!B)
    {
        upd(l,r,h,v<<1,t_l,t_m,B);
        upd(l,r,h+t_m-t_l,(v<<1)+1,t_m+1,t_r,B);
    }
    else
    {
        upd(l,r,h+t_r-t_m,v<<1,t_l,t_m,B);
        upd(l,r,h,(v<<1)+1,t_m+1,t_r,B);
    }
}

void solve()
{
    int m;
    cin>>n>>m;
    n*=2;
    m*=2;
    build(1,0,n);
    int q;
    cin>>q;
    int x,y;
    while(q--)
    {
        cin>>x>>y;
        x*=2;
        y*=2;
        y=m-y;
        int b=x-y;
        //cout<<b<<'\n';
        pair<int,int>q1=get1(x,b,1,0,n);
        pair<int,int>q2=get2(x,b,1,0,n);
        bool b1=(Max(0,x,1,0,n)>=b);
        bool b2=(Max(x,n,1,0,n)>=b);
        if((b1&&q1.X-q1.Y<=x-y&&x+y<=q1.X+q1.Y)||(b2>=m&&q2.X-q2.Y<=x-y&&x+y<=q2.X+q2.Y)){cout<<res<<'\n';continue;}
        int L=x-y,R=x+y;
        int L2=q1.X-q1.Y,R2=q1.X+q1.Y;
        pair<int,int>t1=mp((L+R2)/2,(R2-L)/2);
        if(!b1)t1=mp(x-y,0);
        L=q2.X-q2.Y,R=q2.X+q2.Y;
        L2=x-y,R2=x+y;
        //cout<<L<<' '<<R2<<'\n';
        pair<int,int>t2=mp((L+R2)/2,(R2-L)/2);
        if(!b2)t2=mp(x+y,0);
        if(t1.X<0)
        {
            t1.Y-=t1.X;
            t1.X=0;
        }
        if(t2.X<0)
        {
            t2.Y-=t2.X;
            t2.X=0;
        }
        //cout<<t2.X<<' '<<t2.Y<<'\n';
        //cout<<t1.X+1<<' '<<x<<' '<<t1.Y+1<<'\n';
        upd(t1.X+1,x,t1.Y+1-(t1.X-1),1,1,n,0);
        //cout<<(1.0*n*m-res)/4<<'\n';
        upd(x+1,t2.X,t2.Y+1-(n-t2.X),1,1,n,1);
        cout<<(1.0*n*m-res)/4<<'\n';
        update(x,b,1,0,n);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while(t--)solve();
    return 0;
}
