#include <iostream>

using namespace std;

struct Paper {
    double s;
    bool l;
    bool r;
};

Paper **a;



void print(int n, int m) {

/*
    for (int i=0; i<n; i++) {
        for (int j=0; j<m; j++) cout << a[i][j].s << ' ';
        cout << endl;
    }
    cout << "*******" << endl;
*/

    double area;
    area = 0;
    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++) {
            area += a[i][j].s;
        }

    printf("%.2f",area);
    cout << endl;
    area = 0;

}



void cut(int x, int y, int n, int m) {

    int al=x-1; int bl=y; int ar=x; int br=y;

    while ((al>=0)&&(bl<m)) {
        if (a[al][bl].l == false) {
                a[al][bl].l = true;
                a[al][bl].s /= 2;
        }
        al--;
        bl++;
    }

    while ((ar<n)&&(br<m)) {
        if (a[ar][br].r == false) {
                a[ar][br].r = true;
                a[ar][br].s /= 2;
        }
        ar++;
        br++;
    }




    for (int j=y+1; j<m; j++) {
        for (int i=x+y-j; i<x-y+j; i++) {
            if ((i<0)||(i>=n)) continue;

            a[i][j].s=0;
        }
    }

}

int main()
{
    long long m,n;
    int q;

    cin >> n >> m;

    a = new Paper*[n];
    for (int i=0; i<n; i++) a[i]=new Paper[m];

    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++) a[i][j].s=1;

    cin >> q;

    //print(n,m);

    for (int i=0; i<q; i++) {
        int p,k;
        cin >> p >> k;
        cut(p,k,n,m);

        print(n,m);

    }

    /* for (int i=0; i<n; i++)
        for (int j=0; j<m; j++) area += a[i][j].s;

    cout << area; */

    return 0;
}
