#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;

//extern std::string find_reverse(int, int, int[][2]);


string to_binary_string(int n) {
    string ans = "";
    while (n) {

        if (n & 1) {
            ans += "1";
        }
        else ans += "0";

        n >>= 1;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}
bool dfs(int v, vector<vector<int>>& graph, vector<int>& seen) {
    if (seen[v] == 2) {
        return true;
    }
    if (seen[v] == 1) {
        return false;

    }
    seen[v] = 1;
    for (auto u : graph[v]) {
        if (!dfs(u, graph, seen)) {
            return false;
        }

    }
    seen[v] = 2;
    return true;
}


string find_reverse(int n, int m, int connections[][2]) {
    for (int i = 0; i < (1 << m); i++) {
        //cout << i << '\n';
        int x = i;
        int j = 0;
        vector<vector<int>> graph(m);
        for (int i = 0; i < m; i++) {
            graph[i] = { connections[i][0], connections[i][1] };
        }

        while (x) {
            if (x & 1) {
                swap(graph[m - j - 1][0], graph[m - j - 1][1]);
            }
            x >>= 1;
            j++;
        }
        bool good = 1;
        vector<vector<int>> graph_list(n + 1);
        for (auto x : graph) {
            graph_list[x[0]].push_back(x[1]);
        }
        vector<int> seen(n + 1, 0);
        for (int i = 1; i <= n; i++) {
            if (!dfs(i, graph_list, seen)) {
                good = false;
                break;
            }
        }
        if (good) {
            string str_ans = "";
            string ans = to_binary_string(i);
            for (int j = 0; j < m - ans.size(); j++) {
                str_ans += "0";
            }
            str_ans += ans;
            return  str_ans;
        }

    }
}