#include<iostream>
#include<vector>
#include<queue>
#include<string>
#include<algorithm>
using namespace std;

void bfs(int V, vector<vector<pair<int, pair<int, int>>>>& graph, vector<bool>& seen, vector<bool>& used, vector<int>& solution) {

    queue<int> q;
    q.push(V);
    while (!q.empty()) {
        int v = q.front(); q.pop();
        //do stuff;
        for (auto u : graph[v]) {
            if (used[u.second.first]) continue;
            used[u.second.first] = true;
            solution[u.second.first] = u.second.second;
            if (seen[u.first]) continue;
            seen[u.first] = 1;
            q.push(u.first);
        }
    }
}


string find_reverse(int n, int m, int connections[][2]) {
         vector<vector<int>> graph(m);
        for (int i = 0; i < m; i++) {
            graph[i] = { connections[i][0], connections[i][1] };
        }


        bool good = 1;
        vector<vector<pair<int, pair<int, int>>>> graph_list(n + 1);
        for(int i = 0; i < m; i++){
            graph_list[graph[i][0]].push_back({ graph[i][1], {i, 1} });
            graph_list[graph[i][1]].push_back({ graph[i][0], {i, 0} });
        }
        vector<bool> seen(n + 1, 0);
        vector<int> solution(m);
        vector<bool> used(m, 0);
        bfs(1, graph_list, seen, used, solution);
 
        string ans = "";
        for (int i = 0; i < m; i++) {
            ans += to_string(solution[i]);
        }
        
        
        return ans;
    }
