#include<iostream>
#include<vector>
#include<queue>
#include<string>
#include<algorithm>
using namespace std;

static const int MAXM = 1.5e6;
bool seen[MAXM + 1];
int solution[MAXM + 1];
bool used[MAXM + 1];

void bfs(int V, vector<vector<pair<int, pair<int, int>>>>& graph) {

    queue<int> q;
    q.push(V);
    while (!q.empty()) {
        int v = q.front(); q.pop();
        cout << v << '\n';
        //do stuff;
        for (auto u : graph[v]) {
            if (used[u.second.first]) continue;
            used[u.second.first] = true;
            solution[u.second.first] = u.second.second;
            if (seen[u.first]) continue;
            seen[u.first] = 1;
            q.push(u.first);
        }
    }
}


string find_reverse(int n, int m, int connections[][2]) {
        
    for (int i = 0; i < MAXM; i++) {
        seen[i] = 0;
        used[i] = 0;
        solution[i] = 0;
        }
         vector<vector<int>> graph(m);
        for (int i = 0; i < m; i++) {
            graph[i] = { connections[i][0], connections[i][1] };
        }


        bool good = 1;
        vector<vector<pair<int, pair<int, int>>>> graph_list(n + 1);
        for(int i = 0; i < m; i++){
            graph_list[graph[i][0]].push_back({ graph[i][1], {i, 1} });
            graph_list[graph[i][1]].push_back({ graph[i][0], {i, 0} });
        }
        bfs(1, graph_list);
 
        string ans = "";
        for (int i = 0; i < m; i++) {
            ans += to_string(solution[i]);
        }
        
        
        return ans;
    }


