

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
	int n, m;
	cin >> n;
	vector<int> a(n);
	for (auto& x : a) cin >> x;
	cin >> m;
	vector<int> b(m);
	for (auto& x : b) cin >> x;
	int max_sum = 100000;
	vector<vector<bool>> dp_a(n + 1, vector<bool>(max_sum, 0));

	vector<vector<bool>> dp_b(m + 1, vector<bool>(max_sum, 0));

	dp_a[0][0] = dp_b[0][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < max_sum; j++) {
			if (dp_a[i - 1][j]) {
				dp_a[i][j] = 1;
				dp_a[i][j + a[i - 1]] = 1;
			}
		}
	}

	for (int i = 1; i <= m; i++) {
		for (int j = 0; j < max_sum; j++) {
			if (dp_b[i - 1][j]) {
				dp_b[i][j] = 1;
				dp_b[i][j + b[i - 1]] = 1;
			}
		}
	}

	int sum;
	for (int i = 1; i < max_sum; i++) {
		if (dp_a[n][i] && dp_b[m][i]) {
			sum = i;
			break;
		}
	}
	int sum_a = sum;
	int sum_b = sum;

	vector<int> a_sol;
	int a_index = n;
	while (a_index > 0 && sum_a > 0) {
		while (dp_a[a_index][sum_a] && dp_a[a_index - 1][sum_a]) {
			a_index--;
		}
		sum_a -= a[a_index-1];
		a_sol.push_back(a_index--);


	}
	reverse(a_sol.begin(), a_sol.end());



	vector<int> b_sol;
	int b_index = m;
	while (b_index > 0 && sum_b > 0) {
		while (dp_b[b_index][sum_b] && dp_b[b_index - 1][sum_b]) {
			b_index--;
		}
		sum_b -= b[b_index-1];

		b_sol.push_back(b_index--);

	}
	reverse(b_sol.begin(), b_sol.end());

	cout << a_sol.size() << '\n';
	for (auto x : a_sol) cout << x-1 << ' ';
	cout << '\n';
	cout << b_sol.size() << '\n';
	for (auto x : b_sol) cout << x-1 << ' ';
}
/*
5
2 3 3 2 3
3 
4 5 5


*/