#include <bits/stdc++.h>
#define F first
#define S second
#define PB push_back
#define MP make_pair

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<ll> vi;
typedef pair<ld, ld> point;

ll n, m, q, a, b;

bool contains(point a, point b) {
    return (b.S - a.S) >= abs(a.F - b.F);
}

ld area(point a) {
    ld int_l = a.S + a.F;
    ld int_r = a.S + (n - a.F);
//    cout << a.S << ' ' << a.F << '\n';
//    cout << int_l << ' ' << int_r << '\n';
//    cout << (m - a.S) * (m - a.S) << '\n';
//    cout << max(0.L, int_l - (a.F - m + a.S)) * max(0.L, int_l - (a.F - m + a.S)) / 2.0L << '\n';
//    cout << max(0.L,  (a.F + m - a.S) - int_r) * max(0.L, (a.F + m - a.S) - int_r) / 2.0L << '\n';
    return (m - a.S) * (m - a.S) - max(0.L, m - int_l) * max(0.L, m - int_l) / 2.0L - max(0.L, m - int_r) * max(0.L, m - int_r) / 2.0L;
}

ld inter(point a, point b) {
    if (a.F > b.F) {
        swap(a, b);
    }
    point c;
    c.F = (a.F + b.F - a.S + b.S) / 2.0L;
    c.S = b.F + b.S - c.F;
//    cout << c.F << ' ' << c.S << '\n';
    if (c.S <= m) {
        return area(c);
    }
    return 0.L;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    cin >> q;
    set<point> st;
    ld s = n * m;
    map<point, ld> mp;
    for (int i = 0; i < q; i++) {
        cin >> a >> b;
        point p = MP(a, b);
        st.insert(p);
        auto it = st.find(p);
        auto before = it;
        auto after = it;
        before--;
        after++;
        ld oldS = s;
        s -= area(p);
        while (after != st.end() && contains(*it, *after)) {
            auto it1 = after;
            after++;
            s += mp[*it1];
            st.erase(it1);
        }
//        cout << s << '\n';
        while (it != st.begin() && contains(*it, *after)) {
            auto it1 = before;
            before--;
            s += mp[*it1];
            st.erase(it1);
        }
//        cout << s << '\n';
//        cout << st.size() << '\n';
        if (it != st.begin()) {
            if (after != st.end()) {
                s += inter(*it, *after);
                s += inter(*it, *before);
                s -= inter(*after, *before);
            }
            else {
                s += inter(*it, *before);
            }
        }
        else {
            if (after != st.end()) {
                s += inter(*it, *after);
            }
        }
//        cout << s << '\n';
        mp[p] = oldS - s;
//        cout << mp[p] << '\n';
        cout << fixed << setprecision(2) << s << '\n';
    }
}
