#include <string>
#include <iostream>
#include <vector>
using namespace std;

static const int MAXN = 5e5;
static string ans;
static vector<int> g[MAXN];
static int tin[MAXN];
static int tmr;

void dfs(int v) {
    tin[v] = ++tmr;
    for(auto to : g[v]) if(!tin[to]) dfs(to);
}

string find_reverse(int N, int M, int connections[][2]) {
    ans.resize(M);
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        ///g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        ans[i] = (tin[u] < tin[v]) + '0';
    }
    return ans;
}