#pragma GCC optimize("O3")
#pragma GCC target("sse4.1,sse4.2,avx2")
#include <iostream>
#include <queue>
#include <vector>
using namespace std;
static const int MAXN = 5e5;
static char ans[MAXN * 3];
static vector <int> g[MAXN];
static int tin[MAXN];

string find_reverse(int N, int M, int connections[][2]) {
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;--v;
        g[v].push_back(u);
    }
    queue <int> q;
    q.push(0);
    int tmr = 0;
    while(!q.empty()) {
        v = q.front();
        q.pop();
        for(auto to : g[v]) {
            if(!tin[to]) {
                tin[to] = ++tmr;
                q.push(to);
            }
        }
    }
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;
        --v;
        ans[i] = (tin[u] < tin[v]) + '0';
    }
    return ans;
}