#include <iostream>
using namespace std;
const int MAXN = 5e5;
char ans[MAXN * 3];
pair <int, int> ed[MAXN * 6];
int lst[MAXN];
int tin[MAXN];
int ptr, tmr;

void add_edge(const int &v, const int &u) {
    ed[ptr].first = u;
    ed[ptr].second = lst[v] - 1;
    ++ptr;
    lst[v] = ptr;
}

void dfs(int v) {
    tin[v] = ++tmr;
    for(v = lst[v] - 1; v >= 0; v = ed[v].second) if(!tin[ed[v].first]) dfs(ed[v].first);
}

string find_reverse(int N, int M, int connections[][2]) {
    int u, v;
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;--v;
        add_edge(u, v);
        add_edge(v, u);
    }
    dfs(0);
    for(int i = 0; i < M; ++i) {
        u = connections[i][0];
        v = connections[i][1];
        --u;--v;
        ans[i] = (tin[u] > tin[v]) + '0';
    }
    return ans;
}