#include <iostream>
#include <unordered_map>
using namespace std;
#define ll long long

const int MAXN = 1e6 + 10;
int a[MAXN], b[MAXN];
int n, m;

int main() {
    cin >> n;
    for(int i = 1; i <= n; ++i) cin >> a[i];
    cin >> m;
    for(int i = 1; i <= m; ++i) cin >> b[i];
    int ptr = 1;
    unordered_map <long long, pair <int, int> > was;
    was[0] = make_pair(0, 0);
    ll suma = a[1], sumb = 0;
    for(int i = 1; i <= m; ++i) {
        sumb += b[i];
        while(ptr <= n && suma < sumb) {
            ++ptr;
            suma += a[ptr];
        }
        ll dif = suma - sumb;
        if(dif < 0) break;
        if(was.count(dif)) {
            int l1 = was[dif].first;
            int l2 = was[dif].second;
            cout << ptr - l1 << '\n';
            for(int j = l1 + 1; j <= ptr; ++j) cout << j - 1 << ' ';
            cout << '\n';
            cout << i - l2 << '\n';
            for(int j = l2 + 1; j <= i; ++j) cout << j - 1 << ' ';
            return 0;
        }
        was[dif] = make_pair(ptr, i);
    }
    was.clear();
    was[0] = make_pair(0, 0);
    ptr = 1;
    suma = 0;
    sumb = b[1];
    for(int i = 1; i <= n; ++i) {
        suma += a[i];
        while(ptr <= m && sumb < suma) {
            ++ptr;
            sumb += b[ptr];
        }
        ll dif = sumb - suma;
        if(dif < 0) break;
        if(was.count(dif)) {
            int l1 = was[dif].first;
            int l2 = was[dif].second;
            cout << i - l2 << '\n';
            for(int j = l2 + 1; j <= i; ++j) cout << j - 1 << ' ';
            cout << '\n';
            cout << ptr - l1 << '\n';
            for(int j = l1 + 1; j <= ptr; ++j) cout << j - 1 << ' ';
            return 0;
        }
        was[dif] = make_pair(ptr, i);
    }
    return 0;
}
