#include <iostream>
#include <unordered_map>
#pragma GCC target("avx2")
#pragma GCC optimize("O3")
using namespace std;

int main() {
    int n, m;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; ++i) cin >> a[i];
    cin >> m;
    int b[m];
    for(int i = 0; i < m; ++i) cin >> b[i];
    unordered_map <long long, pair <int, int> > was;
    was[0] = make_pair(-1, -1);
    int ptr = 0;
    long long dif = a[0];
    for(int i = 0; i < m; ++i) {
        dif -= b[i];
        while(ptr < n && dif < 0) {
            ++ptr;
            dif += a[ptr];
        }
        if(dif < 0) break;
        if(was.count(dif)) {
            int l1 = was[dif].first;
            int l2 = was[dif].second;
            cout << ptr - l1 << '\n';
            for(int j = l1 + 1; j <= ptr; ++j) cout << j << ' ';
            cout << '\n';
            cout << i - l2 << '\n';
            for(int j = l2 + 1; j <= i; ++j) cout << j << ' ';
            return 0;
        }
        was[dif] = make_pair(ptr, i);
    }
    was.clear();
    was[0] = make_pair(0, 0);
    ptr = 0;
    dif = b[0];
    for(int i = 0; i < n; ++i) {
        dif -= a[i];
        while(ptr < m && dif < 0) {
            ++ptr;
            dif += b[ptr];
        }
        if(dif < 0) break;
        if(was.count(dif)) {
            int l1 = was[dif].first;
            int l2 = was[dif].second;
            cout << i - l2 << '\n';
            for(int j = l2 + 1; j <= i; ++j) cout << j << ' ';
            cout << '\n';
            cout << ptr - l1 << '\n';
            for(int j = l1 + 1; j <= ptr; ++j) cout << j << ' ';
            return 0;
        }
        was[dif] = make_pair(ptr, i);
    }
    return 0;
}
