#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define sz size()
#define all(x) x.begin(), x.end()

typedef vector < int > vi;
typedef vector < vi > vvi;
typedef pair < int, int > pii;


//int connections[100][2];
vector < pii > edges;
vvi g(1010);
int used[1010];
bool f = 1;

void dfs (int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (used[i] == 1) {
            f = 0;
            continue;
        }
        if (used[i] == 2) {
            continue;
        }
        dfs(i);
    }
    used[v] = 2;
}

bool check (int n, int m) {
    f = 1;
    for (int i = 1; i <= n; i++) used[i] = 0;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs (i);
        }
    }
    return f;
}

void erase_vertex (int u, int v) {
    vi vec;
    for (auto i : g[u]) {
        if (i == v) {
            continue;
        }
        vec.pb(v);
    }
    g[u].clear();
    for (auto i : vec) {
        g[u].pb(i);
    }
}

string find_reverse (int n, int m, int connections[][2]) {
    string s = "";
    for (int i = 0; i < m; i++) {
        edges.pb({connections[i][0], connections[i][1]});
    }
    for (int i = 0; i < m; i++) {
        int u = edges[i].F, v = edges[i].S;
        g[u].pb(v);
        if (check(n, m)) {
            s += '0';
        }
        else {
            s += '1';
            erase_vertex(u, v);
            g[v].pb(u);
            if (check(n, m) == 0) {
                for (int j = i + 1; j < m; j++) {
                    s += '0';
                }
                for (int j = 0; j < m; j++) {
                    s[j] = '0';
                }
                break;
            }
        }
    }
    return s;
}

/*signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> connections[i][0] >> connections[i][1];
    }
    string ans = find_reverse (n, m, connections);
    cout << ans;
}*/

