#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define sz size()
#define int long long

typedef vector < int > vi;
typedef vector < vi > vvi;
typedef pair < int, int > pii;


const int N = 1000001;
int a[N], b[N];
int n, m, sum1 = 0, sum2 = 0;

void solve_300 () {
    vvi dp1(n + 10, vi(sum1 + 10, 0));
    vector < vector < pii > >  pr1(n + 10, vector < pii > (sum1 + 10));
    vvi dp2(m + 10, vi(sum2 + 10, 0));
    vector < vector < pii > >  pr2(m + 10, vector < pii > (sum2 + 10));

    dp1[0][0] = dp2[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= sum1; j++) {
            dp1[i][j] = dp1[i - 1][j];
            pr1[i][j] = {0, j};
            if (a[i] <= j) {
                if (dp1[i - 1][j - a[i]] == 1) {
                    dp1[i][j] = 1;
                    pr1[i][j] = {1, j - a[i]};
                }
            }
        }
    }

    for (int i = 1; i <= m; i++) {
        for (int j = 0; j <= sum2; j++) {
            dp2[i][j] = dp2[i - 1][j];
            pr2[i][j] = {0, j};
            if (b[i] <= j) {
                if (dp2[i - 1][j - b[i]] == 1) {
                    dp2[i][j] = 1;
                    pr2[i][j] = {1, j - b[i]};
                }
            }
        }
    }

    int sum = -1;
    for (int i = 1; i <= min(sum1, sum2); i++) {
        if (dp1[n][i] + dp2[m][i] == 2) {
            sum = i;
            break;
        }
    }
    vi ans1, ans2;
    int pos = n, cur_sum = sum;
    while (pos > 0) {
        pii p = pr1[pos][cur_sum];
        if (p.F == 1) {
            ans1.pb(pos);
        }
        pos--;
        cur_sum = p.S;
    }
    pos = m, cur_sum = sum;
    while (pos > 0) {
        pii p = pr2[pos][cur_sum];
        if (p.F == 1) {
            ans2.pb(pos);
        }
        pos--;
        cur_sum = p.S;
    }
    cout << ans1.sz << "\n";
    for (auto i : ans1) {
        cout << i - 1 << " ";
    }
    cout << "\n";
    cout << ans2.sz << "\n";
    for (auto i : ans2) {
        cout << i - 1 << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        sum1 += a[i];
    }

    cin >> m;
    set < int > s;
    for (int j = 1; j <= m; j++) {
        cin >> b[j];
        sum2 += b[j];
        s.insert(b[j]);
    }

    if (n <= 300 && m <= 300) {
        solve_300();
        return 0;
    }

    for (int i = 1; i <= n; i++) {
        if (s.find(a[i]) != s.end()) {
            cout << 1 << "\n";
            cout << i - 1 << "\n";
            cout << 1 << "\n";
            for (int j = 1; j <= m; j++) {
                if (b[j] == a[i]) {
                    cout << j - 1;
                    return 0;
                }
            }
        }
    }
    cout << "1\n0\n1\n0\n";
    return 0;
}
