
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <cassert>
#include <fstream>
#include <queue>
#include <set>
#include <map>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <random>

using namespace std;
//mt19937 rnd(time(228));
#define ll long long
#define dl double
//#define int long long
#define pii pair<int, int>
#define sz(a) (int)a.size()
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1;
int n, m;
vector<set<int>> g;
int c = 0;
pii edge;
int used[maxn];

void dfs(int v, int p = -1) {
    if (used[v] == 2 || c)return;
    if (used[v] == 1) {
        c = 1, edge = {p, v};
        return;
    }
    used[v] = 1;
    for (int u: g[v])dfs(u, v);
    used[v] = 2;
}

string find_reverse(int N, int M, int connections[][2]) {
    string ans;
    map<pii, int> edges;
    for (int i = 0; i < M; ++i) ans += '0';
    n = N, m = M;
    g.resize(n);
    for (int i = 0; i < M; ++i) {
        int u = connections[i][0];
        int v = connections[i][1];
        u--, v--;
        edges[{u, v}] = i, edges[{v, u}] = i;
        g[u].insert(v);
    }
    while (true) {
        c = 0;
        fill(used, used + n, 0);
        for (int i = 0; i < n && !c; ++i) {
            dfs(i);
        }
        auto[u, v]=edge;
        if (!c || (min(u, v) == -1)) break;
        g[u].erase(v);
        g[v].insert(u);
        ans[edges[{u, v}]] = '1';
        edge = {-1, -1};
    }
    return ans;
}
/*
signed main() {
    int N, M;
    cin >> N >> M;
    int con[M][2];
    for (int i = 0; i < M; ++i) {
        cin >> con[i][0] >> con[i][1];
    }
    cout << find_reverse(N, M, con);
}

/*
 6 12
 1 2
 1 5
 2 3
 2 5
 3 4
 3 6
 4 1
 4 5
 5 3
 5 6
 6 1
 6 4
 */