#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <cassert>
#include <fstream>
#include <queue>
#include <set>
#include <map>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <random>

using namespace std;
//mt19937 rnd(time(228));
#define ll long long
#define dl double
//#define int long long
#define pii pair<int, int>
#define sz(a) (int)a.size()
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1;
int n, m;
vector<set<int>> g, r;

string find_reverse(int N, int M, int connections[][2]) {
    string ans;
    map<pii, int> e;
    for (int i = 0; i < M; ++i) ans += '0';
    n = N, m = M;
    g.resize(n), r.resize(n);
    for (int i = 0; i < M; ++i) {
        int u = connections[i][0];
        int v = connections[i][1];
        u--, v--;
        e[{u, v}] = i, e[{v, u}] = i;
        g[u].insert(v);
        r[v].insert(u);
    }
    vector<pii > s(n);
    for (int i = 0; i < n; ++i) s[i] = {sz(g[i]) + sz(r[i]), i};
    sort(all(s)), reverse(all(s));
    queue<int> q;
    q.push(s[0].second);
    int k = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (k == 0) {
            set<int> gg;
            for (int u: g[v]) {
                int j = e[{u, v}];
                if (ans[j] == '0') {
                    ans[j] = '1';
                    r[v].insert(u);
                    g[u].insert(v);
                    r[u].erase(v);
                    q.push(u);
                } else gg.insert(u);
            }
            g[v] = gg;
            k = 1;
        } else {
            set<int> rr;
            for (int u: r[v]) {
                int j = e[{u, v}];
                if (ans[j] == '0') {
                    g[v].insert(u);
                    g[u].erase(v);
                    r[u].insert(v);
                    q.push(u);
                } else rr.insert(u);
            }
            r[v] = rr;
            k=0;
        }
    }
    return ans;
}

/*
 6 12
 1 2
 1 5
 2 3
 2 5
 3 4
 3 6
 4 1
 4 5
 5 3
 5 6
 6 1
 6 4
 */