#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <cassert>
#include <fstream>
#include <queue>
#include <set>
#include <map>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <random>

using namespace std;
//mt19937 rnd(time(228));
#define ll long long
#define dl double
//#define int long long
#define pii pair<int, int>
#define sz(a) (int)a.size()
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1;
int n, m;
vector<vector<int>> g, r;
int used[maxn];
vector<int> ts, comp;

void dfs1(int v) {
    if (used[v])return;
    used[v] = 1;
    for (int u: g[v])dfs1(u);
    ts.push_back(v);
}

int cnt = 1;
vector<int> c;

void dfs(int v) {
    if (comp[v] != 0)return;
    c.push_back(v), comp[v] = cnt;
    for (int u: r[v])dfs(u);
}

string find_reverse(int N, int M, int connections[][2]) {
    string ans;
    map<pii, int> e;
    for (int i = 0; i < M; ++i) ans += '0';
    n = N, m = M;
    g.resize(n), r.resize(n), comp.resize(n);
    for (int i = 0; i < M; ++i) {
        int u = connections[i][0];
        int v = connections[i][1];
        u--, v--;
        e[{u, v}] = i;
        e[{v, u}] = i;
        g[u].push_back(v), r[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs1(i);
        }
    }
    for (int v: ts) {
        if (comp[v] == 0) {
            dfs(v);

            for (int i = 1; i + 1 < sz(c); i += 2) {
                ans[e[{c[i], c[i + 1]}]] = '1';
            }
            c.clear(), cnt++;
        }
    }

    return ans;
}
/*
 6 12
 1 2
 1 5
 2 3
 2 5
 3 4
 3 6
 4 1
 4 5
 5 3
 5 6
 6 1
 6 4
 */