#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <cassert>
#include <fstream>
#include <queue>
#include <set>
#include <map>
#include <list>
#include <unordered_map>
#include <unordered_set>
#include <random>

using namespace std;
//mt19937 rnd(time(228));
#define ll long long
#define dl double
//#define int long long
#define pii pair<int, int>
#define sz(a) (int)a.size()
#define all(v) v.begin(), v.end()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1;
int n, m;
vector<vector<int>> g, r;
int used[maxn];
vector<int> ts, comp;

void dfs1(int v) {
    if (used[v])return;
    used[v] = 1;
    for (int u: g[v])dfs1(u);
    ts.push_back(v);
}

int cnt = 1;
vector<int> c;

void dfs(int v) {
    if (comp[v] != 0)return;
    c.push_back(v), comp[v] = cnt;
    for (int u: r[v])dfs(u);
}

map<pii, int> e;

string ans;

void pl(vector<set<int>> rh, vector<set<int>> gh) {
    vector<pii > s(n);
    for (int i = 0; i < n; ++i) {
        if (!gh[i].empty() || !rh[i].empty())
            s[i] = {sz(gh[i]) + sz(rh[i]), i};
    }
    sort(all(s)), reverse(all(s));
    queue<int> q;
    q.push(s[0].second);
    int k = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (k == 0) {
            set<int> gg;
            for (int u: gh[v]) {
                int j = e[{u, v}];
                if (ans[j] == '0') {
                    ans[j] = '1';
                    rh[v].insert(u);
                    gh[u].insert(v);
                    rh[u].erase(v);
                    q.push(u);
                } else gg.insert(u);
            }
            gh[v] = gg;
            k = 1;
        } else {
            set<int> rr;
            for (int u: rh[v]) {
                int j = e[{u, v}];
                if (ans[j] == '0') {
                    gh[v].insert(u);
                    gh[u].erase(v);
                    rh[u].insert(v);
                    q.push(u);
                } else rr.insert(u);
            }
            rh[v] = rr;
            k = 0;
        }
    }
}

string find_reverse(int N, int M, int connections[][2]) {
    for (int i = 0; i < M; ++i) ans += '0';
    n = N, m = M;
    g.resize(n), r.resize(n), comp.resize(n);
    map<pii, int> ee, re;
    for (int i = 0; i < M; ++i) {
        int u = connections[i][0];
        int v = connections[i][1];
        u--, v--;
        e[{u, v}] = i;
        e[{v, u}] = i;
        ee[{u, v}] = i;
        re[{v, u}] = i;
        g[u].push_back(v), r[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs1(i);
        }
    }
    vector<vector<int>> k;
    for (int v: ts) {
        if (comp[v] == 0) {
            dfs(v);
            k.push_back(c);
            c.clear(), cnt++;
        }
    }
    vector<vector<set<int>>> ggg(cnt, vector<set<int>>(n));
    vector<vector<set<int>>> rrr(cnt, vector<set<int>>(n));
    for (auto el: ee) {
        auto[u, v]=el.first;
        if(comp[u]==comp[v]) {
            ggg[comp[u] - 1][u].insert(v);
            rrr[comp[u] - 1][v].insert(u);
        }
    }
    for (int i = 0; i < cnt; ++i) {
        pl(ggg[i], rrr[i]);
    }
    return ans;
}

/*
 6 12
 1 2
 1 5
 2 3
 2 5
 3 4
 3 6
 4 1
 4 5
 5 3
 5 6
 6 1
 6 4
 */