#include <bits/stdc++.h>

using namespace std;

//mt19937 rnd(228);

#define ll long long
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const int infI = 1e9 + 7;
const ll infL = 1e18;
const int maxN = 500000;

bitset<maxN> b1, b2;

int prev1[maxN], prev2[maxN], a[maxN], b[maxN];


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n;
    b1[0] = true, b2[0] = true;
    prev1[0] = -1, prev2[0] = -1;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    cin >> m;
    for (int i = 0; i < m; ++i)
        cin >> b[i];
    for (int i = 0; i < n; ++i) {
        bitset<maxN> now = b1;
        b1 = b1 | (b1 << a[i]);
        now = b1 ^ (now & b1);
        int j = (int) now._Find_first();
        while (j != maxN) {
            prev1[j] = i;
            j = (int) now._Find_next(j);
        }
    }
    for (int i = 0; i < m; ++i) {
        bitset<maxN> now = b2;
        b2 = b2 | (b2 << b[i]);
        now = b2 ^ (now & b2);
        int j = (int) now._Find_first();
        while (j != maxN) {
            prev2[j] = i;
            j = (int) now._Find_next(j);
        }
    }
    b1[0] = b2[0] = false;
    bitset<maxN> ans = b1 & b2;
    assert(ans.any());
    int i = (int) ans._Find_first();
    vector<int> ans1;
    vector<int> ans2;
    int j = i;
    while (i != 0) {
        ans1.push_back(prev1[i]);
        i -= a[prev1[i]];
    }
    i = j;
    while (i != 0) {
        ans2.push_back(prev2[i]);
        i -= b[prev2[i]];
    }
    cout << sz(ans1) << '\n';
    for (int x : ans1)
        cout << x << " ";
    cout << '\n';
    cout << sz(ans2) << "\n";
    for (int x : ans2) {
        cout << x << " ";
    }
    return 0;
}