#define _CRT_SECURE_NO_WARNINGS

/*--------------Define--------------*/
#define MOD 1000000007
#define INF 1000000000
#define cn const
#define pb push_back
#define ppb pop_back
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))


/*--------------Include--------------*/
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <fstream>
#include <ostream>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <stack>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<long long, long long>;
using vl = vector<long long>;
using vpll = vector<pair<long long, long long>>;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
    return false;
}

#ifdef _DEBUG
#define find_reverse find_reverse_1
#endif // _DEBUG



vi a[500002];
map<pii, bool> m1;
map<pii, int> m2;
bool used[500002];
set<pii> res;

void dfs(int x)
{
    used[x] = true;

    for (int i = 0; i < a[x].sz; i++)
    {
        if (used[a[x][i]])
        {
            if (!m1[{x, a[x][i]}] && !m1[{a[x][i], x}])
            {
                res.insert({ a[x][i], x });
                m1[{a[x][i], x}] = true;
                m1[{x, a[x][i]}] = true;
            }
            continue;
        }

        res.insert({ x, a[x][i] });

        m1[{a[x][i], x}] = true;
        m1[{x, a[x][i]}] = true;

        dfs(a[x][i]);
    }
}


string find_reverse(int n, int m, int connections[][2])
{
    for (int i = 0; i < m; i++)
    {
        a[connections[i][0]].pb(connections[i][1]);
        a[connections[i][1]].pb(connections[i][0]);
        m1.insert({ {connections[i][0], connections[i][1]}, false });
        m2.insert({ {connections[i][0], connections[i][1] }, i + 1 });
    }

    dfs(1);

    string s;
    s.resize(m);

    for (const auto& i : res)
    {
        auto x = m2[i];
        if (0 < x && x < 1500010)
        {
            s[x - 1] = '0';
        }
        else
        {
            s[m2[{i.ss, i.ff}] - 1] = '1';
        }
    }

    return s;
}


string find_reverse_1(int n, int m, vpii connections)
{
    for (int i = 0; i < m; i++)
    {
        a[connections[i].ff].pb(connections[i].ss);
        a[connections[i].ss].pb(connections[i].ff);
        m1.insert({ {connections[i].ff, connections[i].ss}, false });
        m2.insert({ {connections[i].ff, connections[i].ss }, i + 1 });
    }

    dfs(1);

    string s;
    s.resize(m);

    for (const auto& i : res)
    {
        auto x = m2[i];
        if (0 < x && x < 1500010)
        {
            s[x - 1] = '0';
        }
        else
        {
            s[m2[{i.ss, i.ff}] - 1] = '1';
        }
    }

    return s;
}


#ifdef _DEBUG

int main()
{
#ifdef _DEBUG
    freopen("Input.txt", "r", stdin);
#endif // _DEBUG


    ios::sync_with_stdio(false);
    cin.tie(0);


    int t = 1;
    //cin >> t;

    while (t--)
    {
        int n, m;
        
        vpii connections;

        cin >> n >> m;

        connections.resize(m);

        for (int i = 0; i < m; i++)
        {
            cin >> connections[i].ff >> connections[i].ss;
        }

        cout << find_reverse(n, m, connections) << endl;
    }



#ifdef _DEBUG
    cin.get();
#endif // _DEBUG

    return 0;
}

#endif // _DEBUG