#define _CRT_SECURE_NO_WARNINGS

/*--------------Define--------------*/
#define MOD 1000000007
#define INF 1000000000
#define cn const
#define pb push_back
#define ppb pop_back
#define ff first
#define ss second
#define sz size()
#define all(x) x.begin(), x.end()
#define sortall(x) sort(all(x))


/*--------------Include--------------*/
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <fstream>
#include <ostream>
#include <deque>
#include <iomanip>
#include <map>
#include <set>
#include <stack>
#include <cstdlib>

#define endl '\n'


using namespace std;


using ll = long long;
using ull = unsigned long long;
using pll = pair<long long, long long>;
using vl = vector<long long>;
using vpll = vector<pair<long long, long long>>;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vs = vector<string>;
using vpii = vector<pii>;


template<typename T>
constexpr T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
    return false;
}


int Lower_bound(const vpll& a, ll x)
{
    int l = -1;
    int r = a.sz - 1;

    while (r - l > 1)
    {
        int mid = (l + r) / 2;

        if (a[mid].ff < x)
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
    }

    return r;
}

vpll a, a1, b1;
vpll b;

int n, m;

void gen1(const vi& v1, const int& sum1, vi v, ll sum)
{
    if (v.sz == m)
    {
        if (sum1 == sum)
        {
            vl res1, res2;
            for (int i = 0; i < v1.sz; i++)
            {
                if (v1[i] == 1)
                {
                    res1.pb(i);
                }
            }
            for (int i = 0; i < v.sz; i++)
            {
                if (v[i] == 1)
                {
                    res2.pb(i);
                }
            }

            cout << res1.sz << endl;
            for (int i = 0; i < res1.sz; i++)
            {
                cout << res1[i] << ' ';
            }
            cout << endl << res2.sz << endl;
            for (int i = 0; i < res2.sz; i++)
            {
                cout << res2[i] << ' ';
            }
            cout << endl;

            exit(0);
        }
        return;
    }

    for (int i = 0; i < 2; i++)
    {
        v.pb(i);
        if (i == 0)
        {
            gen1(v1, sum1, v, sum);
        }
        else
        {
            gen1(v1, sum1, v, sum + b1[v.sz - 1].ff);
        }
        v.ppb();
    }
}

void gen(vi v, ll sum)
{
    if (v.sz == n)
    {
        if (sum == 0)
        {
            return;
        }
        gen1(v, sum, vi(), 0);
        return;
    }

    for (int i = 0; i < 2; i++)
    {
        v.pb(i);
        if (i == 0)
        {
            gen(v, sum);
        }
        else
        {
            gen(v, sum + a1[v.sz - 1].ff);
        }
        
        v.ppb();
    }
}

ll pref1[1000002];
ll pref2[1000002];

void Pref1(const vpll& a)
{
    pref1[0] = 0;

    for (int i = 0; i < a.sz; i++)
    {
        pref1[i + 1] = pref1[i] + a[i].ff;
    }
}

void Pref2(const vpll& a)
{
    pref2[0] = 0;

    for (int i = 0; i < a.sz; i++)
    {
        pref2[i + 1] = pref2[i] + a[i].ff;
    }
}


void solve()
{
    cin >> n;

    a.resize(n);
    a1.resize(n);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i].ff;
        a[i].ss = i;

        a1[i] = a[i];
    }

    cin >> m;

    b.resize(m);
    b1.resize(m);

    for (int i = 0; i < m; i++)
    {
        cin >> b[i].ff;
        b[i].ss = i;

        b1[i] = b[i];
    }
    
    sortall(a);
    sortall(b);

    
    for (int i = 0; i < n; i++)
    {
        int l = -1;
        int r = m - 1;
        while (r - l > 1)
        {
            int mid = (l + r) / 2;
            if (b[mid] < a[i])
            {
                l = mid;
            }
            else
            {
                r = mid;
            }
        }
        if (b[r] == a[i])
        {
            cout << 1 << endl << i << endl << 1 << endl << r << endl;
            return;
        }
    }

    Pref1(a1);
    Pref2(b1);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << k << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << k << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a1));
    reverse(all(b1));

    Pref1(a1);
    Pref2(b1);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << n - k - 1 << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << m - k - 1 << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a1));

    Pref1(a1);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << k << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << m - k - 1 << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a1));
    reverse(all(b1));

    Pref1(a1);
    Pref2(b1);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << n - k - 1 << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << k << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a1));

    Pref1(a);
    Pref2(b);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << a[k].ss << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << b[k].ss << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a));

    Pref1(a);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << a[n - k - 1].ss << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << b[k].ss << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(b));
    
    Pref2(b);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << a[n - k - 1].ss << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << b[m - k - 1].ss << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(a));

    Pref1(a);

    for (int i = 1; i < n + 1; i++)
    {
        for (int j = 1; j < m + 1; j++)
        {
            if (pref1[i] == pref2[j])
            {
                cout << i << endl;
                for (int k = 0; k < i; k++)
                {
                    cout << a[k].ss << ' ';
                }
                cout << endl << j << endl;
                for (int k = 0; k < j; k++)
                {
                    cout << b[m - k - 1].ss << ' ';
                }
                cout << endl;
                return;
            }
        }
    }

    reverse(all(b));

    gen(vi(), 0);
}



int main()
{
#ifdef _DEBUG
    freopen("Input.txt", "r", stdin);
#endif // _DEBUG


    ios::sync_with_stdio(false);
    cin.tie(0);


    int t = 1;
    //cin >> t;

    while (t--)
    {
        solve();
    }



#ifdef _DEBUG
    cin.get();
#endif // _DEBUG

    return 0;
}