#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int maxn = 5e5+10;

string res;
struct edge {

    int to, ix;
    edge(){}
    edge(int _to, int _ix) {

        to = _to;
        ix = _ix;

    }

};

vector < edge > v[maxn], rev[maxn];
vector < int > scc[maxn], topsort;
int in_scc[maxn], cnt;
int bl[maxn];
int n, m;

void dfs_topsort(int x) {

    bl[x] = 1;
    for (auto [to, ix] : v[x]) {

        if (bl[to]) continue;
        dfs_topsort(to);

    }

    topsort.push_back(x);

}

void dfs_scc(int x) {

    bl[x] = 1;
    in_scc[x] = cnt;
    scc[in_scc[x]].push_back(x);
    for (auto [to, ix] : rev[x]) {

        if (bl[to]) continue;
        dfs_scc(to);

    }

}

void dfs_edges(int x, int currscc) {

    bl[x] = 1;
    // cout << "curr: " << x << ' ' << currscc << '\n';

    for (auto [to, ix] : v[x]) {

        // cout << x << " neighboor: " << to << ' ' << ix << ' ' << bl[to] << '\n'; 

        if (in_scc[to] != currscc || bl[to] == 2) continue;
        if (bl[to] == 1) {

            res[ix] = '1';
            continue;

        }

        dfs_edges(to, currscc);

    } 

    bl[x] = 2;

    // cout << "done: " << x << '\n';

}

string find_reverse(int N, int M, int connections[][2]) {

    n = N;
    m = M;
    for (int i = 0 ; i < m ; ++i) {

        v[connections[i][0]].push_back({connections[i][1], i});
        rev[connections[i][1]].push_back({connections[i][0], i});

    }

    for (int i = 1 ; i <= n ; ++i) {

        if (bl[i]) continue;
        dfs_topsort(i);

    }

    reverse(topsort.begin(), topsort.end());
    // cerr << "topsort:\n";
    // for (int i : topsort)
    //     cerr << i << ' ';
    // cerr << '\n';

    fill(bl+1, bl+1+n, 0);

    for (int i : topsort) {

        if (bl[i]) continue;
        ++cnt;
        dfs_scc(i);

    }

    // cerr << "scc:\n";
    // for (int i = 1 ; i <= cnt ; ++i) {

    //     cerr << i << ":";
    //     for (int j : scc[i])
    //         cerr << ' ' << j;
    //     cerr << '\n';

    // }

    fill(bl+1, bl+1+n, 0);
    res.resize(m, '0');

    for (int i = 1 ; i <= cnt ; ++i) 
        dfs_edges(scc[i][0], i);

    // cerr << "end graph:\n";
    // for (int i = 0 ; i < m ; ++i) {

    //     if (res[i] == '0') cout << connections[i][0] << ' ' << connections[i][1] << '\n';
    //     else cout << connections[i][1] << ' ' << connections[i][0] << '\n';

    // }

    return res;

}
