#include <iostream>
#include <unordered_set>
#include <unordered_map>
using namespace std;
const int maxn = 1e6+10;

unordered_set < long long > s;
unordered_map < long long, pair < int, int > > um;
int a[maxn], n;
int b[maxn], m;

void solve() {

    long long sum;
    for (int i = 1 ; i <= n ; ++i) {

        sum = 0;
        for (int j = i ; j <= n ; ++j) {

            sum += a[j];
            s.insert(sum);
            um[sum] = {i, j};

        }

    }
    
    for (int i = 1 ; i <= m ; ++i) {

        sum = 0;
        for (int j = i ; j <= m ; ++j) {

            sum += b[j];
            if (s.count(sum)) {

                int l = um[sum].first;
                int r = um[sum].second;
                cout << r-l+1 << '\n';
                for (int curr = l ; curr <= r ; ++curr)
                    cout << curr-1 << ' ';
                cout << '\n';
                cout << j-i+1 << '\n';
                for (int curr = i ; curr <= j ; ++curr)
                    cout << curr-1 << ' ';
                cout << '\n';
                return;

            }

        }

    } 

    exit(-1);

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

void read() {

    cin >> n;
    for (int i = 1 ; i <= n ; ++i) cin >> a[i];

    cin >> m;
    for (int i = 1 ; i <= m ; ++i) cin >> b[i];

}

int main () {

    fast_io();
    read();
    solve();

    return 0;

}