#include <iostream>
#include <unordered_map>
#include <algorithm>
using namespace std;
const int maxn = 1e6+10, maxlog = 10;

int a[maxn], n;
int b[maxn], m;
pair < int, int > sorteda[maxn];
pair < int, int > sortedb[maxn];
unordered_map < long long, int > prefixes;

void solve() {

    for (int i = 1 ; i <= n ; ++i)
        sorteda[i] = {a[i], i};

    for (int i = 1 ; i <= m ; ++i)
        sortedb[i] = {b[i], i};

    sort(sorteda+1, sorteda+1+n);
    sort(sortedb+1, sortedb+1+m);

    long long sum = 0;
    for (int j = 1 ; j <= n ; ++j) {

        sum += sorteda[j].first;
        prefixes[sum] = j;

    }
    
    for (int i = 1 ; i <= m ; ++i) {

        sum = 0;
        for (int j = i ; j <= min(i+maxlog-1, m) ; ++j) {

            sum += sortedb[j].first;
            if (prefixes.count(sum)) {


                int r = prefixes[sum];
                cout << r << '\n';
                for (int curr = 1 ; curr <= r ; ++curr)
                    cout << sorteda[curr].second-1 << ' ';
                cout << '\n';
                cout << j - i+1 << '\n';
                for (int curr = i ; curr <= j ; ++curr)
                    cout << sortedb[curr].second-1 << ' ';
                cout << '\n';
                return;

            }


        }

    } 

    exit(-1);

}

void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

}

void read() {

    cin >> n;
    for (int i = 1 ; i <= n ; ++i) cin >> a[i];

    cin >> m;
    for (int i = 1 ; i <= m ; ++i) cin >> b[i];

}

int main () {

    fast_io();
    read();
    solve();

    return 0;

}