#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXQ=150005;
const int INF=1e9;
struct org_point
{
    long long x,y;
    int numV,numL,numR;
};
struct point
{
    long long x,y;
    int num;
};
long long n,m;
int q;
org_point org_p[MAXQ];
point p[MAXQ];
multiset<int>sl;
multiset<int>sr;
//set<org_point>sv;
long double treeV[4*MAXQ];
int treeL[4*MAXQ];
int treeR[4*MAXQ];
void treeV_update(int node,int l,int r,int idx,long double val)
{
    if(r<idx||idx<l)return;
    if(idx<=l&&r<=idx)
    {
        treeV[node]+=val;
        return;
    }
    int mid=(l+r)/2;
    treeV_update(2*node,l,mid,idx,val);
    treeV_update(2*node+1,mid+1,r,idx,val);
    treeV[node]=treeV[2*node]+treeV[2*node+1];
}
long double treeV_query(int node,int l,int r,int b,int e)
{
    if(e<l||r<b)return 0;
    if(b<=l&&r<=e)
    {
        return treeV[node];
    }
    int mid=(l+r)/2;
    return treeV_query(2*node,l,mid,b,e)+treeV_query(2*node+1,mid+1,r,b,e);
}
void treeL_update(int node,int l,int r,int idx,int val)
{
    if(r<idx||idx<l)return;
    if(idx<=l&&r<=idx)
    {
        treeL[node]=val;
        return;
    }
    int mid=(l+r)/2;
    treeL_update(2*node,l,mid,idx,val);
    treeL_update(2*node+1,mid+1,r,idx,val);
    if(org_p[treeL[2*node]].numR>org_p[treeL[2*node+1]].numR)treeL[node]=treeL[2*node];
    else treeL[node]=treeL[2*node+1];
}
long long treeL_query(int node,int l,int r,int b,int e)
{
    if(e<l||r<b)return 0;
    if(b<=l&&r<=e)
    {
        return treeL[node];
    }
    int mid=(l+r)/2;
    int ql=treeL_query(2*node,l,mid,b,e);
    int qr=treeL_query(2*node+1,mid+1,r,b,e);
    if(org_p[ql].numR>org_p[qr].numR)return ql;
    else return qr;
}
void treeR_update(int node,int l,int r,int idx,int val)
{
    if(r<idx||idx<l)return;
    if(idx<=l&&r<=idx)
    {
        treeR[node]=val;
        return;
    }
    int mid=(l+r)/2;
    treeR_update(2*node,l,mid,idx,val);
    treeR_update(2*node+1,mid+1,r,idx,val);
    if(org_p[treeR[2*node]].numL<org_p[treeR[2*node+1]].numL)treeR[node]=treeR[2*node];
    else treeR[node]=treeR[2*node+1];
}
long long treeR_query(int node,int l,int r,int b,int e)
{
    if(e<l||r<b)return 0;
    if(b<=l&&r<=e)
    {
        return treeR[node];
    }
    int mid=(l+r)/2;
    int ql=treeR_query(2*node,l,mid,b,e);
    int qr=treeR_query(2*node+1,mid+1,r,b,e);
    if(org_p[ql].numL<org_p[qr].numL)return ql;
    else return qr;
}
//getl, getr
long long getl(point a)
{
    return a.x-(m-a.y);
}
long long getr(point a)
{
    return a.x+(m-a.y);
}
long long getl(org_point a)
{
    return a.x-(m-a.y);
}
long long getr(org_point a)
{
    return a.x+(m-a.y);
}
//sort cmp
bool cmpV(point a,point b)
{
    if(a.x==b.x)return a.y>b.y;
    return a.x<b.x;
}
bool cmpL(point a,point b)
{
    if(getl(a)==getl(b))return getr(a)<getr(b);
    return getl(a)<getl(b);
}
bool cmpR(point a,point b)
{
    if(getr(a)==getr(b))return getl(a)<getl(b);
    return getr(a)<getr(b);
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cout<<fixed<<setprecision(2);
cin>>n>>m;
cin>>q;
org_p[0].numL=INF;
org_p[0].numR=-INF;
for(int i=1;i<=q;i++)
{
    cin>>org_p[i].x>>org_p[i].y;
    //org_p[i].num=i;
    p[i].x=org_p[i].x;
    p[i].y=org_p[i].y;
    p[i].num=i;
}
sort(p+1,p+q+1,cmpV);//cout<<"V:";
//for(int i=1;i<=q;i++)cout<<p[i].num<<" ";
for(int i=1;i<=q;i++)
{
    org_p[p[i].num].numV=i;
}
//for(int i=1;i<=q;i++)cout<<org_p[i].numV<<" ";
//cout<<endl;
sort(p+1,p+q+1,cmpL);
for(int i=1;i<=q;i++)
{
    org_p[p[i].num].numL=i;
}
sort(p+1,p+q+1,cmpR);
for(int i=1;i<=q;i++)
{
    org_p[p[i].num].numR=i;
}
long double curr_area=n*m;
long double new_area;
new_area=(m-org_p[1].y)*(m-org_p[1].y);
if(getl(org_p[1])<0)new_area-=(long double)getl(org_p[1])*getl(org_p[1])/2;
if(getr(org_p[1])>n)new_area-=(long double)(getr(org_p[1])-n)*(getr(org_p[1])-n)/2;
curr_area-=new_area;
cout<<curr_area<<endl;
for(int i=2;i<=q;i++)
{
    //sv.insert(org_p[i-1]);
    treeV_update(1,1,q,org_p[i-1].numV,new_area);
    sl.insert(org_p[i-1].numL);
    treeL_update(1,1,q,org_p[i-1].numL,i-1);
    sr.insert(org_p[i-1].numR);
    treeR_update(1,1,q,org_p[i-1].numR,i-1);

    auto it1=sl.upper_bound(org_p[i].numL);
    int LeftP;
    if(it1==sl.begin()&&*it1>org_p[i].numL)LeftP=0;
    else {it1--;LeftP=*it1;}

    auto it2=sr.lower_bound(org_p[i].numR);
    int RightP;
    if(it2==sr.end())RightP=0;
    else RightP=*it2;

    int v1,v2;
    if(LeftP==0)v1=-1;
    else
    {
        v1=treeL_query(1,1,q,*sl.begin(),LeftP);
    }
    if(RightP==0)v2=-1;
    else
    {
        auto itt=sr.end(); itt--;
        v2=treeR_query(1,1,q,RightP,*itt);
    }
    long double tmp=curr_area;
    //cout<<RightP<<endl;
    //cout<<v1<<" "<<v2<<endl;
    if(v1>0&&v2>0)tmp+=treeV_query(1,1,q,org_p[v1].numV,org_p[v2].numV);
    else if(v1==-1&&v2==-1)tmp+=treeV_query(1,1,q,1,q);
    else if(v1==-1)tmp+=treeV_query(1,1,q,1,org_p[v2].numV);
    else if(v2==-1)tmp+=treeV_query(1,1,q,org_p[v1].numV,q);
    //cout<<"vq:"<<treeV_query(1,1,q,org_p[v1].numV,org_p[v2].numV)<<endl;
    tmp-=(m-org_p[i].y)*(m-org_p[i].y);
    if(getl(org_p[i])<0)tmp+=(long double)getl(org_p[i])*getl(org_p[i])/2;
    if(getr(org_p[i])>n)tmp+=(long double)(getr(org_p[i])-n)*(getr(org_p[i])-n)/2;

    if(LeftP!=0)
    {
        long double sTr=(m-org_p[v1].y)*(m-org_p[v1].y);
        if(getl(org_p[v1])<0)sTr-=(long double)getl(org_p[v1])*getl(org_p[v1])/2;
        if(getr(org_p[v1])>n)sTr-=(long double)(getr(org_p[v1])-n)*(getr(org_p[v1])-n)/2;
        long double comx=(long double)(getl(org_p[i])+getr(org_p[v1]))/2;
        long double comy=(long double)m-(getr(org_p[v1])-getl(org_p[i]))/2;
        long double sCom=(m-comy)*(m-comy);
        if(comx-(m-comy)<0)sCom-=(long double)(comx-(m-comy))*(comx-(m-comy))/2;
        if(comx+(m-comy)>n)sCom-=(long double)(comx-(m-comy)-n)*(comx-(m-comy)-n)/2;
        //cout<<sTr<<" "<<sCom<<endl;
        tmp-=sTr;
        tmp+=sCom;
    }
    if(RightP!=0)
    {
        long double sTr=(m-org_p[v2].y)*(m-org_p[v2].y);
        if(getl(org_p[v2])<0)sTr-=(long double)getl(org_p[v2])*getl(org_p[v2])/2;
        if(getr(org_p[v2])>n)sTr-=(long double)(getr(org_p[v2])-n)*(getr(org_p[v2])-n)/2;
        long double comx=(long double)(getr(org_p[i])+getl(org_p[v2]))/2;
        long double comy=(long double)m-(getr(org_p[i])-getl(org_p[v2]))/2;
        long double sCom=(m-comy)*(m-comy);
        if(comx-(m-comy)<0)sCom-=(long double)(comx-(m-comy))*(comx-(m-comy))/2;
        if(comx+(m-comy)>n)sCom-=(long double)(comx-(m-comy)-n)*(comx-(m-comy)-n)/2;
        //cout<<sTr<<" "<<sCom<<endl;
        tmp-=sTr;
        tmp+=sCom;
    }
    new_area=curr_area-tmp;
    curr_area=tmp;
    //cout<<new_area<<endl;
    cout<<fixed<<setprecision(2)<<curr_area<<endl;
}
return 0;
}
