#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5+5;

string changes;
vector <int> G[MAXN];

map <pair <int, int>, int> mp;

bool used[MAXN];
int start_v;

int m = 0;
int n = 0;

const int MAXM=1.5e6;
int edges[MAXM][2];

bool dfs(int v, int prev = -1, int p = -1)
{
    if (used[v]) return p == v;

    used[v] = 1;

    bool ret = 1;


    for (int i = 0; i < m; i++)
    {
        if (edges[i][0] != v) continue;
        if (edges[i][1] == prev) continue;

        ret &= dfs(edges[i][1], v, prev);
    }

    used[v] = 0;

    return ret;
}

bool check()
{
    for (int i = 0; i < m; i++)
        if (changes[i] == '1') swap(edges[i][0], edges[i][1]);
    for (int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        if (!dfs(i, -1, i))
        {
//            cerr << "Err at " << i << endl;
            for (int j = 0; j < m; j++)
                if (changes[j] == '1') swap(edges[j][0], edges[j][1]);

            return 0;
        }
    }
    for (int i = 0; i < m; i++)
        if (changes[i] == '1') swap(edges[i][0], edges[i][1]);
    return 1;
}

bool found_solution = false;

string answer;

void rec(int ind = 0)
{
    if (found_solution) return;
    if (ind == m)
    {
        found_solution = check();

        if (found_solution) answer = changes;

        return;
    }
    rec(ind + 1);
    changes[ind] = '1';
    rec(ind + 1);

    changes[ind] = '0';
}

string find_reverse (int N, int M, int connections[][2])
{
    m = M;
    n = N;
    changes = string(M, '0');

    for (int i = 0; i < M; i++)
    {
        edges[i][0] = connections[i][0];
        edges[i][1] = connections[i][1];
    }

    rec(0);

    return answer;
}
