#include <bits/stdc++.h>
using namespace std;

const int MAXN = 30;

string changes;
vector <int> G[MAXN];

bool used[MAXN];

int m = 0;
int n = 0;

const int MAXM=30;
int edges[MAXM][2];

bool stop = false;

bool dfs(int v, int prev = -1, int p = -1, int edge = 0)
{
    if (stop) return 0;
    if (used[v])
    {
        if (p == v) return 1;

        swap(edges[edge][0], edges[edge][1]);

        stop = true;
        return 0;
    }

    used[v] = 1;

    bool ret = 1;

    for (int i = 0; i < m; i++)
    {
        if (edges[i][0] != v) continue;
        if (edges[i][1] == prev) continue;

        ret &= dfs(edges[i][1], v, prev, i);
    }

    used[v] = 0;

    return ret;
}

bool check()
{
    for (int i = 1; i <= n; i++)
    {
        stop = false;
        memset(used, 0, sizeof(used));
        if (!dfs(i, -1, i))
        {
            return 0;
        }
    }


    return 1;
}

string find_reverse (int N, int M, int connections[][2])
{
    m = M;
    n = N;
    changes = string(M, '0');

    for (int i = 0; i < M; i++)
    {
        edges[i][0] = connections[i][0];
        edges[i][1] = connections[i][1];
    }

    while (!check());

    for (int i = 0; i < M; i++)
    {
        if (edges[i][0] != connections[i][0])
            changes[i] = '1';
    }

    return changes;
}
