#include<bits/stdc++.h>
using namespace std;

const int maxn=150003;

struct point{
	long long x, y;
};

long long n, m;
int q;
double areas[maxn];

point pt[maxn];
double area=0;

vector <point> d, d1;

double signed_area(point a, point b, point c){
	point v1, v2;
	v1.x=b.x-a.x;
	v2.x=c.x-a.x;

	v1.y=b.y-a.y;
	v2.y=c.y-a.y;

	return (v1.x*v1.y)-(v2.x*v1.y);
}

point intersect(point a, point b, point c, point d){
	
	//za 1vata prava
	double a1=b.y-a.y, b1=a.x-b.x;
	double c1=a1*(a.x)+b1*(a.y);

	//za 2rata prava
	double a2=d.y-c.y, b2=c.x-d.x;
        double c2=a2*(c.x)+b2*(c.y);

	double det= (a1*b2) - (a2*b1);

	point ans;
	if(det==0){
		ans.x=-99;
		ans.y=-99;
	}else{
		ans.x=( (c1*b2) - (c2*b1) )/det;
		ans.y=( (c2*a1) - (c1*a2) )/det;
	}

	return ans;
}

vector <point> add(point curr, vector <point> t){
	bool ima=false;

	vector<point> ans;
	for(int i=0; i<t.size(); i++){
		ans.push_back(t[i]);
	}

        for(int j=0; j<ans.size(); j++){
                if(curr.x==ans[j].x and curr.y==ans[j].y){
                        ima=true;
			cerr<<"tochkata q ima "<<endl;
                        break;
                }
        }
	if(!ima and curr.x>=0 and curr.y>=0 and curr.x<=n and curr.y<=m){
		//cerr<<"tochka "<<curr.x<<" "<<curr.y<<" q nqma"<<endl;
		ans.push_back(curr);	
	}
	return ans;
}

int main (){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;
area=n*m;

cin>>q;

for(int i=0; i<q; i++){
	cin>>pt[i].x>>pt[i].y;
	
	//curr area
	point a, b, curr;
	a.x=pt[i].x;
	a.y=pt[i].y;
	b.x=pt[i].x-1;
	b.y=pt[i].y+1;
	//cerr<<"a: "<<a.x<<" "<<a.y<<" b:"<<b.x<<" "<<b.y<<endl;

	d.clear();
	d.push_back(pt[i]);

	curr=intersect(a, b, {0, 0}, {0, 1});
	//cerr<<"s lqvata strana: "<<curr.x<<" "<<curr.y<<endl;
	d=add(curr, d);

	if(curr.y<m and curr.x==0){
		d.push_back({0, m});
	}
	curr=intersect(a, b, {0, m}, {1, m});
	//cerr<<"s gornata strana: "<<curr.x<<" "<<curr.y<<endl;
	d=add(curr, d);

	b.x+=2;

	//cerr<<"b: "<<b.x<<" "<<b.y<<endl;
	curr=intersect(a, b, {n, 1}, {n, 0});
	//cerr<<"s dqsnata strana: "<<curr.x<<" "<<curr.y<<endl;
	d=add(curr, d);
	if(curr.y<m and curr.x==n){
		d.push_back({n, m});
	}
	curr=intersect(a, b, {0, m}, {n, m});
	//cerr<<"s gornata strana: "<<curr.x<<" "<<curr.y<<endl;
	d=add(curr, d);
	
	//cerr<<"POINTS: "<<endl;
	double curr_area=0;
	for(int j=1; j<d.size()-1; j++){
		double to=signed_area(d[0], d[j], d[j+1]);
		if(to<0){
			to*=-1;
		}
		curr_area+=to;
	}
	curr_area/=2.0;
	areas[i]=curr_area;
	//cerr<<"curr_area: "<<curr_area<<endl;
	
	for(int j=0; j<i; j++){
	
		//vutre(po strana)/otvun
			point p=pt[j];
		
			double ar=0;
			for(int j=0; j<d.size()-1; j++){
                	double to=signed_area(p, d[j], d[j+1]);
                	if(to<0){
                        	to*=-1;
                	}
                	ar+=to;
        		}
			ar/=2.0;
			if(ar==curr_area){
			curr_area-=areas[j];
			}else{
				if(pt[i].x>p.x){
					point mejdu=intersect({pt[i].x-1, pt[i].y+1}, pt[i], {p.x+1, p.y+1}, p);
					point g, h, k;
        				g.x=p.x;
        				g.y=p.y;
        				h.x=p.x-1;
        				h.y=p.y+1;
        //cerr<<"a: "<<a.x<<" "<<a.y<<" b:"<<b.x<<" "<<b.y<<endl;

        				d1.clear();
        				d1.push_back(mejdu);

        				k=intersect(g, h, {0, 0}, {0, 1});
        //cerr<<"s lqvata strana: "<<curr.x<<" "<<curr.y<<endl;
       					 d1=add(k, d1);

        				if(k.y<m and k.x==0){
                				d1.push_back({0, m});
        				}
       					k=intersect(h, g, {0, m}, {1, m});
        //cerr<<"s gornata strana: "<<curr.x<<" "<<curr.y<<endl;
        				d1=add(k, d1);

        				h.x+=2;

        //cerr<<"b: "<<b.x<<" "<<b.y<<endl;
        				k=intersect(h, g, {n, 1}, {n, 0});
        //cerr<<"s dqsnata strana: "<<curr.x<<" "<<curr.y<<endl;
        				d1=add(k, d1);
        				if(k.y<m and k.x==n){
                			d1.push_back({n, m});
        				}
        				k=intersect(g, h, {0, m}, {n, m});
        //cerr<<"s gornata strana: "<<curr.x<<" "<<curr.y<<endl;
        				d1=add(k, d1);

        //cerr<<"POINTS: "<<endl;
        				double to_sub=0;
        				for(int j=1; j<d.size()-1; j++){
                				double ti=signed_area(d[0], d[j], d[j+1]);
                				if(ti<0){
                        				ti*=-1;
                				}
                				to_sub+=ti;

					}
						to_sub/=2.0;
						curr_area-=to_sub;
				}
			}
		
		//ako e vutre, dobavi mu cqloto lice
		//ako ne e vutre, napravi si nov mnogougulnik, nameri mu liceto i go dobavi
		
	}
	area-=curr_area;
	cout<<setprecision(1000)<<area<<endl;
}

return 0;
}