#include<iostream>

using namespace std;

int sheet[10000][10000];

///0 - full;
///1 - empty;
///2 - top left empty; /
///3 - top right empty; \
///4 - top left and right empty; x

double s = 0;

void cut(int n,int m,int x, int y, bool whole)
{
    if(y >= m)
    {
        return;
    }

    int i = x;

    for(int j = y + 1; j < m; j++)
    {
        if(i < 0)
        {
            break;
        }

        if(whole == true)
        {
            if(sheet[i][j] == 0)
            {
                s -= 1;
            }
            else if(sheet[i][j] == 2 || sheet[i][j] == 3)
            {
                s -= 0.5;
            }
            else if(sheet[i][j] == 4)
            {
                s -= 0.25;
            }

            sheet[i][j] = 1;
        }
        else
        {
            if(sheet[i][j] == 1)
            {
                continue;
            }

            if(sheet[i][j] == 0)
            {
                //cout<<"cutting top right "<<i<<" "<<j<<endl;
                sheet[i][j] = 3;

                s -= 0.5;
            }
            else if(sheet[i][j] == 2)
            {
                //cout<<"cutting X "<<i<<" "<<j<<endl;
                sheet[i][j] = 4;

                s -= 0.25;
            }
        }

        i--;
    }

    i = x + 1;

    for(int j = y + 1; j < m; j++)
    {

        if(i >= n)
        {
            break;
        }

        if(whole == true)
        {
            if(sheet[i][j] == 0)
            {
                s -= 1;
            }
            else if(sheet[i][j] == 2 || sheet[i][j] == 3)
            {
                s -= 0.5;
            }
            else if(sheet[i][j] == 4)
            {
                s -= 0.25;
            }

            sheet[i][j] = 1;
        }
        else
        {

            if(sheet[i][j] == 1)
            {
                continue;
            }

            if(sheet[i][j] == 0)
            {
                //cout<<"cutting top left "<<i<<" "<<j<<endl;
                sheet[i][j] = 2;

                s -= 0.5;
            }
            if(sheet[i][j] == 3)
            {
                //cout<<"cutting X "<<i<<" "<<j<<endl;
                sheet[i][j] = 4;

                s -= 0.25;
            }
        }

        i++;
    }

    cut(n, m, x, y + 1, true);
}

int main()
{
    int n,m;

    cin>>n>>m;

    s = n * m;

    int q;

    cin>>q;

    double results[q];

    for(int i = 0;i < q;i++)
    {
        int x, y;

        cin>>x>>y;

        cut(n, m, x - 1, y - 1, false);

        results[i] = s;

        /*
        for(int i1 = 0;i1 < n;i1++)
        {
            for(int i2 = 0;i2 < m;i2++)
            {
                if(sheet[i1][i2] == 0)
                {
                    cout<<"O";
                }
                if(sheet[i1][i2] == 1)
                {
                    cout<<" ";
                }
                if(sheet[i1][i2] == 2)
                {
                    cout<<"\\";
                }
                if(sheet[i1][i2] == 3)
                {
                    cout<<"/";
                }
                if(sheet[i1][i2] == 4)
                {
                    cout<<"X";
                }
            }
            cout<<endl;
        }
        */
    }

    for(int i = 0;i < q;i++)
    {
        int res = results[i] * 100;

        cout<<res / 100<<".";

        if(res % 100 < 10)
        {
            cout<<0;
        }

        cout<<res % 100<<endl;
    }

    return 0;
}
