#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int n, m;
int k;
vector <pair<double, double>> points;

bool compare(pair<double, double> a, pair<double, double> b)
{
    if(a.first<b.first)
    {
        return true;
    }
    else
    {
        return false;
    }
}

double area(double ax, double ay, double bx, double by, double cx, double cy)
{
    double s=(cx+bx)*(cy-by)+(bx+ax)*(by-ay)+(ax+cx)*(ay-cy);
    s=abs(s);
    s=s/2;
    return s;
}
bool check(double ax, double ay, double bx, double by, double cx, double cy, double px, double py)
{
    //cout << ax << " " << ay << " " << bx << " " << by << " " << cx << " " << cy << " " << px << " " << py << endl;
    double surface1=area(ax, ay, bx, by, cx, cy);
    double surface2=area(ax, ay, bx, by, px, py)+area(ax, ay, px, py, cx, cy)+area(px, py, bx, by, cx, cy);
    if(surface1==surface2)
    {
        return true;
    }
    return false;
}
void remove_p(pair<double, double> point)
{
    //cout << "#############" << point.first << " " << point.second << endl;
    double r1=point.first-((double)m-point.second);
    double r2=(double)n-point.first;
    double add, substract;
    if(r1<0)
    {
        add=point.second-r1;
    }
    else
    {
        add=0;
    }
    if(r2<m-point.second)
    {
        substract=(m-point.second)-r2;
    }
    else
    {
        substract=0;
    }
    int i=0;
    bool ch1, ch2;
    double x1=point.first+add-(m-point.second);
    double x2=point.first-substract+(m-point.second);
    //cout << x1 << " " << x2 << endl;
    while(i!=points.size())
    {
        ch1=check(x1, m, point.first+add, point.second, point.first+add, m, points[i].first+add, points[i].second);
      //  cout << ch1;
        ch2=check(point.first-substract, m, point.first-substract, point.second, x2, m, points[i].first-substract, points[i].second);
        //cout << ch2 << endl;
        if(ch1 || ch2)
        {
          //  cout << "*";
            points.erase(points.begin()+i);
        }
        else
        {
            i++;
        }
    }
}
void new_point(pair<double, double> point)
{
    remove_p(point);
    points.push_back(point);
    double face=0;
    double minx=n;
    double maxx=0;
    double miny=m;
    double right, left;
    for(int i=0; i<points.size(); i++)
    {
        right=points[i].first+m-points[i].second;
        left=points[i].first-m+points[i].second;
        if(maxx<right)
        {
            if(n<right)
            {
                maxx=n;
            }
            else
            {
                maxx=right;
            }
        }
        if(minx>left)
        {
            if(0>left)
            {
                minx=0;
            }
            else
            {
                minx=left;
            }
        }
    }
    face=m*n-((maxx-minx)*m);
    sort(points.begin(), points.end(), compare);
    double s1=(points[0].first-minx)*(points[0].first-minx)/2+(points[0].first-minx)*points[0].second;
    double s2=(maxx-points[points.size()-1].first)*(maxx-points[points.size()-1].first)/2.0+(maxx-points[points.size()-1].first)*points[points.size()-1].second;
    for(int i=1; i<points.size()-1; i++)
    {
        if(points[i].second==points[i+1].second)
        {
            face+=((points[i].first+points[i].second)-(points[i+1].first+points[i+1].second))/4.0;
        }
        else if(points[i].second<points[i+1].second)
        {
            face+=((points[i].first+points[i].second)-(points[i+1].first+points[i+1].second))/4.0;
            int difference=points[i+1].second-points[i].second;
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first-difference, points[i+1].second);
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first, points[i+1].second);
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first, 0);
        }
        else if(points[i].second>points[i+1].second)
        {
            face+=((points[i].first+points[i].second)-(points[i+1].first+points[i+1].second))/4.0;
            int difference=points[i].second-points[i+1].second;
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first-difference, points[i+1].second);
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first, points[i+1].second);
            face+=area(points[i].first, 0, points[i]. first, points[i].second, points[i+1].first, 0);
        }
    }
    face+=s1;
    face+=s2;
    cout << face;

}


int main()
{
    cin >> n >> m;
    cin >> k;
    pair<double, double> input;
    for(int i=0; i<k; i++)
    {
        cin >> input.first >> input.second;

        new_point(input);
    }



    return 0;
}
